// @ts-check
// Protractor configuration file, see link for more information
// https://github.com/angular/protractor/blob/master/lib/config.ts
// npm run e2e -- --baseUrl=http://localhost:5000 --devServerTarget

const { SpecReporter, StacktraceOption } = require('jasmine-spec-reporter');
const { platform } = require('os');
const chromedriver = require('chromedriver');

/**
 * @type { import("protractor").Config }
 */
exports.config = {
  allScriptsTimeout: 30000,
  specs: [
    './src/login/*.e2e-spec.ts',
    './src/domestic-sales/batch-sale-*.e2e-spec.ts'
    // './src/**/*.e2e-spec.ts'
  //'./src/domestic-sales/online-sale-01-Normal.e2e-spec.ts', //online - Normal
  //  './src/domestic-sales/online-sale-02-BO.e2e-spec.ts', //online - BO
  //  './src/domestic-sales/online-sale-03-LockSales.e2e-spec.ts', //online - LockSale
  //  './src/domestic-sales/batch-sale-01-normal.e2e-spec.ts', //batch
  //  './src/domestic-sales/newbackorder-sale.e2e-spec.ts', //New Back Order
  //  './src/domestic-sales/Allocate-sale.e2e-spec.ts',// Allocate
  //  './src/domestic-sales/cancelnew-sale.e2e-spec.ts',// Cancel New
  //  './src/domestic-sales/cancelback-sale.e2e-spec.ts',// Cancel Back
  //  './src/domestic-sales/printinvoice-sale.e2e-spec.ts', // print invoice
  //  './src/domestic-sales/reprint-sale.e2e-spec.ts' // reprint
 // './src/warehouse/pre-received-WH.e2e-spec.ts', // WH - Prerecive Invoive
  //'./src/warehouse/received-WH.e2e-spec.ts' // WH - Recive Invoice
  ],
  // chromeDriver: '/usr/local/bin/chromedriver',
  chromeDriver: chromedriver.path,
  capabilities: {
    // browserName: 'firefox',
    // 'moz:firefoxOptions': {
    //   'args': ['--safe-mode']
    // }
  
    browserName: 'chrome',
    // chromeOptions: {
      // binary: process.env.CHROME_BIN,
      // args: ['--headless', '--no-sandbox']
    // }
  },
  directConnect: true,
  // seleniumAddress: 'http://localhost:4444/wd/hub',
  baseUrl: 'http://localhost:4200/',
  framework: 'jasmine',
  jasmineNodeOpts: {
    showColors: true,
    defaultTimeoutInterval: 30000,
    print: function() {}
  },
  onPrepare() {
    require('ts-node').register({
      project: require('path').join(__dirname, './tsconfig.json')
    });
    jasmine.getEnv().addReporter(new SpecReporter({
      spec: {
        displayStacktrace: StacktraceOption.PRETTY
      }
    }));
  }
};
