import {
  browser,
  by,
  element,
  ElementArrayFinder,
  ElementFinder,
  Key,
  logging,
  protractor,
} from "protractor";
import { GlobalFunctions } from "../global-functions";
import { SNSE005_NPage, SNSE215Page, SNSE212Page, SNSE015_NPage, SNSQ022Page, SNSE026_MPage, SNSE025_NPage, SNSE031Page, SNSE032_MPage, SNSE034Page,SNSE033NPage} from "./export-order.po";

describe(`Sale Export Process`, () => {

  let CustomerCode: ElementFinder,
    CustomerName: ElementFinder,
    BranchCode: ElementFinder,
    BranchName: ElementFinder,
    OrderNo: ElementFinder,
    OrderDate: ElementFinder,
    OrderClass: ElementFinder,
    NewOrderButton: ElementFinder,
    NewCustomerCode: ElementFinder,
    NewCustomerName: ElementFinder,
    NewBranchCode: ElementFinder,
    NewBranchName: ElementFinder,
    NewOrderNo: ElementFinder,
    NewOrderDate: ElementFinder,
    NewOrderClass: ElementFinder,
    NewBoFlag: ElementFinder,
    NewDeliveryCode: ElementFinder,
    NewSaveBtn: ElementFinder,
    AddPartBtn: ElementFinder,
    CreateBtn: ElementFinder,
    SearchBtn: ElementFinder,
    AllocateBtn: ElementFinder,
    PartNo: ElementFinder,
    UnlockBtn: ElementFinder,
    ProcessBtn: ElementFinder,
    ConfirmExportPriceBtn: ElementFinder,
    AutoPrintCheckbox: ElementFinder,
    NewSentBy: ElementFinder,
    NewCaseBtn: ElementFinder,
    NewCaseNo: ElementFinder,
    NewSubCaseNo: ElementFinder,
    NewPackBy: ElementFinder,
    NewPackTime: ElementFinder,
    SaveBtn: ElementFinder,
    ConfirmPreBtn: ElementFinder,

    AirCustomerCode: ElementFinder,
    AirCustomerName : ElementFinder,
    AirPreInvoiceNo : ElementFinder,
    AirPreInvoiceDate : ElementFinder,
    AirAttachCheckBox : ElementFinder,
    AirFlightNo : ElementFinder,
    AirAwbNo : ElementFinder,
    AirAwbDate: ElementFinder,
    AirFreight: ElementFinder,
    AirInsurrance: ElementFinder,
    AirConfirmBtn: ElementFinder,
    SeaCustomerCode: ElementFinder,
    SeaCustomerName: ElementFinder,
    SeaPreInvoiceNo: ElementFinder,
    SeaPreInvoiceDate: ElementFinder,
    SeaAttachCheckBox: ElementFinder,
    SeaVessel: ElementFinder,
    SeaBLNo: ElementFinder,
    SeaBLDate: ElementFinder,
    SeaFreight: ElementFinder,
    SeaInsurrance: ElementFinder,
    SeaConfirmBtn: ElementFinder;

  let caseNo: string,
    sentBy: string,
    preInvoice: string,
    invoice: string;

  let setElements = (page: SNSE005_NPage) => {
    CustomerCode = page.getCustomerCodeElement();
    CustomerName = page.getCustomerNameElement();
    BranchCode = page.getBranchCodeElement();
    BranchName = page.getBranchNameElement();
    OrderNo = page.getOrderNumberElement();
    OrderDate = page.getOrderDateElement();
    OrderClass = page.getOrderClassElement();
    NewOrderButton = page.getNewOrderButtonElement();

    NewCustomerCode = page.getNewCustomerCodeElement();
    NewCustomerName = page.getNewCustomerNameElement();
    NewBranchCode = page.getNewBranchCodeElement();
    NewBranchName = page.getNewBranchNameElement();
    NewOrderNo = page.getNewOrderNumberElement();
    NewOrderDate = page.getNewOrderDateElement();
    NewOrderClass = page.getNewOrderClassElement();
    NewBoFlag = page.getNewBoFlagElement();
    NewDeliveryCode = page.getNewDeliveryCodeElement();
    NewSaveBtn = page.getNewSaveBtnElement();
    AddPartBtn = page.getAddPartBtnElement();
  };

  let setElements_SNSE215 = (page: SNSE215Page) => {
    CustomerCode = page.getCustomerCodeElement();
    CustomerName = page.getCustomerNameElement();
    OrderNo = page.getOrderNumberElement();
    SearchBtn = page.getSearchButtonElement();
    CreateBtn = page.getCreateButtonElement();

    NewCustomerCode = page.getNewCustomerCodeElement();
    NewCustomerName = page.getNewCustomerNameElement();

    NewOrderNo = page.getNewOrderNumberElement();
    NewSaveBtn = page.getNewSaveBtnElement();
  };

  let setElements_SNSE212 = (page: SNSE212Page) => {
    CustomerCode = page.getCustomerCodeElement();
    CustomerName = page.getCustomerNameElement();
    OrderNo = page.getOrderNumberElement();
    UnlockBtn = page.getUnlockBtnElement();
  };

  let setElements_SNSE015_N = (page: SNSE015_NPage) => {
    CustomerCode = page.getCustomerCodeElement();
    CustomerName = page.getCustomerNameElement();
    OrderNo = page.getOrderNumberElement();
    AllocateBtn = page.getAllocateBtnElement();
  };

  let setElements_SNSQ022 = (page: SNSQ022Page) => {
    CustomerCode = page.getCustomerCodeElement();
    CustomerName = page.getCustomerNameElement();
    OrderNo = page.getOrderNumberElement();
    PartNo = page.getPartNoElement();
    OrderClass = page.getOrderClassElement();
    SearchBtn = page.getSearchBtnElement();
    ConfirmExportPriceBtn = page.getConfirmNewExportPriceElement();
  };

  let setElements_SNSE026_M = (page: SNSE026_MPage) => {
    CustomerCode = page.getCustomerCodeElement();
    CustomerName = page.getCustomerNameElement();
    OrderNo = page.getOrderNumberElement();
    PartNo = page.getPartNoElement();
    OrderClass = page.getOrderClassElement();
    SearchBtn = page.getSearchBtnElement();
    ProcessBtn = page.getProcessButtonElement();
    AutoPrintCheckbox = page.getAutoPrintCheckboxElement();
  };

  let setElements_SNSE025_N = (page: SNSE025_NPage) => {
    NewCustomerCode = page.getNewCustomerCodeElement();
    NewCustomerName = page.getNewCustomerNameElement();
    NewBranchCode = page.getNewBranchCodeElement();
    NewBranchName = page.getNewBranchNameElement();
    NewSentBy = page.getNewSentByElement();
    NewCaseNo = page.getNewCaseNoElement();
    NewSubCaseNo = page.getNewSubCaseNoElement();
    NewPackBy = page.getNewPackByElement();
    NewPackTime = page.getNewPackTimeElement();

    NewCaseBtn = page.getNewCaseBtnElement();
    NewSaveBtn = page.getNewSaveBtnElement();
  };

  let setElements_SNSE031 = (page: SNSE031Page) => {
    CustomerCode = page.getCustomerCodeElement();
    CustomerName = page.getCustomerNameElement();
    BranchCode = page.getBranchCodeElement();
    BranchName = page.getBranchNameElement();
    SaveBtn = page.getSaveBtnElement();
  };

  let setElements_SNSE032_M = (page: SNSE032_MPage) => {
    CustomerCode = page.getCustomerCodeElement();
    CustomerName = page.getCustomerNameElement();
    BranchCode = page.getBranchCodeElement();
    BranchName = page.getBranchNameElement();
    AutoPrintCheckbox = page.getAttachCheckBoxElement();
    ConfirmPreBtn = page.getConfirmPreBtnElement();
  };

  let setElements_SNSE034 = (page: SNSE034Page) => {
    CustomerCode = page.getCustomerCodeElement();
    CustomerName = page.getCustomerNameElement();
    BranchCode = page.getBranchCodeElement();
    BranchName = page.getBranchNameElement();
    SaveBtn = page.getSaveBtnElement();
  };

  let setElements_SNSE033N = (page: SNSE033NPage) => {
    //AIR
    AirCustomerCode = page.getAirCustomerCodeElement();
    AirCustomerName = page.getAirCustomerNameElement();
    AirPreInvoiceNo = page.getAirPreInvoiceNoElement();
    AirPreInvoiceDate = page.getAirPreInvoiceDateElement();
    AirAttachCheckBox = page.getAirAttachCheckBoxElement();
    AirFlightNo = page.getAirFlightNoElement();
    AirAwbNo = page.getAirAwbNoElement();
    AirAwbDate = page.getAirAwbDateElement();
    AirFreight = page.getAirFreightElement();
    AirInsurrance = page.getAirInsurranceElement();
    AirConfirmBtn = page.getAirConfirmBtnElement();

    //SEA
    SeaCustomerCode = page.getSeaCustomerCodeElement();
    SeaCustomerName = page.getSeaCustomerNameElement();
    SeaPreInvoiceNo = page.getSeaPreInvoiceNoElement();
    SeaPreInvoiceDate = page.getSeaPreInvoiceDateElement();
    SeaAttachCheckBox = page.getSeaAttachCheckBoxElement();
    SeaVessel = page.getSeaVesselElement();
    SeaBLNo = page.getSeaBLNoElement();
    SeaBLDate = page.getSeaBLDateElement();
    SeaFreight = page.getSeaFreightElement();
    SeaInsurrance = page.getSeaInsurranceElement();
    SeaConfirmBtn = page.getSeaConfirmBtnElement();
  };

  describe(`SNSE215 - Hold New Order`, () => {
    let fn = new GlobalFunctions();
    let page: SNSE215Page = new SNSE215Page();
    let timeFormat = Math.floor(new Date().getTime() / 10000).toString();

    let customerCode;
    let orderNo;
    let partList: Array<any>;

    beforeAll(() => {
      page.navigateTo();

      setElements_SNSE215(page);

      customerCode = "1INN1";
      orderNo = 'ATORDER02'
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to click new order button`, async () => {
      CreateBtn.click();
    });

    it(`Should able to key customer`, async () => {
      NewCustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();

      var autoCompleteText = await page.getDynamicElementText(
        ".cdk-overlay-container auto-complete-query-dialog span.mat-form-field-label-wrapper>label>span"
      );

      if (autoCompleteText == "Select Customer Code") {
        page.selectDownKey();
        page.selectDownKey();
        page.selectDownKey();
        page.selectEnterKey();
        page.selectEnterKey();
      }

      browser.waitForAngular();
      expect(NewCustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key order no`, () => {
      NewOrderNo.sendKeys(orderNo);
      expect(NewOrderNo.getAttribute("value")).toBeTruthy();
    });

    it(`Save button able to click`, () => {
      expect(NewSaveBtn.getAttribute('disabled')).not.toEqual("true");
      NewSaveBtn.click();
    });

    it(`Confirm modal appeared and confirmable`, () => {
      var confirmModal: ElementFinder = page.getMessageModalElement(".modal-confirm");
      var confirmButton: ElementFinder = confirmModal.element(by.css(".mat-dialog-actions button[name=Confirm]"));

      expect(confirmModal.element(by.css(".mat-dialog-title")).getText()).toMatch(/CONFIRMATION/);
      expect(confirmModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Do you want to save changed you have made\?/);

      confirmButton.click();
      browser.waitForAngular();
    });

    it(`Save completed`, () => {
      var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
      expect(infoModal.element(by.css(".mat-dialog-content")).getText()).toEqual('Transaction complete: applied and saved.');
      page.selectEnterKey();
    })
  });

  describe(`SNSE005_N - Receive Order Export (Non-Dragon Format)`, () => {
    let fn = new GlobalFunctions();
    let page: SNSE005_NPage = new SNSE005_NPage();

    let customerCode;
    let orderNo;
    let partList: Array<any>;

    beforeAll(() => {
      page.navigateTo();

      setElements(page);

      customerCode = "1INN1";
      orderNo = 'ATORDER02'
      partList = [
        {
          PART_NO: "111101HC1A",
          ORDER_QTY: 2,
        }
      ];
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to click new order button`, async () => {
      NewOrderButton.click();
    });

    it(`Should able to key customer`, async () => {
      NewCustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();

      var autoCompleteText = await page.getDynamicElementText(
        ".cdk-overlay-container auto-complete-query-dialog span.mat-form-field-label-wrapper>label>span"
      );

      if (autoCompleteText == "Select Customer") {
        page.selectDownKey();
        page.selectDownKey();
        page.selectDownKey();
        page.selectEnterKey();
        page.selectEnterKey();
      }

      browser.waitForAngular();
      expect(NewCustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Branch should not be null`, () => {
      expect(NewBranchCode.getAttribute("value")).toBeTruthy();
      expect(NewBranchName.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key order no`, () => {
      NewOrderNo.sendKeys(orderNo);
      expect(NewOrderNo.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key order class`, () => {
      NewOrderClass.click();
      page.selectEnterKey();

      expect(NewOrderNo.getAttribute("value")).toBeTruthy();
    });

    it(`Order date should not be null`, () => {
      expect(NewOrderDate.getAttribute("value")).toBeTruthy();
    });

    it(`B/O flag should not be null`, () => {
      expect(NewBoFlag.getText()).toBeTruthy();
    });

    it(`Delivery code should not be null`, () => {
      expect(NewDeliveryCode.getText()).toBeTruthy();
    });

    it(`Part no should able to enter`, () => {
      var rows: ElementArrayFinder = page.getNewDetailRowsElement();
      rows.each(async (elem, idx) => {
        var partItem: ElementFinder = await elem.element(
          by.css("td.mat-column-PART_NO input[name=DATA_PART_NO]")
        );
        var orderQtyItem: ElementFinder = await elem.element(
          by.css("td.mat-column-ORDER_QTY input[name=DATA_ORDER_QTY]")
        );

        if (idx < partList.length) {
          AddPartBtn.click();
          await partItem.sendKeys(partList[idx].PART_NO);
          page.selectEnterKey();
          await browser.waitForAngular();

          expect(orderQtyItem.getAttribute("disabled")).not.toEqual("true");
        }
      })
        .catch((err) => {
          console.log(err);
        });
    });

    it(`Order Qty should able to enter`, () => {
      var rows: ElementArrayFinder = page.getNewDetailRowsElement();

      partList.forEach(async (part, idx) => {
        var elem: ElementFinder = rows.get(idx);
        var OrderQtyItem: ElementFinder = await elem.element(
          by.css("td.mat-column-ORDER_QTY input[name=DATA_ORDER_QTY]")
        );

        expect(OrderQtyItem.getAttribute("disabled")).not.toEqual("true");
        await OrderQtyItem.sendKeys(part.ORDER_QTY);
        page.selectEnterKey();
      });
    });

    it(`Save button able to click`, () => {
      expect(NewSaveBtn.getAttribute('disabled')).not.toEqual("true");
      NewSaveBtn.click();
    });

    it(`Confirm modal appeared and confirmable`, () => {
      var confirmModal: ElementFinder = page.getMessageModalElement(".modal-confirm");
      var confirmButton: ElementFinder = confirmModal.element(by.css(".mat-dialog-actions button[name=Confirm]"));

      expect(confirmModal.element(by.css(".mat-dialog-title")).getText()).toMatch(/CONFIRMATION/);
      expect(confirmModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Do you want to add new order\?/);

      confirmButton.click();
      browser.waitForAngular();
    });

    it(`Save completed`, () => {
      var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
      expect(infoModal.element(by.css(".mat-dialog-content")).getText()).toEqual('Save data successfully.');
      page.selectEnterKey();
    })
  });

  describe(`SNSE215 - Hold New Order (Check)`, () => {
    let page: SNSE215Page = new SNSE215Page();

    let customerCode;
    let orderNo;

    beforeAll(() => {
      page.navigateTo();

      setElements_SNSE215(page);

      customerCode = "1INN17";
      orderNo = 'ATORDER02'
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to key customer`, async () => {
      CustomerCode.sendKeys(customerCode);
      page.selectEnterKey();
      browser.waitForAngular();
      expect(CustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key order no`, () => {
      OrderNo.sendKeys(orderNo);
      expect(OrderNo.getAttribute("value")).toBeTruthy();
    });

    it(`Search button able to click`, () => {
      expect(SearchBtn.getAttribute('disabled')).not.toEqual("true");
      SearchBtn.click();
      browser.waitForAngular();
    });

    it(`Check process status to be 'Y'`, () => {
      expect(page.getStatusText()).toEqual(['Y']);
    });
  });

  describe(`SNSE212 - Unlock Hold New Order To Allocate`, () => {
    let page: SNSE212Page = new SNSE212Page();

    let customerCode;
    let orderNo;

    beforeAll(() => {
      page.navigateTo();

      setElements_SNSE212(page);

      customerCode = "1INN17";
      orderNo = 'ATORDER02'
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to key customer`, async () => {
      CustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();
      expect(CustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key order no`, () => {
      OrderNo.sendKeys(orderNo);
      page.selectEnterKey();
      expect(OrderNo.getAttribute("value")).toBeTruthy();

    });

    it(`Should able to select part no`, () => {
      var rows: ElementArrayFinder = page.getDetailRowsElement();

      rows.each(async (elem, idx) => {
        var CheckboxItem: ElementFinder = await elem.element(
          by.css("td.mat-column-CHECK mat-checkbox[name=CHK_BOX]")
        );
        await CheckboxItem.click();
        await browser.waitForAngular();

        expect(CheckboxItem.getAttribute("ng-reflect-checked")).toEqual("true");

      })
        .catch((err) => {
          console.log(err);
        });
    });

    it(`Unlock order button able to click`, () => {
      expect(UnlockBtn.getAttribute('disabled')).not.toEqual("true");
      UnlockBtn.click();
    });

    it(`Confirm modal appeared and confirmable`, () => {
      var confirmModal: ElementFinder = page.getMessageModalElement(".modal-confirm");
      var confirmButton: ElementFinder = confirmModal.element(by.css(".mat-dialog-actions button[name=Confirm]"));

      expect(confirmModal.element(by.css(".mat-dialog-title")).getText()).toMatch(/CONFIRMATION/);
      expect(confirmModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Do you want to unlock this order part\?/);

      confirmButton.click();
      browser.waitForAngular();
    });

    it(`Unlock order completed`, () => {
      var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
      expect(infoModal.element(by.css(".mat-dialog-content")).getText()).toEqual('Unlock Order Part Completed.');
      page.selectEnterKey();
    })
  });

  describe(`SNSE015_N - Allocate Order Export`, () => {
    let page: SNSE015_NPage = new SNSE015_NPage();

    let customerCode;
    let orderNo;

    beforeAll(() => {
      page.navigateTo();

      setElements_SNSE015_N(page);

      customerCode = "1INN17";
      orderNo = 'ATORDER02'
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to key customer`, async () => {
      CustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();
      expect(CustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key order no`, () => {
      OrderNo.sendKeys(orderNo);
      page.selectEnterKey();
      expect(OrderNo.getAttribute("value")).toBeTruthy();

    });

    it(`Allocate order button able to click`, () => {
      expect(AllocateBtn.getAttribute('disabled')).not.toEqual("true");
      AllocateBtn.click();
    });

    it(`Confirm modal appeared and confirmable`, () => {
      var confirmModal: ElementFinder = page.getMessageModalElement(".modal-confirm");
      var confirmButton: ElementFinder = confirmModal.element(by.css(".mat-dialog-actions button[name=Confirm]"));

      expect(confirmModal.element(by.css(".mat-dialog-title")).getText()).toMatch(/CONFIRMATION/);
      expect(confirmModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Do you want to allocate this order\?/);

      confirmButton.click();
      browser.waitForAngular();
    });

    it(`Allocate order completed`, () => {
      var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
      expect(infoModal.element(by.css(".mat-dialog-content")).getText()).toEqual('Allocate Order Completed.');
      page.selectEnterKey();
    })
  });

  describe(`SNSQ022 - Density Evaluation Function`, () => {
    let page: SNSQ022Page = new SNSQ022Page();

    let customerCode;
    let orderNo;
    let partNo;
    let orderClass;

    beforeAll(() => {
      page.navigateTo();

      setElements_SNSQ022(page);

      customerCode = "1INN17";
      orderNo = 'ATORDER02';
      partNo = "111101HC1A";
      orderClass = '2';
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to key customer`, async () => {
      CustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();
      expect(CustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key order no`, () => {
      OrderNo.sendKeys(orderNo);
      page.selectEnterKey();
      expect(OrderNo.getAttribute("value")).toBeTruthy();

    });

    it(`Should able to key order part no`, () => {
      PartNo.sendKeys(partNo);
      page.selectEnterKey();
      expect(PartNo.getAttribute("value")).toBeTruthy();

    });

    it(`Should able to key order class`, () => {
      OrderClass.sendKeys(orderClass);
      page.selectEnterKey();
      expect(OrderNo.getAttribute("value")).toBeTruthy();

    });

    it(`Search button able to click`, () => {
      expect(SearchBtn.getAttribute('disabled')).not.toEqual("true");
      SearchBtn.click();
      browser.waitForAngular();
    });

    it(`Should able to click change tab`, async () => {
      var MatTab4 = await element(by.id('mat-tab-label-0-3'));
      MatTab4.click();
    });

    it(`Should able to click edit export price master`, async () => {
      var EditBtn: ElementFinder = await element(by.css("td.mat-column-EDIT>button"));
      await EditBtn.click();
      browser.waitForAngular();
    });

    it(`Should able to click confirm new export price`, () => {
      expect(ConfirmExportPriceBtn.getAttribute('disabled')).not.toEqual("true");
      ConfirmExportPriceBtn.click();
      browser.waitForAngular();
    });

    it(`Confirm modal appeared and confirmable`, () => {
      var confirmModal: ElementFinder = page.getMessageModalElement(".modal-confirm");
      var confirmButton: ElementFinder = confirmModal.element(by.css(".mat-dialog-actions button[name=Confirm]"));

      expect(confirmModal.element(by.css(".mat-dialog-title")).getText()).toMatch(/CONFIRMATION/);
      expect(confirmModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Do you want to confirm this price\?/);

      confirmButton.click();
      browser.waitForAngular();
    });

    it(`Create new export price completed`, () => {
      var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
      expect(infoModal.element(by.css(".mat-dialog-content")).getText()).toEqual('Successfully to save new price');
      page.selectEnterKey();
    })
  });

  describe(`SNSE026_M - Request Print Picking Card Export`, () => {
    let page: SNSE026_MPage = new SNSE026_MPage();

    let customerCode;
    let orderNo;
    let partNo;
    let orderClass;

    beforeAll(() => {
      page.navigateTo();

      setElements_SNSE026_M(page);

      customerCode = "1INN17";
      orderNo = 'ATORDER02';
      partNo = "111101HC1A";
      orderClass = '2';
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to key customer`, async () => {
      CustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();
      expect(CustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key order no`, () => {
      OrderNo.sendKeys(orderNo);
      page.selectEnterKey();
      expect(OrderNo.getAttribute("value")).toBeTruthy();

    });

    it(`Should able to key accept part no`, () => {
      PartNo.sendKeys(partNo);
      page.selectEnterKey();
      expect(PartNo.getAttribute("value")).toBeTruthy();

    });

    it(`Search button able to click`, () => {
      expect(SearchBtn.getAttribute('disabled')).not.toEqual("true");
      SearchBtn.click();
      browser.waitForAngular();
    });

    it(`Uncheckd automatic print`, () => {
      expect(AutoPrintCheckbox.getAttribute('disabled')).not.toEqual("true");
      AutoPrintCheckbox.click();
      browser.waitForAngular();
    });

    it(`Should able to select order for print picking cards`, () => {
      var rows: ElementArrayFinder = page.getDetailRowsElement();

      rows.each(async (elem, idx) => {
        var CheckboxItem: ElementFinder = await elem.element(
          by.css("td.mat-column-CHECK mat-checkbox[name=CHECK_BOX]")
        );
        await CheckboxItem.click();
        await browser.waitForAngular();

        expect(CheckboxItem.getAttribute("ng-reflect-checked")).toEqual("true");

      })
        .catch((err) => {
          console.log(err);
        });
    });

    it(`Process button able to click`, () => {
      expect(ProcessBtn.getAttribute('disabled')).not.toEqual("true");
      ProcessBtn.click();
      browser.waitForAngular();
    });

    it(`Confirm modal appeared and confirmable`, () => {
      var confirmModal: ElementFinder = page.getMessageModalElement(".modal-confirm");
      var confirmButton: ElementFinder = confirmModal.element(by.css(".mat-dialog-actions button[name=Confirm]"));

      expect(confirmModal.element(by.css(".mat-dialog-title")).getText()).toMatch(/CONFIRMATION/);
      expect(confirmModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Do you want to process and print picking cards\?/);

      confirmButton.click();
      browser.waitForAngular();
    });

    it(`Request print picking cards completed`, () => {
      var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
      expect(infoModal.element(by.css(".mat-dialog-content")).getText()).toEqual('Generate picking card completed!');
      page.selectEnterKey();
    })
  });

  describe(`SNSE025_N - Packing Export Entry`, () => {
    let page: SNSE025_NPage = new SNSE025_NPage();

    let customerCode;
    let orderNo;
    let instructionList: Array<any>;

    beforeAll(() => {
      page.navigateTo();

      setElements_SNSE025_N(page);

      customerCode = "1INN17";
      orderNo = 'ATORDER02';
      instructionList = [
        {
          PART_NO: "111101HC1A",
          PACK_QTY: 1,
        }
      ];
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`New Case No button able to click`, () => {
      expect(NewCaseBtn.getAttribute('disabled')).not.toEqual("true");
      NewCaseBtn.click();
      browser.waitForAngular();
    });

    it(`Should able to key customer`, async () => {
      NewCustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();
      expect(NewCustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Branch should not be null`, () => {
      expect(NewBranchCode.getAttribute("value")).toBeTruthy();
      expect(NewBranchName.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to select sent by`, async () => {
      NewSentBy.click();
      page.selectEnterKey();
      sentBy = (await NewSentBy.getText())
    });

    it(`Case no should not be null`, async () => {
      expect(NewCaseNo.getAttribute("value")).toBeTruthy();
      browser.driver.sleep(300);
      caseNo = (await NewCaseNo.getAttribute("value"))


    });

    it(`Sub case no should not be null`, () => {
      expect(NewSubCaseNo.getAttribute("value")).toBeTruthy();
    });

    it(`Pack by should not be null`, () => {
      expect(NewPackBy.getAttribute("value")).toBeTruthy();
    });

    it(`Pack time no should not be null`, () => {
      expect(NewPackTime.getAttribute("value")).toBeTruthy();
    });

    it(`Instruction no should able to enter`, () => {
      var rows: ElementArrayFinder = page.getNewDetailRowsElement();
      rows.each(async (elem, idx) => {
        var instructionNoItem: ElementFinder = await elem.element(
          by.css("td.mat-column-INSTRUCTION_NO input[name=DATA_INSTRUCTION_NO]")
        );
        if (idx < instructionList.length) {
          await instructionNoItem.sendKeys(instructionList[idx].PART_NO);
          page.selectEnterKey();
          await browser.waitForAngular();
        }
      })
        .catch((err) => {
          console.log(err);
        });
    });

    it(`input part no should able to enter`, () => {
      var rows: ElementArrayFinder = page.getNewDetailRowsElement();
      instructionList.forEach(async (part, idx) => {
        var elem: ElementFinder = rows.get(idx);
        var inputPartNoItem: ElementFinder = await elem.element(
          by.css("td.mat-column-INPUT_PART_NO input[name=DATA_INPUT_PART_NO]")
        );

        expect(inputPartNoItem.getAttribute("disabled")).not.toEqual("true");
        await inputPartNoItem.sendKeys(part.PART_NO);
        page.selectEnterKey();
      });
    });

    it(`Pack qty should able to enter`, () => {
      var rows: ElementArrayFinder = page.getNewDetailRowsElement();
      instructionList.forEach(async (part, idx) => {
        var elem: ElementFinder = rows.get(idx);
        var packQtyItem: ElementFinder = await elem.element(
          by.css("td.mat-column-PACK_QTY input[name=DATA_PACK_QTY]")
        );

        expect(packQtyItem.getAttribute("disabled")).not.toEqual("true");
        await packQtyItem.sendKeys(part.PACK_QTY);
        page.selectEnterKey();
      });
    });

    it(`Save button able to click`, () => {
      expect(NewSaveBtn.getAttribute('disabled')).not.toEqual("true");
      NewSaveBtn.click();
      browser.waitForAngular();
    });

    it(`Confirm modal appeared and confirmable`, () => {
      var confirmModal: ElementFinder = page.getMessageModalElement(".modal-confirm");
      var confirmButton: ElementFinder = confirmModal.element(by.css(".mat-dialog-actions button[name=Confirm]"));

      expect(confirmModal.element(by.css(".mat-dialog-title")).getText()).toMatch(/CONFIRMATION/);
      expect(confirmModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Do you want to update on this data\?/);

      confirmButton.click();
      browser.waitForAngular();
    });

    it(`Packing export completed`, () => {
      var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
      expect(infoModal.element(by.css(".mat-dialog-content")).getText()).toEqual('Done.');
      page.selectEnterKey();
    })
  });

  describe(`SNSE031 - Gross Weight Entry`, () => {
    let page: SNSE031Page = new SNSE031Page();

    let customerCode;
    let instructionList: Array<any>;

    beforeAll(() => {
      page.navigateTo();

      setElements_SNSE031(page);

      customerCode = "1INN17";
      instructionList = [
        {
          PART_NO: "111101HC1A",
          PACK_QTY: 1,
        }
      ];
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to key customer`, async () => {
      CustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();
      expect(CustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Branch should not be null`, () => {
      expect(BranchCode.getAttribute("value")).toBeTruthy();
      expect(BranchName.getAttribute("value")).toBeTruthy();
    });



    it(`Gross weight should able to enter`, () => {
      var rows: ElementArrayFinder = page.getDetailRowsElement();

      rows.each(async (elem, idx) => {
        var SentByItem: ElementFinder = await elem.element(by.css("td.mat-column-SENT_BY_NAME"));
        var CaseNoItem: ElementFinder = await elem.element(by.css("td.mat-column-CASE_NO"));
        var GrossWeightItem: ElementFinder = await elem.element(by.css("td.mat-column-GROSS_WEIGHT input[name=GROSS_WEIGHT]"));

        let SentByText = (await SentByItem.getText())
        let CaseNoText = (await CaseNoItem.getText())

        if (SentByText == sentBy && CaseNoText == caseNo) {
          await GrossWeightItem.sendKeys(protractor.Key.CONTROL, "a", protractor.Key.NULL, "4");
          page.selectEnterKey();
          await browser.waitForAngular();
        }
      })
        .catch((err) => {
          console.log(err);
        });
    });


    it(`Gross mm should able to enter`, () => {
      var rows: ElementArrayFinder = page.getDetailRowsElement();

      rows.each(async (elem, idx) => {
        var SentByItem: ElementFinder = await elem.element(by.css("td.mat-column-SENT_BY_NAME"));
        var CaseNoItem: ElementFinder = await elem.element(by.css("td.mat-column-CASE_NO"));
        var GrossMMItem: ElementFinder = await elem.element(by.css("td.mat-column-GROSS_MM input[name=GROSS_MM]"));

        let SentByText = (await SentByItem.getText())
        let CaseNoText = (await CaseNoItem.getText())

        if (SentByText == sentBy && CaseNoText == caseNo) {
          await GrossMMItem.clear();
          await GrossMMItem.sendKeys("3");
          page.selectEnterKey();
          await browser.waitForAngular();
        }
      })
        .catch((err) => {
          console.log(err);
        });
    });

    it(`Save button able to click`, () => {
      expect(SaveBtn.getAttribute('disabled')).not.toEqual("true");
      SaveBtn.click();
      browser.waitForAngular();
    });


    it(`Confirm modal appeared and confirmable`, () => {
      var confirmModal: ElementFinder = page.getMessageModalElement(".modal-confirm");
      var confirmButton: ElementFinder = confirmModal.element(by.css(".mat-dialog-actions button[name=Confirm]"));

      expect(confirmModal.element(by.css(".mat-dialog-title")).getText()).toMatch(/CONFIRMATION/);
      expect(confirmModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Do you want to update on this data\?/);

      confirmButton.click();
      browser.waitForAngular();
    });

    it(`Packing export completed`, () => {
      var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
      expect(infoModal.element(by.css(".mat-dialog-content")).getText()).toEqual('Update data successfully.');
      page.selectEnterKey();
    })

  });

  describe(`SNSE032_M - PreInvoice Export Air`, () => {
    let page: SNSE032_MPage = new SNSE032_MPage();

    let customerCode;

    beforeAll(() => {
      page.navigateTo();
      setElements_SNSE032_M(page);

      customerCode = "1INN17";
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to key customer`, async () => {
      CustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();
      expect(CustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Branch should not be null`, () => {
      expect(BranchCode.getAttribute("value")).toBeTruthy();
      expect(BranchName.getAttribute("value")).toBeTruthy();
    });

    it(`Unchecked automatic print`, () => {
      expect(AutoPrintCheckbox.getAttribute('disabled')).not.toEqual("true");
      AutoPrintCheckbox.click();
      browser.waitForAngular();
    });

    it(`Clear seleted item`, async () => {
      var CheckboxItem: ElementFinder = await element(by.css("th.mat-column-Edit mat-checkbox[name=CHK_BOX_ALL_PRE]"));
      await CheckboxItem.click();
      await browser.waitForAngular();
    });

    it(`Should able to select case no for confirm pre-invoice`, () => {
      var rows: ElementArrayFinder = page.getPreDetailRowsElement();

      rows.each(async (elem, idx) => {
        var CaseNoItem: ElementFinder = await elem.element(by.css("td.mat-column-CASE_NO button>span.mat-button-wrapper"));
        var CheckboxItem: ElementFinder = await elem.element(by.css("td.mat-column-Edit mat-checkbox[name=CHK_BOX_PRE]"));
        let CaseNoText = (await CaseNoItem.getText())
        await browser.waitForAngular();

        if (CaseNoText == caseNo) {
          await CheckboxItem.click();
          await browser.waitForAngular();
          expect(CheckboxItem.getAttribute("ng-reflect-checked")).toEqual("true");
          await browser.waitForAngular();
        }
      })
        .catch((err) => {
          console.log(err);
        });
    });


    it(`Save button able to click`, () => {
      expect(ConfirmPreBtn.getAttribute('disabled')).not.toEqual("true");
      ConfirmPreBtn.click();
      browser.waitForAngular();
    });

    it(`Confirm modal appeared and confirmable`, () => {
      var confirmModal: ElementFinder = page.getMessageModalElement(".modal-confirm");
      var confirmButton: ElementFinder = confirmModal.element(by.css(".mat-dialog-actions button[name=Confirm]"));

      expect(confirmModal.element(by.css(".mat-dialog-title")).getText()).toMatch(/CONFIRMATION/);
      expect(confirmModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Are you sure to confirm Pre-invoice \?/);

      confirmButton.click();
      browser.waitForAngular();
    });

    it(`Confirm pre-invoice completed`, async () => {
      var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
      //expect(infoModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Confirm successfully [Pre-Invoice no.] : PI(\d){7}/);

      preInvoice = await (await element(by.css(".mat-dialog-content")).getText()).substr(40, 50)
      browser.waitForAngular();
      page.selectEnterKey();

    })
    //Confirm successfully[Pre - Invoice no.] : PI2100002
    //Confirm successfully [Invoice no.] : FA210001

    //123-4567-8900




   
  });

  describe(`SNSE034 - Container Entry`, () => {
    let page: SNSE034Page = new SNSE034Page();

    let customerCode;

    beforeAll(() => {
      page.navigateTo();
      setElements_SNSE034(page);

      customerCode = "1INN17";
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to key customer`, async () => {
      CustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();
      expect(CustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Branch should not be null`, () => {
      expect(BranchCode.getAttribute("value")).toBeTruthy();
      expect(BranchName.getAttribute("value")).toBeTruthy();
    });


    it(`Should able to key container no`, () => {
      var rows: ElementArrayFinder = page.getDetailRowsElement();

      rows.each(async (elem, idx) => {
        var SentByItem: ElementFinder = await elem.element(by.css("td.mat-column-SENT_BY"));
        var CaseNoItem: ElementFinder = await elem.element(by.css("td.mat-column-CASE_NO"));
        var PInvoiceNoItem: ElementFinder = await elem.element(by.css("td.mat-column-PINVOICE_NO"));
        var ConNoItem: ElementFinder = await elem.element(by.css("td.mat-column-CONTRAINER_NO input[name=CONTAINER_NO]"));

        let SentByText = (await SentByItem.getText())
        let CaseNoText = (await CaseNoItem.getText())
        let PInvoiceNoText = (await PInvoiceNoItem.getText())

        await browser.waitForAngular();
        if (PInvoiceNoText == preInvoice.trim()) {
          await ConNoItem.sendKeys(protractor.Key.CONTROL, "a", protractor.Key.NULL, "CONTAINER");
          expect(ConNoItem.getAttribute("value")).toEqual("CONTAINER");
          await browser.waitForAngular();
        }
      })
        .catch((err) => {
          console.log(err);
        });
    });


    it(`Save button able to click`, () => {
      expect(SaveBtn.getAttribute('disabled')).not.toEqual("true");
      SaveBtn.click();
      browser.waitForAngular();
    });

    it(`Confirm modal appeared and confirmable`, () => {
      var confirmModal: ElementFinder = page.getMessageModalElement(".modal-confirm");
      var confirmButton: ElementFinder = confirmModal.element(by.css(".mat-dialog-actions button[name=Confirm]"));

      expect(confirmModal.element(by.css(".mat-dialog-title")).getText()).toMatch(/CONFIRMATION/);
      expect(confirmModal.element(by.css(".mat-dialog-content")).getText()).toMatch(/Do you want to update on this data\?/);

      confirmButton.click();
      browser.waitForAngular();
    });

    it(`Save completed`, async () => {
      var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
      expect(infoModal.element(by.css(".mat-dialog-content")).getText()).toEqual('Update data successfully.');
      browser.waitForAngular();
      page.selectEnterKey();
    })
  });

  describe(`SNSE033_N - Issue Invoice Export Air/Sea`, () => {
    let page: SNSE033NPage = new SNSE033NPage();

    let customerCode,
      flightNo,
      awbNo,
      awbDate,
      freight,
      insurance;

    beforeAll(() => {
      page.navigateTo();
      setElements_SNSE033N(page);

      customerCode = "1INN17";
      flightNo = "AT123";
      awbNo = "123-4567-8900";
      awbDate = "31-Jan-2021";
      freight = "0";
      insurance = "0";
    });

    beforeEach(() => {
      browser.driver.sleep(300);
    });

    it(`Should able to key customer`, async () => {
      AirCustomerCode.sendKeys(customerCode);
      page.selectEnterKey();

      browser.waitForAngular();
      expect(AirCustomerName.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key pre-invoice no`, async () => {
      AirPreInvoiceNo.sendKeys(preInvoice.trim());
      page.selectEnterKey();

      browser.waitForAngular();
      expect(AirPreInvoiceDate.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key flight no`, async () => {
      AirFlightNo.sendKeys(flightNo);
      browser.waitForAngular();
      expect(AirFlightNo.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key AWB no`, async () => {
      AirAwbNo.sendKeys(awbNo);
      browser.waitForAngular();
      expect(AirAwbNo.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key AWB date`, async () => {
      AirAwbDate.sendKeys(awbDate);
      browser.waitForAngular();
      expect(AirAwbNo.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key freight charge`, async () => {
      AirFreight.sendKeys(freight);
      browser.waitForAngular();
      expect(AirFreight.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to key insurance`, async () => {
      AirInsurrance.sendKeys(insurance);
      browser.waitForAngular();
      expect(AirInsurrance.getAttribute("value")).toBeTruthy();
    });

    it(`Should able to select item`, () => {
      var rows: ElementArrayFinder = page.getAirDetailRowsElement();

      rows.each(async (elem, idx) => {
        var CheckboxItem: ElementFinder = await elem.element(by.css("td.mat-column-Edit mat-checkbox[name=AIR_CHKBOX]"));
        await CheckboxItem.click();
        await browser.waitForAngular();
        
      })
        .catch((err) => {
          console.log(err);
        });
    });

    it(`Confirm invoice button able to click`, () => {
      expect(AirConfirmBtn.getAttribute('disabled')).not.toEqual("true");
      AirConfirmBtn.click();
      browser.waitForAngular();
    });

    //it(`Confirm invoice completed`, async () => {
    //  var infoModal: ElementFinder = page.getMessageModalElement(".modal-info");
    //  expect(
    //    infoModal.element(by.css(".mat-dialog-content")).getText()
    //  ).toMatch(/Confirm successfully [Invoice no.] : FA(\d){6}/);

    //  browser.driver.sleep(1000);
    //})
  });
});
