import {
  browser,
  by,
  element,
  ElementArrayFinder,
  ElementFinder,
  Key,
} from "protractor";

export class SNPE015R_Page { 
  navigateTo(): Promise<unknown> {
    return browser.get("/WareHouse/SNPE015_R") as Promise<unknown>;
  }

  getDynamicElementText(query: string): Promise<string> {
    return element(by.css(query)).getText() as Promise<string>;
  }

  getDocumentDateFromElement(): ElementFinder {
    return element(by.css("input[name=PARAMS_DOCUMENT_DATE_FROM]"));
  }

  getDocumentDateToElement(): ElementFinder {
    return element(by.css("input[name=PARAMS_DOCUMENT_DATE_TO]"));
  }

  getPrereceivingNoElement(): ElementFinder {
    return element(by.css("input[name=PARAMS_PRE_RECEIVING_NO]"));
  }

  getVendorCodeElement(): ElementFinder {
  return element(by.css("input[name=PARAMS_VENDOR_CODE]"));
  }

  getInvoiceNoElement(): ElementFinder {
    return element(by.css("input[name=PARAMS_INVOICE_NO]"));
  }

  SearchButtonElement(): ElementFinder {
    return element(by.css("button[name=BtnSearch]"));
  }

  getDetailSerachElement(): ElementArrayFinder {
    return element.all(by.css("auto-table#tbl1 table[mat-table] tr[mat-row]"));
  }

  ConfirmButtonElement(): ElementFinder {
    return element(by.css("button[name=BtnConfirm]"));
  }

  getMessageModalElement(optionalClass: string): ElementFinder {
    return element(by.css(".modal-dialog-panel"+optionalClass));
  }

}
