import { Component, Inject, OnDestroy, Optional } from "@angular/core";
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { HttpService } from 'src/app/core/http.service';
import { Globals } from 'src/app/core/global';
import { Moment } from 'moment';
import * as moment from 'moment';

//@NgModule.entryComponents

export interface DialogData {
  data_type: string;
  data_name: string;
  result: string;
  finding_word: string;


}

@Component({
  selector: 'simple-dialog',
  templateUrl: './dialog-po.component.html',
  styleUrls: ['./dialog-po.component.css']
})


export class DialogPoComponent implements OnDestroy {

  constructor(
    public dialogRef: MatDialogRef<DialogPoComponent>,
    private http: HttpService,
    @Inject(MAT_DIALOG_DATA) public data: DialogData,
    @Optional() private global: Globals
  ) {
  }

  public findingPoNo: any;
  public findingPoDate: Moment;
  public findingInvoiceNo: any;
  public findingInvoiceDate: Moment;
  public findingShipDate: Moment;

  public showType: string='PO_NO';

  public dataList: any = [];
  //findingWord = new FormControl();

  ngOnInit() {

    this.findingPoNo = this.data.finding_word;
    this.showType = this.data.data_type;
    //this.findingWord.valueChanges
    //  .pipe(
    //    startWith(''),
    //    debounceTime(500),
    //    map(value => {
    //      return value && value.length >= 3 && (value || 'null')
    //    })
    //  ).subscribe(value => {
    //    if (value) {
    //      this.Find(value);
    //    }
    //  });
  }

  ngOnDestroy() {
    setTimeout(() => {
      this.dialogRef ? this.dialogRef.close() : null;
    }, 100)
  }

  public Find() {
    this.findingPoNo = this.findingPoNo ? this.global.EscapeCharacter(this.findingPoNo.toUpperCase()) : null;
    this.http.get("System", "FindPO", this.findingPoNo)
      .subscribe(result => {
        this.dataList = result.Table;
      })
  
  }

  public SearchPO() {

    if (this.data.data_type == 'PO_NO') {

      this.findingPoNo = this.findingPoNo ? this.global.EscapeCharacter(this.findingPoNo.toUpperCase()) : null;
      this.http.get("System", "FindPO", this.findingPoNo)
        .subscribe(result => {
          this.dataList = result.Table;
        })
    } else {
      this.findingPoNo = this.findingPoNo ? this.global.EscapeCharacter(this.findingPoNo.toUpperCase()) : null;
      this.findingInvoiceNo = this.findingInvoiceNo ? this.global.EscapeCharacter(this.findingInvoiceNo.toUpperCase()) : null;

      if ((this.findingPoNo && this.findingPoNo.length >= 3) || (this.findingInvoiceNo && this.findingInvoiceNo.length >= 3)) {
        this.dataList = [];
        var gPoNo: string = '';
        var gPoDate: string = '';
        var gInvoiceDate: string = '';
        var gInvoiceNo: string = '';
        var gShipDate: string = '';

        if (this.findingPoNo == undefined) {
          gPoNo = 'empty';
        } else {
          gPoNo = this.findingPoNo;
        }
        if (this.findingPoDate == undefined) {
          gPoDate = '01-01-1000';
        } else {
          gPoDate = this.global.ConvertDateToFormatSTD( this.findingPoDate);
          //gPoDate = this.global.ConvertDateToStringFormatSTD( this.findingPoDate);//BF
        }
        if (this.findingInvoiceNo == undefined) {
          gInvoiceNo = 'empty';
        } else {
          gInvoiceNo = this.findingInvoiceNo;
        }
        if (this.findingInvoiceDate == undefined) {
          gInvoiceDate = '01-01-1000';
        } else {
          gInvoiceDate = this.global.ConvertDateToFormatSTD(this.findingInvoiceDate);
          //gInvoiceDate = this.global.ConvertDateToStringFormatSTD(this.findingInvoiceDate);//BF
        }

        if (this.findingShipDate == undefined) {
          gShipDate = '01-01-1000';
        } else {
          gShipDate =  this.global.ConvertDateToFormatSTD(this.findingShipDate);
          //gShipDate = this.global.ConvertDateToStringFormatSTD(this.findingShipDate);//BF
        }


        this.http.get("IC", "SearchPO"
          , gPoNo
          , gPoDate
          , gInvoiceNo
          , gInvoiceDate
          , gShipDate)
          .subscribe(result => {
            this.dataList = result.Table;
          })


      }



    }

   

  }

  onNoClick(): void {
    this.dialogRef.close();
  }
}
