import { Component, OnInit, Input, Output, EventEmitter, Directive, ViewChild, ElementRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router } from '@angular/router';
import { Observable, config } from 'rxjs';
import { MatDialog } from '@angular/material/dialog';
import { DialogComponent } from '../dialog/dialog.component';
import { error } from '@angular/compiler/src/util';

@Component({
  selector: 'file-upload',
  templateUrl: './file-upload.component.html',
  styleUrls: ['./file-upload.component.css']
})

/**
 * How to use this component?
 * 1. Create tag
 *    <file-upload></file-upload>
 * 2. Add properties
 *    - config [Required][Input]
 *    - fileSelectCallback [Not-required][Output]
 * 
 * Config's model
 *  1. PlaceholderText [String]
 *  2. AcceptFileType [Filetype]['.xlsx,.pdf']
 *  3. MultipleSelect [Boolean]
 */


export class FileUploadComponent implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private formBuilder: FormBuilder,
    public dialog : MatDialog
  ) { }


  @Input() config: any;
  @Output() fileSelectCallback = new EventEmitter<FileList>();

  public states: any;
  public setting: any;
  myControl = new FormControl();
  filteredOptions: Observable<string[]>;
  private formData: any;
  uploadForm: FormGroup;
  fileInput: File;
  public fileNames: string = "";

  ngOnInit() {
  }

  OnFileSelect(fileInput: FileList) {
    this.fileNames = Array.from(fileInput) .map(v => v.name).join(", ");
    
    this.fileSelectCallback.emit(fileInput);
  }

}
