import { Component, OnInit, Input, Output, EventEmitter } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Title } from '@angular/platform-browser';
import { ActivatedRoute } from '@angular/router';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'form-header',
  template: `
        <div class="col-md-12">
            <h6 class="text-header">{{formID}} - {{formName}}</h6>
        </div>
        `
})

export class FormHeaderComponent implements OnInit {
  @Input("formID") formID: string;
  @Output() formTitle = new EventEmitter<any>();
  public formName: string;

  constructor(
    private http: HttpService,
    private title: Title,
    private route: ActivatedRoute,
    private global: Globals
  ) {
    this.route.data.subscribe(d => {
      this.global.SetRoleDetail(d.role);
    })
  }

  ngOnInit() {
    this.GetFormName();
  }

  GetFormName() {
    this.http.get("System", "GetFormName", this.formID)
      .subscribe(result => {


        this.formName = result.FORM_NAME;
        this.formTitle.emit(this.formName);

        this.title.setTitle('PMS : ' + this.formID + ' : ' + this.formName);
      })
  }
}
