import { Component, OnInit, Inject, OnDestroy, ElementRef, Renderer2 } from "@angular/core";
import { Subscription } from "rxjs";
import { LoaderService } from 'src/app/core/loader.service';
import { tap, delay } from 'rxjs/operators';

@Component({
    selector: 'web-loader',
    templateUrl: './loader.component.html',
    styleUrls: ['./loader.component.scss']
})

export class LoaderComponent implements OnInit, OnDestroy {
    public show: boolean = false;
    private subscription: Subscription;

    constructor(
        private loaderService: LoaderService,
        private elem: ElementRef
    ) { }

    ngOnInit() {
        this.subscription = this.loaderService.loaderState
            .pipe(delay(0))
            .subscribe((state) => {
                this.show = state.show;
            })

    }

    ngOnDestroy() {
        this.subscription.unsubscribe();
    }

    checkAutoCompleteExists(): boolean {
        return this.elem.nativeElement.closest('body').querySelector('auto-complete-dialog, auto-complete-part-dialog, auto-complete-query-dialog, auto-complete-query-search-dialog');
    }
}