import { Injectable } from '@angular/core';
import { Subject } from 'rxjs';

export interface LoaderState {
    show: boolean;
}

@Injectable({
    providedIn: 'root'
})
export class LoaderService {
    private loaderSubject = new Subject<LoaderState>();
    loaderState = this.loaderSubject.asObservable();
    private activeloader: number = 0;

    constructor() { }

    show() {
        if(this.activeloader === 0) this.loaderSubject.next(<LoaderState>{ show: true });
        this.activeloader++;
    }

    hide() {
        this.activeloader--;
        if(this.activeloader === 0) this.loaderSubject.next(<LoaderState>{ show: false });
    }
}