import { NgModule } from "@angular/core";
import { CommonModule } from "@angular/common";
import { HttpClientModule } from "@angular/common/http";
import { ReactiveFormsModule, FormsModule } from "@angular/forms";
import { RouterModule } from "@angular/router";

import { SharedComponentModule } from "../shared/shared-component.module";
import { AuthGuard } from "src/app/core/auth-guard.service";

import { MaterialImportModule } from "../shared/material.module";
import { RoleResolver } from "src/app/core/role-resolver.service";

import { Inventory_Control_CommonComponent } from "../../pages/inventory_control_common/inventory_control_common.component";
// import { A_SNPJ006_43_MComponent } from '../../pages/inventory_control_common/A_SNPJ006_43_M/A_SNPJ006_43_M.component';
// import { SNBA007_FBOComponent } from '../../pages/inventory_control_common/SNBA007_FBO/SNBA007_FBO.component';
import { SNBA007_ICComponent } from "../../pages/inventory_control_common/SNBA007_IC/SNBA007_IC.component";

// import { SNBA021_FBOComponent } from '../../pages/inventory_control_common/SNBA021_FBO/SNBA021_FBO.component';
import { SNBA021_LOComponent } from "../../pages/inventory_control_common/SNBA021_LO/SNBA021_LO.component";
import { SNPE002Component } from "../../pages/inventory_control_common/SNPE002/SNPE002.component";
// import { SNPE003_FBOComponent } from '../../pages/inventory_control_common/SNPE003_FBO/SNPE003_FBO.component';
import { SNPE005_MComponent } from "../../pages/inventory_control_common/SNPE005_M/SNPE005_M.component";
import { SNPE005_NComponent } from "../../pages/inventory_control_common/SNPE005_N/SNPE005_N.component";
// import { SNPJ002Component } from '../../pages/inventory_control_common/SNPJ002/SNPJ002.component';
// import { SNPJ003Component } from '../../pages/inventory_control_common/SNPJ003/SNPJ003.component';
// import { SNPJ003MComponent } from '../../pages/inventory_control_common/SNPJ003M/SNPJ003M.component';
// import { SNPJ004Component } from '../../pages/inventory_control_common/SNPJ004/SNPJ004.component';
import { SNPJ005_DRGComponent } from "../../pages/inventory_control_common/SNPJ005_DRG/SNPJ005_DRG.component";
import { SNPJ006_D0Component } from "../../pages/inventory_control_common/SNPJ006_D0/SNPJ006_D0.component";
import { SNPJ006_D1Component } from "../../pages/inventory_control_common/SNPJ006_D1/SNPJ006_D1.component";
// import { SNPJ009Component } from '../../pages/inventory_control_common/SNPJ009/SNPJ009.component';
// import { SNPP021LO_FBOComponent } from '../../pages/inventory_control_common/SNPP021LO_FBO/SNPP021LO_FBO.component';
// import { SNPP021PRN_FBOComponent } from '../../pages/inventory_control_common/SNPP021PRN_FBO/SNPP021PRN_FBO.component';
// import { SNPP101PComponent } from '../../pages/inventory_control_common/SNPP101P/SNPP101P.component';
// import { SNPP107Component } from '../../pages/inventory_control_common/SNPP107/SNPP107.component';
// import { SNPR005_NComponent } from '../../pages/inventory_control_common/SNPR005_N/SNPR005_N.component';
// import { SNPR008_FBOComponent } from '../../pages/inventory_control_common/SNPR008_FBO/SNPR008_FBO.component';
import { SNSD141_99_1Component } from "../../pages/inventory_control_common/SNSD141_99_1/SNSD141_99_1.component";
import { SNSD148_FComponent } from "../../pages/inventory_control_common/SNSD148_F/SNSD148_F.component";
import { SNSD172_FComponent } from "../../pages/inventory_control_common/SNSD172_F/SNSD172_F.component";
// import { SNSE143Component } from '../../pages/inventory_control_common/SNSE143/SNSE143.component';
// import { SNSE144Component } from '../../pages/inventory_control_common/SNSE144/SNSE144.component';
// import { SNSE145Component } from '../../pages/inventory_control_common/SNSE145/SNSE145.component';
// import { SNSE147Component } from '../../pages/inventory_control_common/SNSE147/SNSE147.component';
import { SNSE148Component } from "../../pages/inventory_control_common/SNSE148/SNSE148.component";
// import { SNSE149Component } from '../../pages/inventory_control_common/SNSE149/SNSE149.component';
// import { SNSE150Component } from '../../pages/inventory_control_common/SNSE150/SNSE150.component';
import { SNSE155Component } from "../../pages/inventory_control_common/SNSE155/SNSE155.component";
import { SNSE158Component } from "../../pages/inventory_control_common/SNSE158/SNSE158.component";
import { SNSE162Component } from "../../pages/inventory_control_common/SNSE162/SNSE162.component";
// import { SNSE165Component } from '../../pages/inventory_control_common/SNSE165/SNSE165.component';
import { SNM107PComponent } from "../../pages/inventory_control_common/SNM107P/SNM107P.component";
import { SNM112PComponent } from "../../pages/inventory_control_common/SNM112P/SNM112P.component";
import { SNPE044Component } from "../../pages/inventory_control_common/SNPE044/SNPE044.component";
import { SNPE048Component } from "../../pages/inventory_control_common/SNPE048/SNPE048.component";
import { SNPR008_MComponent } from "../../pages/inventory_control_common/SNPR008_M/SNPR008_M.component";
import { SNSE201Component } from "../../pages/inventory_control_common/SNSE201/SNSE201.component";
import { SNBA008Component } from "../../pages/inventory_control_common/SNBA008/SNBA008.component";
import { SNBA007_SComponent } from "../../pages/inventory_control_common/SNBA007_S/SNBA007_S.component";
import { SNPP021LOComponent } from "../../pages/inventory_control_common/SNPP021LO/SNPP021LO.component";
import { SNPE022MComponent } from "../../pages/inventory_control_common/SNPE022_M/SNPE022_M.component";
import { SNPE022MPartListComponent } from "../../pages/inventory_control_common/SNPE022_M/partials/part-list/part-list.component";
import { SNM031PComponent } from "../../pages/inventory_control_common/SNM031P/SNM031P.component";
import { SNPQ002Component } from "../../pages/inventory_control_common/SNPQ002/SNPQ002.component";
import { SNPP021EX_MComponent } from "../../pages/inventory_control_common/SNPP021EX_M/SNPP021EX_M.component";
// import { SNPR008_Component } from '../../pages/inventory_control_common/SNPR008/SNPR008.component';
import { SNM003PComponent } from '../../pages/inventory_control_common/SNM003P/SNM003P.component';
import { SNM030PComponent } from '../../pages/inventory_control_common/SNM030P/SNM030P.component';
import { SNM006PComponent } from '../../pages/inventory_control_common/SNM006P/SNM006P.component';
import { SNM040PComponent } from '../../pages/inventory_control_common/SNM040P/SNM040P.component';
import { SNPP027Component } from '../../pages/inventory_control_common/SNPP027/SNPP027.component';
import { SNPP021PRNComponent } from '../../pages/inventory_control_common/SNPP021PRN/SNPP021PRN.component';
import { SNPE049Component } from 'src/app/pages/inventory_control_common/SNPE049/SNPE049.component';
import { SNPE050Component } from 'src/app/pages/inventory_control_common/SNPE050/SNPE050.component';
import { SNSQ094Component } from 'src/app/pages/inventory_control_common/SNSQ094/SNSQ094.component';
import { SNM141PComponent } from 'src/app/pages/inventory_control_common/SNM141P/SNM141P.component';
import { SNM144PComponent } from "src/app/pages/inventory_control_common/SNM144P/SNM144P.component";

@NgModule({
  declarations: [
    Inventory_Control_CommonComponent,
    // A_SNPJ006_43_MComponent,
    // SNBA007_FBOComponent,
    SNBA007_ICComponent,
    SNBA007_SComponent,
    // SNBA021_FBOComponent,
    SNBA021_LOComponent,
    SNPE002Component,
    // SNPE003_FBOComponent,
    SNPE005_MComponent,
    SNPE005_NComponent,
    // SNPJ002Component,
    // SNPJ003Component,
    // SNPJ003MComponent,
    // SNPJ004Component,
    SNPJ005_DRGComponent,
    SNPJ006_D0Component,
    SNPJ006_D1Component,
    // SNPJ009Component,
    // SNPP021LO_FBOComponent,
    // SNPP021PRN_FBOComponent,
    // SNPP101PComponent,
    // SNPP107Component,
    // SNPR005_NComponent,
    // SNPR008_FBOComponent,
    SNSD141_99_1Component,
    SNSD148_FComponent,
    SNSD172_FComponent,
    // SNSE143Component,
    // SNSE144Component,
    // SNSE145Component,
    // SNSE147Component,
    SNSE148Component,
    // SNSE149Component,
    // SNSE150Component,
    SNSE155Component,
    SNSE158Component,
    SNSE162Component,
    // SNSE165Component,
    SNM107PComponent,
    SNM112PComponent,
    SNPE044Component,
    SNPE048Component,
    SNPR008_MComponent,
    SNSE201Component,
    SNBA008Component,
    SNPP021LOComponent,
    SNPE022MComponent,
    SNPE022MPartListComponent,
    SNM031PComponent,
    SNPQ002Component,
    SNPP021EX_MComponent,
    // SNPR008_Component,
    SNM003PComponent,
    SNM030PComponent,
    SNM006PComponent,
    SNM040PComponent,
    SNPP027Component,
    SNPP021PRNComponent,
    SNPE049Component,
    SNPE050Component,
    SNSQ094Component,
    SNM141PComponent,
    SNM144PComponent
    ],
    imports: [
        CommonModule,
        HttpClientModule,
        FormsModule,
        ReactiveFormsModule,
        SharedComponentModule,
        FormsModule,

    //Material imports
    MaterialImportModule,


        RouterModule.forChild([
            {
                path: '',
                component: Inventory_Control_CommonComponent,
                children: [
                    {
                        path: 'SNM144P',
                        component: SNM144PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNM141P',
                        component: SNM141PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    // {
                    //     path: 'A_SNPJ006_43_M',
                    //     component: A_SNPJ006_43_MComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNBA007_FBO',
                    //     component: SNBA007_FBOComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    {
                        path: 'SNBA007_IC',
                        component: SNBA007_ICComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNBA007_S',
                        component: SNBA007_SComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNBA008',
                        component: SNBA008Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    // {
                    //     path: 'SNBA021_FBO',
                    //     component: SNBA021_FBOComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    {
                        path: 'SNBA021_LO',
                        component: SNBA021_LOComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPE002',
                        component: SNPE002Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    // {
                    //     path: 'SNPE003_FBO',
                    //     component: SNPE003_FBOComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    {
                        path: 'SNPE005_M',
                        component: SNPE005_MComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPE005_N',
                        component: SNPE005_NComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    // {
                    //     path: 'SNPJ002',
                    //     component: SNPJ002Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNPJ003',
                    //     component: SNPJ003Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNPJ003M',
                    //     component: SNPJ003MComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNPJ004',
                    //     component: SNPJ004Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    {
                        path: 'SNPJ005_DRG',
                        component: SNPJ005_DRGComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPJ006_D0',
                        component: SNPJ006_D0Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPJ006_D1',
                        component: SNPJ006_D1Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    // {
                    //     path: 'SNPJ009',
                    //     component: SNPJ009Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNPP021LO_FBO',
                    //     component: SNPP021LO_FBOComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNPP021PRN_FBO',
                    //     component: SNPP021PRN_FBOComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNPP101P',
                    //     component: SNPP101PComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNPP107',
                    //     component: SNPP107Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNPR005N',
                    //     component: SNPR005_NComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNPR008_FBO',
                    //     component: SNPR008_FBOComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    {
                        path: 'SNSD141_99_1',
                        component: SNSD141_99_1Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNSD148_F',
                        component: SNSD148_FComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNSD172_F',
                        component: SNSD172_FComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    // {
                    //     path: 'SNSE143',
                    //     component: SNSE143Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNSE144',
                    //     component: SNSE144Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNSE145',
                    //     component: SNSE145Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNSE147',
                    //     component: SNSE147Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    {
                        path: 'SNSE148',
                        component: SNSE148Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    // {
                    //     path: 'SNSE149',
                    //     component: SNSE149Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNSE150',
                    //     component: SNSE150Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                     {
                         path: 'SNSE155',
                         component: SNSE155Component,
                         resolve: {
                             role: RoleResolver
                         },
                     },
                     {
                         path: 'SNSE158',
                         component: SNSE158Component,
                         resolve: {
                             role: RoleResolver
                         },
                     },
                     {
                         path: 'SNSE162',
                         component: SNSE162Component,
                         resolve: {
                             role: RoleResolver
                         },
                     },
                    // {
                    //     path: 'SNSE165',
                    //     component: SNSE165Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    {
                        path: 'SNM107P',
                        component: SNM107PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNM112P',
                        component: SNM112PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPE044',
                        component: SNPE044Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                      path: 'SNPE048',
                      component: SNPE048Component,
                      resolve: {
                        role: RoleResolver
                      },
                    },
                    {
                        path: 'SNPR008_M',
                        component: SNPR008_MComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNSE201',
                        component: SNSE201Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPP021LO',
                        component: SNPP021LOComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPE022_M',
                        component: SNPE022MComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNM031P',
                        component: SNM031PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPQ002',
                        component: SNPQ002Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPP021EX_M',
                        component: SNPP021EX_MComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    // {
                    //     path: 'SNPR008',
                    //     component: SNPR008_Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    {
                        path: 'SNM003P',
                        component: SNM003PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    // {
                    //     path: 'SNPR008',
                    //     component: SNPR008_Component,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    {
                        path: 'SNM030P',
                        component: SNM030PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNM006P',
                        component: SNM006PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNM040P',
                        component: SNM040PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPP027',
                        component: SNPP027Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPP021PRN',
                        component: SNPP021PRNComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNPE049',
                        component: SNPE049Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                path: 'SNPE050',
                component: SNPE050Component,
                resolve: {
                  role: RoleResolver
                },
              },
              {
                        path: 'SNSQ094',
                      component: SNSQ094Component,
                        resolve: {
                          role: RoleResolver
                    },
                    }
                ],
                canActivate: [AuthGuard]
            }
        ])
    ],
    exports: [],
    providers: [
        AuthGuard,
        RoleResolver
    ],
    entryComponents: []
})
export class Inventory_Control_CommonModule {}
