import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { MAComponent } from 'src/app/pages/ma/ma.component';
import { SyslogsComponent } from 'src/app/pages/ma/syslogs/syslogs.component';
import { BatchComponent } from 'src/app/pages/ma/batch/batch.component';
import { SKCUMUSER_MComponent } from 'src/app/pages/ma/SKCUMUSER_M/SKCUMUSER_M.component';
import { SKCUMTPRGComponent } from 'src/app/pages/ma/SKCUMTPRG/SKCUMTPRG.component';


@NgModule({
  declarations: [
    MAComponent,
    SyslogsComponent,
    BatchComponent,
    SKCUMUSER_MComponent,
    SKCUMTPRGComponent
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: MAComponent,
        children: [
          {
            path: 'syslogs',
            component: SyslogsComponent
          },
          {
            path: 'batch',
            component: BatchComponent
          },
          {
            path: 'SKCUMUSER_M',
            component: SKCUMUSER_MComponent
          },
          {
            path: 'SKCUMTPRG',
            component: SKCUMTPRGComponent
          }
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [
  ],
  providers: [AuthGuard, RoleResolver],
})
export class MAModule { }
