import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { PriceRevisionComponent } from '../../pages/pricerevision/pricerevision.component';

// import { SNSE102Component } from '../../pages/pricerevision/SNSE102/SNSE102.component';
// import { SNSE126RComponent } from '../../pages/pricerevision/SNSE126R/SNSE126R.component';
// import { SNSE127_1_1Component } from '../../pages/pricerevision/SNSE127_1_1/SNSE127_1_1.component';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';

@NgModule({
  declarations: [
    PriceRevisionComponent,
    // SNSE102Component,
    // SNSE126RComponent,
    // SNSE127_1_1Component,

  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: PriceRevisionComponent,
        children: [
          // {
          //   path: 'SNSE102',
          //   component: SNSE102Component,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNSE126R',
          //   component: SNSE126RComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNSE127_1_1',
          //   component: SNSE127_1_1Component,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard, RoleResolver],
})
export class PriceRevisionModule { }
