import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { PS_DeadStockComponent } from '../../pages/ps_deadstock/ps_deadstock.component';
//import { SNPP104Component } from '../../pages/ps_deadstock/SNPP104/SNPP104.component';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';



@NgModule({
  declarations: [
    PS_DeadStockComponent,
    // SNPP104Component,

  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material 
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: PS_DeadStockComponent,
        children: [
          // {
          //   path: 'SNPP104',
          //   component: SNPP104Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },


        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard, RoleResolver],
})
export class PS_DeadStockModule { }

