import { Component, ElementRef, OnInit, ViewChild } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from "../../../core/modal.service";
import { ViewContainerRef } from "@angular/core";
import { SelectionModel } from '@angular/cdk/collections';
import { FormControl } from "@angular/forms";
import { isBoolean } from "util";

@Component({
  selector: 'SNIE004',
  templateUrl: './SNIE004.component.html',
  styleUrls: ['./SNIE004.component.css']
})

export class SNIE004Component implements OnInit {
  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals
  ) { }


  public dataHeadeList: any = [];

  public dataSP108: any = [];
  public dataRS108: any = [];
  public dataSP123: any = [];
  public dataRS123: any = [];
  public dataPA: any = [];

  public dataPartDiff: any = [];

  public dataLocationList4Temp: any = [];
  public dataLocationList5: any = [];

  public showList: boolean = true;
  public paramSearch: any = {};
  public paramAdd: any = {};
  public dataHead: any = {};
  public uploadInfo: any = {};
  public paramsEdit: any = {};

  public partInfo: any = {};
  public partPO: any = {};

  public dataConfig: any = {};

  public selectedLocation: any = {};
  public currentLocation: any = {};
  public dataByCat: any = {};
  public dataByEmpty: any = {};

  private iTab: number = 0;
  public iByCat: number = 0;
  public iByEmpty: number = 0;

  public iMax: number = 0;
  public iMaxEmpty: number = 0;

  public selection = new SelectionModel<any>(true, []);
  public dataIsSelected: any = [];

  public ReccordCount: any = 0;
  public params = {
    locationFrom: null,
    locationTo: null,
    PrintFrom: null,
    PartFrom: null,
    PartTo: null,
    PRINT_NO: null,
    PrintTo: null
  }

  @ViewChild("fileInput") fileInput: ElementRef;
  @ViewChild("dialogUpload", { static: false }) dialogUpload: any;
  @ViewChild("dialogAdd", { static: false }) dialogAdd: any;
  @ViewChild("dialog2", { static: false }) dialog2: any;

  public tableDataUpload: any = [];
  public correctData: any = [];
  private file: any;
  public fileNameInput: string = "";
  public isSave: boolean = false;

  myControl = new FormControl();

  public ConfigLocation: any = {
    ColName: "LOCATION_NO",
    ColValue: "LOCATION_NO",
    PlaceholderText: "Select Location",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetLocation",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }
  public ConfigPart: any = {
    ColName: "PART_NO",
    ColValue: "PART_NO",
    PlaceholderText: "Select Part",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetPart",
    NoOfShowRecords: 30,
    //locationFrom: this.params.locationFrom !== null ? this.params.locationFrom:"null",
    //locationTo: this.params.locationTo !== null ? this.params.locationTo : "null",

    SourceParams: {
      locationFrom: null,
      locationTo: null
    },
    MinLengthSearch: 1,
    UpperCase: false
  }
  public ConfigPrint: any = {
    ColName: "PRINT_NO",
    ColValue: "PRINT_NO",
    PlaceholderText: "Select Print",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetPrint",
    locationFrom: this.params.locationFrom !== null ? this.params.locationFrom : "null",
    locationTo: this.params.locationTo !== null ? this.params.locationTo : "null",
    PartFrom: this.params.PartFrom !== null ? this.params.PartFrom : "null",
    PartTo: this.params.PartTo !== null ? this.params.PartTo : "null",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  ngOnInit() {
    this.dataConfig.COMING_IN_DAY = 0;
    this.dataConfig.ETD_DAY = 0;
    this.dataConfig.M3_MAGIN_RATE = 10;
    this.dataConfig.WEIGHT_MAGIN_RATE = 10;

    this.Search();

    this.paramSearch.LOCATION_NO = '';
  }

  public Search() {
    this.http.post('AC', 'SNIE004_GetCycleCountHeader', this.paramSearch)
      .subscribe(res => {
        this.dataHeadeList = res.Table;
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }

  public ViewDetail(pData) {

    /* this.invoiceDetail = [];*/

    this.showList = false;
    this.dataHead = pData;

    this.GetCycleDetail();
    //this.http.post("WH", "SNPE015_P_GetInvoiceDetail", pData).subscribe(
    //  (res) => {

    //  },
    //  (err) => {
    //    this.modal.warning(
    //      "Found an error, please contact support team",
    //      this.viewRef
    //    );
    //  }
    //);
  }

  private GetCycleDetail() {

    this.http.post("AC", "SNIE004_GetCycleDetail", this.dataHead )
      .subscribe(result => {
        this.dataHead = result.Table[0];
        this.dataPartDiff = result.Table1;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public Add() {
    this.dialogAdd.OpenDialog();
  }

  public openDialog() {
    this.paramAdd = {}
    this.dialogAdd.OpenDialog();
  }


  public AddHeader() {
    this.modal.confirm("Do you want to add the new cycle count?", this.viewRef, this.ConfirmAdd)
  }

  private ConfirmAdd = () => {

    this.http.post('AC', 'SNIE004_AddHeader', this.paramAdd)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Transaction complete: applied and saved.', this.viewRef);
          this.Search();
        
          this.dialogAdd.Close();
        } else if (res.Table[0].STATUS == 'Duplicate') {
          this.modal.warning('No change to save. Found duplicate record.', this.viewRef);
        }
        else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      }, (err => {
        console.log(err)
        this.modal.error('Found an error, please contact support team', this.viewRef);
      }))
  }

  CancelAdd() {
    this.dialogAdd.Close()
  }

  public BackToHead() {
    this.showList = true;
  }

  public TabChange($event) {
    if ($event.index == 0) {
      this.GetCycleDetail();
    } else if ($event.index == 1) {
     // this.GetSP108();
      this.GetRS108();
    } else if ($event.index == 2) {
      this.GetSP123();
    } else if ($event.index == 3) {
      this.GetRS123();
    } else if ($event.index == 4) {
      this.GetPA();
    }
  }

  public GetSP108() {
    this.modal.confirm('Do you want to get the suspend - 108, prepare reverse suspend will be clear?', this.viewRef, this.ConfirmGetSP108);
  }

  private ConfirmGetSP108 = () =>  {
    this.http.post("AC", "SNIE004_GetSP108", this.dataHead)
      .subscribe(result => {
        this.dataSP108 = result.Table;
        //this.GetCycleDetail();
        this.GetRS108();       
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetRS108() {

    this.http.post("AC", "SNIE004_GetRS108", this.dataHead)
      .subscribe(result => {
        this.dataSP108 = result.Table;
        this.dataRS108 = result.Table1;

      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public CancelEdit() {
    this.dialog2.Close();
  }

  public DeleteRS108(data) {
    this.modal.confirm('Do you want to delete record?', this.viewRef, () => this.ConfirmDelete(data))
  }

  private ConfirmDelete = (data) => {
    this.http.post('AC', 'SNIE004_Delete_RS108', data)
      .subscribe(res => {
        if (res.STATUS == 'DONE') {
          this.modal.info('Delete complete', this.viewRef);
          this.GetRS108();
        } else {
          this.modal.warning(res.MESSAGE, this.viewRef);
        }
      })
  }

  public EditData(data) {
      this.paramsEdit = data
      this.dialog2.OpenDialog();   
  }

  public SaveRS108() {
    this.http.post('AC', 'SNIE004_Save_RS108', this.paramsEdit)
      .subscribe(res => {
        if (res.STATUS == 'DONE') {
          this.modal.info('Save data complete', this.viewRef);
          this.GetRS108();
        } else {
          this.modal.warning(res.MESSAGE, this.viewRef);
        }
      })
  }

  public Reverse108() {
    this.modal.confirm('Do you want to confirm reverse suspend - 108?', this.viewRef, this.ConfirmReverse108);
  }



  private ConfirmReverse108 = () =>  {
    this.http.post("AC", "SNIE004_Run_RS108", this.dataHead)
      .subscribe(result => {
        if (result.STATUS == 'DONE') {
          this.modal.info('Successfully to revese suspend 108, document no. : ' + result.MESSAGE, this.viewRef);
          this.GetCycleDetail();
          this.GetRS108();        
        } else {
          this.modal.error('The operation is not completed', this.viewRef);
          console.log(result.MESSAGE);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GenerateSP123() {

    this.http.post("AC", "SNIE004_Generate_SP123", this.dataHead)
      .subscribe(result => {
        this.dataSP123 = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetSP123() {

    this.http.post("AC", "SNIE004_GetSP123", this.dataHead)
      .subscribe(result => {
        this.dataSP123 = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }



  public Suspend123() {
    this.modal.confirm('Do you want to confirm suspend - 123?', this.viewRef, this.ConfirmSuspend123);
  }

  private ConfirmSuspend123 = () =>  {
    this.http.post("AC", "SNIE004_Run_SP123", this.dataHead)
      .subscribe(result => {
        if (result.STATUS == 'DONE') {
          this.modal.info('Successfully to suspend 123, document no. : ' + result.MESSAGE, this.viewRef);
          this.GetCycleDetail();
          this.GetSP123();
        } else {
          this.modal.error('The operation is not completed', this.viewRef);
          console.log(result.Table[0].MESSAGE);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }
  


  public GetRS123() {
    this.http.post("AC", "SNIE004_GetRS123", this.dataHead)
      .subscribe(result => {
        this.dataRS123 = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public SaveRS123() {

  }

  public Reverse123() {
    this.modal.confirm('Do you want to confirm reverse suspend - 123 and MA?', this.viewRef, this.ConfirmReverse123);
  }

  private ConfirmReverse123 = () => {
    this.http.post("AC", "SNIE004_Run_MA123", this.dataHead)
      .subscribe(result => {
        if (result.STATUS == 'DONE') {
          this.modal.info('Successfully to revese suspend 123 and MA, document no. : ' + result.MESSAGE, this.viewRef);
          this.GetCycleDetail();
          this.GetRS123();
        } else {
          this.modal.error('The operation is not completed', this.viewRef);
          console.log(result.MESSAGE);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetPA() {
    this.http.post("AC", "SNIE004_GetPA", this.dataHead)
      .subscribe(result => {
        this.dataPA = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public SavePA() {
    this.modal.confirm('Do you want to confirm PA?', this.viewRef, this.ConfirmPA);
  }

  private ConfirmPA = () => {
    this.http.post("AC", "SNIE004_Run_PA416", this.dataHead)
      .subscribe(result => {
        if (result.STATUS == 'DONE') {
          this.modal.info('Successfully to PA , document no. : ' + result.MESSAGE, this.viewRef);
          this.GetCycleDetail();
          this.GetPA();
        } else {
          this.modal.error('The operation is not completed', this.viewRef);
          console.log(result.MESSAGE);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.dataPartDiff.length;
    return numSelected === numRows;
  }

  public Toggle() {
    if (this.isAllSelected()) {
      this.selection.clear()
      this.dataPartDiff.map(x => {
        this.dataIsSelected = [];
      })
    } else {
      this.dataPartDiff.forEach(row => this.selection.select(row));
      this.dataIsSelected = [];
      this.dataPartDiff.map(x => {
        this.dataIsSelected.push(x);
      })
    }

  }

  public CheckboxChange(event, data) {
    if (event.checked) {

      this.dataIsSelected.push(data);
    }
    else {
      this.dataIsSelected.splice(this.dataIsSelected.indexOf(data), 1);
    }
    // this.params.CNT_SEL = this.dataIsSelected.length;
  }

  public OpenReport() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR004_RE_LOCATION_ST",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_USER_ID: '1'
      });
  }

  public PrintLocation() {

    this.global.GoToReport("PMS_RPT_WMS_SNWR004_RE_LOCATION_ST",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_USER_ID: '1'
      });
  }

  public OpendialogUpload() {
    this.dialogUpload.OpenDialog();
    this.fileNameInput = "";
    //this.fileInput.nativeElement.value = '';
    this.tableDataUpload = []
    this.correctData = []
    this.isSave = false
  }

  public OpenFileBrowser() {
    this.fileNameInput = "";
    this.fileInput.nativeElement.value = '';
    this.fileInput.nativeElement.click();
  }
  public SelectFile(evt) {
    let Files: Array<File> = evt.target.files;
    if (Files.length > 0) {
      //let File: File = Files[0];
      this.file = Files[0];
      this.fileNameInput = this.file.name;
    }
  }

  public PreView() {
    if (!this.fileInput) {
      this.modal.warning("Please Open File First...", this.viewRef)
      return;
    }
    let formData = new FormData();
    formData.append('file', this.file);
    this.tableDataUpload = []
    this.http.postFile("AC", "SNIE004_UploadFile", formData)
      .subscribe(result => {
        this.modal.info("Data is previewed. Check data before save", this.viewRef);
        this.tableDataUpload = result.filter(x => x.DIFF_QTY != 0 && x.DIFF_QTY != '0');
        this.correctData = this.tableDataUpload.filter(x => x.ERR_FLAG == 'N')

        this.uploadInfo.MA_QTY = 0;
        this.uploadInfo.MA_ITEM = 0;
        this.uploadInfo.PA_QTY = 0;
        this.uploadInfo.PA_ITEM = 0;

        this.tableDataUpload.forEach((e) => {       
          if (e.DIFF < 0) {
            this.uploadInfo.MA_QTY = this.uploadInfo.MA_QTY + (e.DIFF*-1);
            this.uploadInfo.MA_ITEM = this.uploadInfo.MA_ITEM + 1;
          } else if (e.DIFF > 0) {
            this.uploadInfo.PA_QTY = this.uploadInfo.PA_QTY + e.DIFF;
            this.uploadInfo.PA_ITEM = this.uploadInfo.PA_ITEM  + 1 ;
          }         
        });

        this.isSave = false;

      }, err => {
        this.modal.error("Upload not complete", this.viewRef);
        console.log(err);
      })
  }

  public SaveByUpload() {

    this.modal.confirm("Do you want to save data?", this.viewRef, () => ConfirmSave())

    let ConfirmSave = () => {

      let data = {
        DETAIL: this.correctData,
        HEADER: this.dataHead
      }

      this.http.post("AC", "SNIE004_SaveByUpload", data)
        .subscribe(res => {
          if (res.STATUS == 'DONE') {
            this.isSave = true
            this.GetCycleDetail();
            this.modal.info("Save " + (this.uploadInfo.MA_ITEM + this.uploadInfo.PA_ITEM) + " records complete", this.viewRef)
            this.dialogUpload.Close();
          } else {
            this.modal.error('Found an error, please contact support team', this.viewRef);
          }
        }, err => {
          this.modal.error('Found an error, please contact support team', this.viewRef);
        })

    }

  }

  public DownloadTemplate() {
    let link = "assets/templates/SNWR004_RELOCATION_TEMPLATE.xlsx"
    window.open(link, '_blank')
  }



}
