import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef, ElementRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { Globals } from '../../../core/global';
import { ModalService } from '../../../core/modal.service';
import { AutoCompleteQueryComponent } from 'src/app/components/shared/auto-complete-query/auto-complete-query.component';
import * as moment from 'moment';
import { SelectionModel } from '@angular/cdk/collections';


@Component({
  selector: 'SNPE018_M',
  templateUrl: './SNPE018_M.component.html',
  styleUrls: ['./SNPE018_M.component.css']
})

export class SNPE018_MComponent implements OnInit {

  constructor(
    private http: HttpService,
    private auth: AuthDecode,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private router: Router,
    private global: Globals,
    private route: ActivatedRoute,
  ) { }
  @ViewChild("dialogDoc", { static: false }) dialogDoc: any;
  @ViewChild("dialogDate", { static: false }) dialogDate: any;
  @ViewChild("dialogVat", { static: false }) dialogVat: any;
  @ViewChild("dialogInvo", { static: false }) dialogInvo: any;
  @ViewChild("dialogCom", { static: false }) dialogCom: any;
  @ViewChild("dialogPart", { static: false }) dialogPart: any;
  @ViewChild("autocompleteVat", { static: false }) autocompleteVat: AutoCompleteQueryComponent;
  @ViewChild("alertMsg") alert: ElementRef;
  @ViewChild("inputDocument") inputDocument: ElementRef;
  @ViewChild("dialogSPTF", { static: false }) dialogSPTF: any; 
  @ViewChild("dialogKitHis", { static: false }) dialogKitHis: any; 
  public sDocData: any;
  public sDateData: any;
  public sData: any;
  public sVatData: any;
  public sInvoData: any;
  public sComData: any;
  public DisableSave: any = true;
  public ShowDetail = false;
  public PageNo = "";;
  public tableWorkFile: any = [];
  public valid: boolean = false;
  public oldValue: any;
  public ConfirmStatus: any = "";
  public SaveKit: any = false;
  public businessplace: any;
  public editTableHideCols: Array<string> = [];
  public ShowButton : boolean = false;
  public iScancel : boolean = false;
  private tempDataSK : any = [];
  public tableSPTF : any = [];

  public ParamsSearch = {
    DOCUMENT_NO: '',
    DOCUMENT_DATE: null,
    DOCUMENT_DATE_SEARCH: moment(),
    DEST_PORT: null,
    VAT_NAME: null,
    VAT_LOOKUP: null,
    INVOICE_NO: null,
    INVOICE_DATE: null,
    INVOICE_DATE_SEARCH: null,
    DOCUMENT_TYPE: null,
    P_FORM_NO: null,
    VENDOR_CODE: null,
    CONFIRM_STATUS: null
  }

  public ParamsHeadData: any = {};

  public data: any = {};

  public tblFooterDetail35: any = [
    {
      fieldName: "PART_NAME",
      value: "Total",
      show: true
    },
    {
      fieldName: "QUANTITY",
      show: true
    },
    {
      fieldName: "EXP_CLEANRANCE_AMT_B",
      show: true
    },
    {
      fieldName: "EXP_OTHER_AMT_B",
      show: true
    },
    {
      fieldName: "INCOME_TAX",
      show: true
    },
    {
      fieldName: "AMOUNT",
      show: true
    },
    {
      fieldName: "TOTAL",
      show: true
    }]

  public ParamsDetailData = {
    DOCUMENT_TYPE: null,
    DOCUMENT_NO: null,
    ITEM_NO: null,
    CONFIRM_DATE: null,
    VENDOR_CODE: null,
    VENDOR_TYPE: null,
    RETAIL_PRICE_B: null,
    UNIT_PRICE_B: null,
    UNIT_PRICE_C: null,
    NET_AMT_B: null,
    ORDER_NO: null,
    ORDER_DATE: null,
    ORDER_ITEM_NO: null,
    SUB_ITEM_NO: null,
    ORDER_PART_NO: null,
    ACCEPT_PART_NO: null,
    REASON_CODE: null,
    ITEM_QTY: null,
    KIT_FLAG: null,
    SUB_DOC_NO: null,
    JOB_TYPE: null,
    SEQ: null
  }

  public BusnessPlaces: any = [
    '00000', '00001', '00002', '00003', '00004', '00005', '00006', '00007', '00008', '00009', '00010',
    '00011', '00012', '00013', '00014', '00015', '00016', '00017', '00018', '00019', '00020'
  ];


  public ParamsWorkfile = {
    TMP_DOC_NO: null,
    TMP_DOC_DATE: null,
    REASON_CODE: '501',
    REASON_NAME_EN: 'ประกอบเป็นชุดใหญ่'
  }

  public tblFooterWorkFile: any = [
    {
      fieldName: "PART_NAME",
      value: "Total",
      show: true
    },
    {
      fieldName: "QUANTITY",
      value: null,
      show: true
    },
    {
      fieldName: "AMOUNT",
      value: null,
      show: true
    }]

    public tblFooterSPTF: any = [
      {
        fieldName: "DOCUMENT_NO",
        value: "Total",
        show: true
      },
      {
        fieldName: "REVERSE_QTY",
        value: 0,
        show: true
      },
      {
        fieldName: "REVERSE_AMOUNT",
        value: 0,
        show: true
      },
    ]


  //private loaded: boolean = false;
  public tableData: any;
  public tableName: string;
  public PartListData: any = [];
  public SK_SYSTEM_LIST: any = [];
  public ConfigDoc: any = {
    ColName: "DOCUMENT_NO",
    ColValue: "",
    PlaceholderText: "Select Document",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetDoc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: true
  }

  public ConfigVat: any = {
    ColName: "LOOKUP_VAT",
    ColValue: "",
    PlaceholderText: "Select Vat",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetVat",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      INV_DATE: this.data.REF_INV_DATE
    },
  }

  public ConfigInv: any = {
    ColName: "LOOKUP_INV",
    ColValue: "",
    PlaceholderText: "Select Rate",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }


  public ConfigInvSearch: any = {
    ColName: "INVOICE_NO",
    ColValue: "",
    PlaceholderText: "Select Rate",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  public ConfigCom: any = {
    ColName: "SK_SYSTEM_ID",
    ColValue: "SK_SYSTEM_ID",
    PlaceholderText: "Select Company",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetCom",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  public ConfigDocDate: any = {
    ColName: "DOCUMENT_DATE",
    ColValue: "",
    PlaceholderText: "Select Document Date",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetDate",
    NoOfShowRecords: 50,
    MinLengthSearch: 2
  }

  public ConfigReason: any = {
    ColName: "LOOKUP_REASON",
    PlaceholderText: "Select Reason Code",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetReason",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigPart: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Part No.",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetDocPart",
    NoOfShowRecords: 30,
    MinLengthSearch: 3,
    UpperCase: true
  }

  public ConfigVendor: any = {
    ColName: "LOOKUP_VENDOR_NAME",
    ColValue: "",
    PlaceholderText: "Select Vender Code",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetVendor",
    NoOfShowRecords: 50,
    MinLengthSearch: 0
  }

  public ConfigPartKIT: any = {
    ColName: "LOOKUP_PART",
    PlaceholderText: "Select Part No.",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetPartKit",
    NoOfShowRecords: 30
  }

  public selection = new SelectionModel<any>(true, []);
  public paramStock : any = {}
  private tempDocSPTF = []
  public tableKitReceiveHis = []

  ngOnInit() {

    this.ParamsSearch.DOCUMENT_TYPE = "RC";
    this.ParamsSearch.P_FORM_NO = "SNPE018_M";
    this.ConfigDoc.SourceParams = { DOCUMENT_TYPE: "RC" };

    this.businessplace = "";

    this.http.get("AC", "SNPE019_M_GetSKSYSTEM")
      .subscribe(res => {

        this.SK_SYSTEM_LIST = res.Table
      })

      this.ShowDetail = true;
      this.DisableSave = false;
  }

  
  ngAfterViewInit(): void {

    setTimeout(() => {
      this.inputDocument.nativeElement.select();
      this.inputDocument.nativeElement.focus();
    }, 100);
    
  }

  ChenkBusinessplace(event){
     
    if(event.length <= 5){
      let getlenght = 5 - event.length
      switch(getlenght) 
      {
        case 0 :
          this.data.BUSINESS_PLACE = event
          break;
        case 1 :
          this.data.BUSINESS_PLACE = "0" + event
          break;
        case 2 :
          this.data.BUSINESS_PLACE = "00" + event
          break;
        case 3 :
          this.data.BUSINESS_PLACE = "000" + event
          break;
        case 4 :
          this.data.BUSINESS_PLACE = "0000" + event
          break;
        case 5 :
          this.data.BUSINESS_PLACE =  "00000"
          break;
        default:
          this.data.BUSINESS_PLACE = "00000"
          break;
      }
    }else{
      this.data.BUSINESS_PLACE = "00000"
    }
  }

  ClearData(){
      this.ShowDetail = true;
      this.DisableSave = false;
      this.tableData = []
      this.tableWorkFile = []
      this.PartListData = []
      this.data = {}

      setTimeout(() => {
        this.inputDocument.nativeElement.select();
        this.inputDocument.nativeElement.focus();
      }, 100);
  }

  FormatDate(date) {

    let d = new Date(date);
    let Day = d.getDate().toString();
    let NewDay = Day.toString().length < 2 ? '0' + Day.toString() : Day.toString()
    let Month = d.getMonth() + 1;
    let NewMonth = Month.toString().length < 2 ? '0' + Month.toString() : Month.toString()
    let Year = d.getFullYear().toString();
    return Year + NewMonth + NewDay;
  }

  BackToGrid() {
    //this.Search(); 
    this.ConfirmStatus = "";
    this.ParamsSearch.DOCUMENT_DATE_SEARCH = moment()
    this.ParamsSearch.DOCUMENT_NO = null
    this.ParamsSearch.INVOICE_NO = null
    this.ParamsSearch.VENDOR_CODE = null
    this.tableData = [];
    this.ShowDetail = false;
  }

  Search() {
    this.ShowDetail = false;
    this.tableData = [];
    if (this.ParamsSearch.DOCUMENT_DATE_SEARCH) {
      this.ParamsSearch.DOCUMENT_DATE = this.FormatDate(this.ParamsSearch.DOCUMENT_DATE_SEARCH)
    } else {
      this.ParamsSearch.DOCUMENT_DATE = null;
    }
    if (this.ParamsSearch.INVOICE_DATE_SEARCH) {
      this.ParamsSearch.INVOICE_DATE = this.FormatDate(this.ParamsSearch.INVOICE_DATE_SEARCH)
    } else {
      this.ParamsSearch.INVOICE_DATE = null
    }
    this.ParamsSearch.CONFIRM_STATUS = "";
    if (this.ConfirmStatus === "Y") {
      this.ParamsSearch.CONFIRM_STATUS = "Y";
    }
    if (this.ConfirmStatus === "N") {
      this.ParamsSearch.CONFIRM_STATUS = "N";
    }
    this.http.post("AC", "SNPE018_M_GetTransactionHeaderInfo", this.ParamsSearch)
      .subscribe(res => {
        this.tableData = res.Table;
        if (this.ParamsSearch.CONFIRM_STATUS == 'N') {
          this.tableData = this.tableData.filter(x => x.INDENT_STATUS == 'C')
        }

        // console.log(this.tableData)


      })
  }

  ViewClick(event) {
    if (event.CONFIRM_DATE == null && event.CONFIRM_DATE == "" && event.INDENT_STATUS == 'N') {
      this.modal.warning("Cannot confirm. Because this document not to shevle", this.viewref)
    }
    this.data.DOCUMENT_TYPE = event.DOCUMENT_TYPE;
    this.data.DOCUMENT_NO = event.DOCUMENT_NO;
    this.data.DOCUMENT_DATE = this.getDateParam(event.DOCUMENT_DATE);
    //this.ParamsSearch.DOCUMENT_TYPE = event.DOCUMENT_TYPE;
    //this.ParamsSearch.DOCUMENT_NO = event.DOCUMENT_NO;
    this.FindHeadAuto();
    this.ShowDetail = true;
    this.iScancel = false;
  }

  GotoConfirmDocument(){
    this.ShowDetail = true;
    this.iScancel = false;
    this.tableWorkFile = []
    this.PartListData = []
    this.data = {}

    setTimeout(() => {
      this.inputDocument.nativeElement.select();
      this.inputDocument.nativeElement.focus();
    }, 100);
  }

  ValidatePart(autocomplete, event, data) {
    if (this.tableWorkFile.filter(x => x.PART_NO).length > 0) {

      let foundDup = this.tableWorkFile.some(x => x.PART_NO == event.PART_NO)
      let foundQuantity = this.tableWorkFile.some(x => x.PART_NO && !x.QUANTITY)
      if (foundDup) {
        this.modal.warning("P# " + event.PART_NO + " is duplicated!", this.viewref)
        this.valid = false;
      } else if (foundQuantity) {
        this.modal.warning("Please enter the quantity", this.viewref)
        this.valid = false;
      } else {
        let index = this.tableWorkFile.findIndex(x => x.SEQ == data.SEQ)
        this.tableWorkFile[index].PART_NO = event.PART_NO
        this.tableWorkFile[index].PART_NAME = event.PART_NAME_EN
        this.tableWorkFile[index].UNIT_PRICE = event.AVERAGE_COST
        this.valid = false;
        this.tableWorkFile = this.tableWorkFile.slice();
      }
    } else {
      let index = this.tableWorkFile.findIndex(x => x.SEQ == data.SEQ)
      this.tableWorkFile[index].PART_NO = event.PART_NO
      this.tableWorkFile[index].PART_NAME = event.PART_NAME_EN
      this.tableWorkFile[index].UNIT_PRICE = event.AVERAGE_COST
      this.valid = false;
      this.tableWorkFile = this.tableWorkFile.slice();
    }
  }


  Back() {
    this.dialogPart.Close()
  }

  DocDateChange(event) {

  }

  FindDoc() {

  }
  FindHead(evt) {
    this.data.DOCUMENT_NO = evt.DOCUMENT_NO;
    this.data.DOCUMENT_DATE = this.getDateParam(evt.DOCUMENT_DATE);
    this.FindHeadAuto();

    this.dialogDoc.Close();
  }
  BindData() {
    this.PartListData = [];

    if (this.data.STATUS_CODE === "55" && (this.data.CONFIRM_DATE === null || this.data.CONFIRM_DATE === "")) {
      this.DisableSave = false;
    } else {
      this.DisableSave = true;
    }
    this.data.TMP_INV_NO = this.data.REF_INV_NO;
    this.data.TMP_INV_DATE = this.data.REF_INV_DATE;
    // if (this.data.LAST_UPD_BY !== "" && this.data.LAST_UPD_BY !== null) {
    // }
    this.data.TMP_TOT_IMP = 0;
    this.data.TMP_TOT_LOC = 0;
    if (this.data.VENDOR_TYPE === "K" || this.data.VENDOR_TYPE === "J") {
      this.data.TMP_TOT_IMP = this.data.TOTAL_NET_B;
    } else {
      this.data.TMP_TOT_LOC = this.data.TOTAL_NET_B;
    }
    if (!this.data.ATTRIBUTE5) {
      this.data.ATTRIBUTE5 = this.SK_SYSTEM_LIST[0].SK_SYSTEM_ID;
      this.data.TNAME = this.SK_SYSTEM_LIST[0].TNAME;
    }
    this.ConfigVat.SourceParams.INV_DATE = this.data.REF_INV_DATE

    this.http.get("AC", "SNPECOMMON_GetDocPart", this.data.DOCUMENT_TYPE, this.data.DOCUMENT_NO)
      .subscribe(result => {
        this.PartListData = result.Table;

        if (!this.data.CONFIRM_DATE) {
          this.data.DEST_PORT = this.data.ATTRIBUTE3 || "00";
          this.autocompleteVat.textInput = this.data.DEST_PORT;
          this.autocompleteVat.query();
        } else {
          this.data.DEST_PORT = this.data.DEST_PORT;
          this.autocompleteVat.textInput = this.data.DEST_PORT;
          this.autocompleteVat.query();
        }

        setTimeout(() => {
          if (this.data.vendor_type === 'J' || this.data.vendor_type === 'K') {
            this.data.TMP_TOT_IMP = this.data.TOTAL_NET_B;
            this.data.TMP_TOT_LOC = "0";
          } else {
            this.data.TMP_TOT_IMP = "0";
            this.data.TMP_TOT_LOC = this.data.TOTAL_NET_B;
          }
        }, 500);

        let subdocmin = "", subdocmax = "";
        let PartListFilter = this.PartListData.filter(x => x.SUB_DOC_NO)
        PartListFilter.forEach((v, i) => {
          
            if (v.SUB_DOC_NO > subdocmax) {
              subdocmax = v.SUB_DOC_NO;
            }
            if (v.SUB_DOC_NO < subdocmin || i === 0) {
              subdocmin = v.SUB_DOC_NO || '';
            }
          //
        })
        this.data.SUB_DOC_NO = subdocmin + " - " + subdocmax;

      });
  }
  FindHeadAuto() {
    this.http.post("AC", "SNPE018_M_GetTransactionHeader", this.data)
      .subscribe(result => {
       
        if(result.Table.length > 0){
        this.data = result.Table[0];
        this.data.BUSINESS_PLACE = this.data.BUSINESS_PLACE || "00000";

        this.BindData();
        }
        else{
          if(this.data.DOCUMENT_NO){
          this.modal.warning("Document not found",this.viewref)
          }else{
            this.modal.warning("Invoice not found",this.viewref)
          }
        }
      });
  }
  public InvoiceChange(){
    if(this.PartListData.length == 0){
      this.FindHeadAuto();
    }
  }

  FindDate(evt) {
    this.data.DOCUMENT_DATE = evt.DOCUMENT_DATE;
    this.dialogDate.Close();
  }
  FindVat(evt) {
    this.data.DEST_PORT = evt.VAT_CODE;
    this.dialogVat.Close();
  }


  FindInvoAuto(evt, p) {
    // if (p === "a") {
    //   this.data.REF_INV_NO = evt.INVOICE_NO;
    //   this.data.REF_INV_DATE = evt.INVOICE_DATE;
    // }

    if (p === "s") {
      this.ParamsSearch.INVOICE_NO = evt.INVOICE_NO;
    }

  }
  FindCom(evt) {
    this.data.ATTRIBUTE5 = evt.SK_SYSTEM_ID;
    this.data.VENDOR_NAME_TH = evt.TNAME;
    this.dialogCom.Close();
  }
  OpenDocDialog() {
    this.http.post("AC", "SNPECOMMON_GetDoc", this.data)
      .subscribe(result => {
        this.sDocData = result.Table;
        this.dialogDoc.title = "Document No";
        this.dialogDoc.OpenDialog();
      });
  }

  keyupCal(val1, data) {
   
    if (data.QUANTITY !== undefined && val1 !== undefined) {
      if (val1 === "") {
        data.AMOUNT = 0;
      } else {
        data.AMOUNT = parseFloat(val1) * parseFloat(data.QUANTITY);
      }

    }
    this.PartListData = [...this.PartListData];

    this.CalVatTotal();

    setTimeout(() => {
      if (this.data.vendor_type === 'J' || this.data.vendor_type === 'K') {
        this.data.TMP_TOT_IMP = this.data.TOTAL_NET_B;
        this.data.TMP_TOT_LOC = "0";
      } else {
        this.data.TMP_TOT_IMP = "0";
        this.data.TMP_TOT_LOC = this.data.TOTAL_NET_B;
      }
    }, 150);

  }

  OpenDateDialog() {
    var p_date = null;
    if (this.data.DOCUMENT_DATE !== null) {
      p_date = this.data.DOCUMENT_DATE.toISOString().substring(0, 10);
    }
    this.http.get("AC", "SNPECOMMON_GetDate", p_date)
      .subscribe(result => {
        this.sVatData = result.Table;
        this.dialogDoc.title = "Document Date";
        this.dialogDate.OpenDialog();
      });
  }
  OpenVatDialog() {
    this.http.get("AC", "SNPECOMMON_GetVat")
      .subscribe(result => {
        this.sDateData = result.Table;
        this.dialogVat.title = "Vat";
        this.dialogVat.OpenDialog();
      });
  }
  OpenInvoDialog() {
    this.http.get("AC", "SNPECOMMON_GetInv", null, this.data.VENDER_CODE, null)
      .subscribe(result => {
        this.sInvoData = result.Table;
        this.dialogInvo.title = "Invoice";
        this.dialogInvo.OpenDialog();
      });
  }
  OpenComDialog() {
    this.http.get("AC", "SNPECOMMON_GetCom")
      .subscribe(result => {
        this.sComData = result.Table;
        this.dialogCom.title = "Company";
        this.dialogCom.OpenDialog();
      });
  }

  Save() {
    if (!this.data.DEST_PORT) {
      this.modal.warning("Please select Vat Code", this.viewref);
    } else if (!this.data.BUSINESS_PLACE) {
      this.modal.warning("Please select Business Place", this.viewref);
    } else {
      this.modal.confirm('Do you want to save change you have made?', this.viewref, this.ConfirmSave)
    }
  }

  ConfirmSave = () => {
    this.data.CREATE_DATE = new Date();
    this.data.LAST_UPD_PGM = this.PageNo;
    this.data.LAST_UPD_DATE = new Date();
    this.data.REF_DOC_NO = this.getDateParam(this.data.REF_DOC_NO);
    this.data.LAST_IP_ADDR = this.global.GetTokenDetail("ssIPAddress");
    this.data.Detail = this.PartListData;
    this.http.post('AC', 'SNPE018_M_Save', this.data)
      .subscribe(res => {
        if (res.Table[0].STATUS === "DONE") {
          this.ngOnInit();
          //this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.alert.nativeElement.hidden = false
          this.FindHeadAuto();
          this.iScancel = false;
          setTimeout(() => {
            this.alert.nativeElement.hidden = true;
          }, 3000);
          
        }
      
        else if(res.Table[0].STATUS == 'CONFIRMED'){
          this.modal.warning('Someone is working on this document, please try again later',this.viewref)
        }
        else{
          this.modal.error(res.Table[0].MESSAGE, this.viewref);
        }
      },err =>{
        console.log('errr',err)
          this.modal.error('Found an error, please contact support team', this.viewref);
      });
  }


  getDateParam(dt) {
    if (dt !== undefined) {
      dt = new Date(dt)
      let year = dt.getFullYear();
      let month = (1 + dt.getMonth()).toString().padStart(2, '0');
      let day = dt.getDate().toString().padStart(2, '0');
      var p_Date = year + '-' + month + '-' + day;
      return p_Date;
    }
  }
  AppendRow() {
    for (var i = 0; i < this.tableWorkFile.length; i++) {
      if (this.tableWorkFile[i].EDIT === "ADD") {
        this.tableWorkFile[i].EDIT = 'DEL';
        this.tableWorkFile[i].ITEM_NO = this.tableWorkFile.length;
      }
    }
    this.tableWorkFile = [...this.tableWorkFile, { 'EDIT': 'ADD', 'ITEM_NO': '' }];

  }
  DeleteRow(Item) {
    // for (var i = 0; i < this.tableWorkFile.length; i++) {
    //   if (this.tableWorkFile[i].ITEM_NO === Item) {
        
    //     this.tableWorkFile[i].FLAG = 'DEL';
    //     this.tempDataSK.push(this.tableWorkFile[i])
    //     this.tableWorkFile.splice(i, 1);
    //   }
    // }

    if(this.tableWorkFile[Item].PART_NO){
      this.tableWorkFile[Item].FLAG = 'DEL';
    }

   
    this.tableWorkFile.splice(Item, 1);
    this.tblFooterWorkFile[2].value = this.tableWorkFile.reduce((prev, next) => prev + (next.AMOUNT || 0),0);
    this.tableWorkFile = [...this.tableWorkFile];
  }

  GetPartKit(evt, data, index) {
    this.selection.clear()
    this.tblFooterSPTF[1].value = 0
    this.tblFooterSPTF[2].value = 0
    if(evt.PART_NO){
    var found = this.tableWorkFile.find((element, i) => index != i && element.PART_NO == evt.PART_NO);
    if (found !== undefined) {
      this.modal.warning("P# " + evt.PART_NO + " is duplicated!", this.viewref)
      this.tableWorkFile[index].PART_NO = null;
      this.tableWorkFile[index].PART_NAME = null;
      this.tableWorkFile[index].QUANTITY = null;
      this.tableWorkFile[index].OH_QTY = null;
      this.tableWorkFile[index].UNIT_PRICE = null;
      this.tableWorkFile[index].AMOUNT = null;
      return;
    }

    this.http.post("AC","SNPE018_M_Find_SP_TF",evt)
    .subscribe(res =>{
      
      this.tableSPTF = res.Table;

      if(this.tableSPTF.length > 0){
          this.dialogSPTF.OpenDialog();
          this.paramStock.SUSPEND_QTY = evt.SUSPEND_QTY
          this.paramStock.TRANSFER_QTY = evt.TRANSFER_QTY
          this.tableWorkFile[index].PART_NO = evt.PART_NO;
          this.tableWorkFile[index].PART_NAME = evt.PART_NAME;
          this.tableWorkFile[index].QUANTITY = 0;
          this.tableWorkFile[index].TEMP_OH_QTY = evt.OH_QTY;
          this.tableWorkFile[index].OH_QTY = evt.OH_QTY;
          this.tableWorkFile[index].UNIT_PRICE = evt.UNIT_PRICE;
          this.tableWorkFile[index].AMOUNT = evt.AMOUNT;
          this.tblFooterWorkFile[2].value = this.tableWorkFile.reduce((prev, next) => prev + (next.AMOUNT || 0),0);
          this.tableWorkFile = [...this.tableWorkFile];
          setTimeout(() => {
            this.AppendRow();
          }, 100);
      }else{
          this.modal.warning("This part "+ evt.PART_NO +" not have suspend qty and transfers qty",this.viewref)
          this.tableWorkFile[index].PART_NO = null;
          this.tableWorkFile[index].PART_NAME = null;
          this.tableWorkFile[index].QUANTITY = null;
          this.tableWorkFile[index].OH_QTY = null;
          this.tableWorkFile[index].UNIT_PRICE = null;
          this.tableWorkFile[index].AMOUNT = null;
      }
    })
    }else{
      this.tableWorkFile[index].PART_NO = null;
      this.tableWorkFile[index].PART_NAME = null;
      this.tableWorkFile[index].QUANTITY = null;
      this.tableWorkFile[index].OH_QTY = null;
      this.tableWorkFile[index].UNIT_PRICE = null;
      this.tableWorkFile[index].AMOUNT = null;
    }
  }

  public ReverseQtyChange(event,data){
    
    if(event > data.NET_QTY){
      this.modal.warning("Revers qty cannot more than net qty",this.viewref)
      data.REVERSE_QTY = data.NET_QTY
    }

    this.tblFooterSPTF[1].value = this.selection.selected.reduce((prev, next) => prev + (next.REVERSE_QTY || 0),0);
    this.tblFooterSPTF[2].value = this.selection.selected.reduce((prev, next) => prev + ((next.REVERSE_QTY || 0) * (next.UNIT_PRICE)),0);
    this.tableSPTF = this.tableSPTF.slice();
    
  }

  public AcceptSelectedSPTF(){


    if(this.selection.selected.length > 0){

      let find = this.selection.selected.some(x => x.REVERSE_QTY <= 0 || x.REVERSE_QTY == null)
      if(find){
        this.modal.warning("Revers qty must be more than 0",this.viewref)
        return;
      }


      let part_no = this.selection.selected[0].ACCEPT_PART_NO
      let total_revers = this.selection.selected.reduce((prev, next) => prev + (next.REVERSE_QTY || 0),0);
      let index = this.tableWorkFile.findIndex(x => x.PART_NO == part_no)

      this.tableWorkFile[index].OH_QTY = this.tableWorkFile[index].TEMP_OH_QTY + total_revers
      this.tableWorkFile[index].QUANTITY = total_revers
      this.tableWorkFile[index].AMOUNT = this.global.Round(this.tableWorkFile[index].UNIT_PRICE * total_revers,2)
      this.tblFooterWorkFile[2].value = this.tableWorkFile.reduce((prev, next) => prev + (next.AMOUNT || 0),0);
      this.tableWorkFile = [...this.tableWorkFile];

      this.tempDocSPTF = this.tempDocSPTF.filter(x =>  x.ACCEPT_PART_NO != part_no)

      Array.prototype.push.apply(this.tempDocSPTF,this.selection.selected); 
      
      this.selection.clear()
      this.dialogSPTF.Close();
    }else{
      this.modal.warning("Please select data",this.viewref);
    }

  }

  keyupCalQ(evt, data) {
    if (data.QUANTITY > data.OH_QTY) {
      data.QUANTITY = data.OH_QTY;
      this.tableWorkFile = [...this.tableWorkFile];
      this.modal.warning('Item Qty cannot more than balance', this.viewref,
        () => {
          evt.target.focus();
        })
    }
    data.AMOUNT = (parseFloat(data.QUANTITY) * parseFloat(data.UNIT_PRICE)) || 0;
    this.tblFooterWorkFile[2].value = this.tableWorkFile.reduce((prev, next) => prev + (next.AMOUNT || 0),0);
    this.tableWorkFile = [...this.tableWorkFile];
  }

  isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tableSPTF.length;
    return numSelected === numRows;
  }

  Toggle() {
    this.isAllSelected() ?
      this.selection.clear() :
      this.tableSPTF.forEach(row => this.selection.select(row));

    this.tblFooterSPTF[1].value = this.selection.selected.reduce((prev, next) => prev + (next.REVERSE_QTY || 0),0);
    this.tblFooterSPTF[2].value = this.selection.selected.reduce((prev, next) => prev + ((next.REVERSE_QTY || 0) * (next.UNIT_PRICE)),0);
    this.tableSPTF = this.tableSPTF.slice();
  }

  CheckboxChange() {

    this.tblFooterSPTF[1].value = this.selection.selected.reduce((prev, next) => prev + (next.REVERSE_QTY || 0),0);
    this.tblFooterSPTF[2].value = this.selection.selected.reduce((prev, next) => prev + ((next.REVERSE_QTY || 0) * (next.UNIT_PRICE)),0);
    this.tableSPTF = this.tableSPTF.slice();
  }

  KitFlagIsY(p_data) {
    this.tempDataSK = []
    //if (this.DisableSave=== false) {
    this.tblFooterWorkFile[2].value = 0;
    this.tableWorkFile = [];
    this.ParamsDetailData = p_data;
    this.ParamsDetailData.ORDER_NO = p_data.PO_NO
    this.ParamsDetailData.ORDER_ITEM_NO = p_data.ORDER_ITEM_NO;
    this.ParamsDetailData.SUB_ITEM_NO = p_data.SUB_ITEM;
    this.ParamsDetailData.VENDOR_CODE = this.data.VENDOR_CODE;
    this.ParamsDetailData.VENDOR_TYPE = this.data.VENDOR_TYPE;
    this.ParamsDetailData.DOCUMENT_NO = this.data.DOCUMENT_NO;
    this.SaveKit = false;
    // this.ConfigPartKIT.SourceParams = { DOCUMENT_NO: this.data.DOCUMENT_NO };
    if (!this.data.CONFIRM_DATE) {
      this.http.post("AC", "SNPE018_M_GetWorkfile", this.ParamsDetailData)
        .subscribe(res => {
          
          this.tempDocSPTF = res.Table1

          if (res.Table.length > 0) {
            this.tableWorkFile = res.Table;
            for (var i = 0; i < this.tableWorkFile.length; i++) {
              this.tableWorkFile[i].EDIT = 'DEL';
            }
            this.tableWorkFile = [...this.tableWorkFile, { 'EDIT': 'ADD', 'ITEM_NO': '' }];
            this.ParamsWorkfile.TMP_DOC_NO = "New SK";
            this.ParamsWorkfile.TMP_DOC_DATE = new Date();
            this.tblFooterWorkFile[2].value = this.tableWorkFile.reduce((prev, next) => prev + (next.AMOUNT || 0),0);
          }
          else {
            this.ParamsWorkfile.TMP_DOC_NO = "New SK";
            this.ParamsWorkfile.TMP_DOC_DATE = new Date();
            this.tableWorkFile = [];
            this.tableWorkFile = [...this.tableWorkFile, { 'EDIT': 'ADD', 'ITEM_NO': '' }];
            this.AppendRow();
          }

         
        })
      
      this.dialogPart.title = "Part Kit";
      this.dialogPart.OpenDialog();
      // }
    } else {

      this.http.post("AC", "SNPE018_M_GetKit", this.ParamsDetailData)
        .subscribe(res => {
          if (res.Table.length > 0) {
            this.tableWorkFile = res.Table;
            // for (var i = 0; i < this.tableWorkFile.length; i++) {
            //   this.tableWorkFile[i].EDIT = 'DEL';
            // }
            this.ParamsWorkfile.TMP_DOC_NO = this.ParamsDetailData.SUB_DOC_NO;
            this.ParamsWorkfile.TMP_DOC_DATE = this.tableWorkFile[0]?.DOCUMENT_DATE;
            this.tblFooterWorkFile[2].value = this.tableWorkFile.reduce((prev, next) => prev + (next.AMOUNT || 0),0);
          }
          else {
            this.ParamsWorkfile.TMP_DOC_NO = this.ParamsDetailData.SUB_DOC_NO;
            this.ParamsWorkfile.TMP_DOC_DATE = this.tableWorkFile[0]?.DOCUMENT_DATE;
            this.tableWorkFile = [];
          }
        })

      
      this.dialogPart.title = "Part Kit";
      this.dialogPart.OpenDialog();
    }

    //this.dialogPart.OpenDialog();
  }

  AcceptKitFlag() {
    if (this.tableWorkFile.length > 0) {
      let headParam : any = {}
      let param = this.tableWorkFile.filter(x => x.PART_NO)
      param.map((x) => {
        x.TD_ORDER_NO = this.ParamsDetailData.ORDER_NO
        x.TD_ORDER_ITEM_NO = this.ParamsDetailData.ORDER_ITEM_NO
        x.TD_SUB_ITEM_NO = this.ParamsDetailData.SUB_ITEM_NO
        x.TD_VENDOR_CODE = this.ParamsDetailData.VENDOR_CODE
        x.TD_VENDOR_TYPE = this.ParamsDetailData.VENDOR_TYPE
        x.REASON_CODE = this.ParamsWorkfile.REASON_CODE
        x.REASON_DESC = this.ParamsWorkfile.REASON_NAME_EN
        x.RC_ITEM_NO = this.ParamsDetailData.ITEM_NO
        x.TOT_QUANTITY = param.reduce((sum, currentValue) => { return sum + parseFloat(currentValue.QUANTITY); }, 0);
        x.TOT_AMOUNT = param.reduce((sum, currentValue) => { return sum + (parseFloat(currentValue.UNIT_PRICE) * parseFloat(currentValue.QUANTITY)); }, 0);
      })

      let find = param.some(x => x.QUANTITY < 1)
      if(find){
        this.modal.warning("Quantity can not less than 1",this.viewref)
        return
      }

      let completeData = []
      if(param.length !== 0){
        completeData = this.tempDocSPTF.filter((x) => param.find(({ PART_NO }) => x.ACCEPT_PART_NO === PART_NO));
      }

      headParam.TD_ORDER_NO = this.ParamsDetailData.ORDER_NO
      headParam.TD_ORDER_ITEM_NO = this.ParamsDetailData.ORDER_ITEM_NO
      headParam.TD_SUB_ITEM_NO = this.ParamsDetailData.SUB_ITEM_NO
      headParam.Detail = param
      headParam.RC_NO = this.data.DOCUMENT_NO
      headParam.RC_ITEM_NO = this.ParamsDetailData.ITEM_NO
      headParam.Detail_SPTF = completeData


      this.http.post("AC", "SNPE018_M_AcceptKitFlag", headParam)
        .subscribe(res => {
          if (res.Table[0].STATUS !== "Fail") {
            this.modal.info('Transaction complete: applied and saved.', this.viewref);
            //       this.ParamsWorkfile.TMP_DOC_NO = this.data.DOCUMENT_NO;
            this.ParamsWorkfile.TMP_DOC_DATE = new Date();
            this.SaveKit = true;
            this.dialogPart.Close();
          }
        }, (err) => {

          this.modal.error(err.message, this.viewref,() =>{},{width :'700px',height : '320px'})
        })
    } else {
      this.modal.warning("No Part select", this.viewref)
    }

  }

  public ShowReverseDetail(kitdata){

    
    let param = {
      RC_NO : this.data.DOCUMENT_NO,
      RC_ITEM_NO : this.ParamsDetailData.ITEM_NO,
      ACCEPT_PART_NO : kitdata.PART_NO
    }

    this.http.post("AC","SNPE018_M_GetReceiveKitHis",param)
    .subscribe(res => {
      this.tableKitReceiveHis = res.Table
      this.dialogKitHis.OpenDialog();
    })
  }


  AddRow() {
    this.tableWorkFile.push({
      PART_NAME: null,
      PART_NO: null,
      QUANTITY: null,
      REASON_CODE: null,
      ITEM_NO: this.tableWorkFile.length + 1,
      TMP_DOC_DATE: null,
      TMP_DOC_NO: null,
      UNIT_PRICE: null,
      AMOUNT: 0
    })
    this.tableWorkFile = this.tableWorkFile.slice();
  }

  QuantityChange(oldValue, event, data) {
    // console.log('eeee',oldValue,event,data)
    let param = {
      PART_NO: data.PART_NO,
      QUANTITY: data.QUANTITY
    }
    this.http.post("AC", "SNPE018_M_CheckQty", param)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Fail') {
          this.modal.error(res.Table[0].MSG, this.viewref);
          this.valid = false;
        } else {
          this.valid = true;
        }
        this.tblFooterWorkFile[2].value = this.tableWorkFile.reduce((prev, next) => prev + (next.AMOUNT || 0),0);
        this.tableWorkFile = this.tableWorkFile.slice();
      })

  }

 

  Cancel() {
    this.modal.confirm('Do you want to Cancel?', this.viewref, this.ConfirmCancel)
  }
  ConfirmCancel = () => {
    
    this.http.post('AC', 'SNPE018_M_Cancel', this.data)
      .subscribe(res => {
        if (res.STATUS_MESSAGE == "DONE") {
          this.ngOnInit();
          this.modal.info('Cancel document complete', this.viewref);
          this.FindHeadAuto();
          this.iScancel = true;
        }else if(res.STATUS_MESSAGE == 'HAVE_TRANSACTON'){
          this.modal.info('This document cannot be canceled because parts in this document has been issued!', this.viewref);
        }else{
          this.modal.error('Found an error, please contact support team', this.viewref);
        }
      },err =>{
        this.modal.error('Found an error, please contact support team', this.viewref);
      });
  }


  SelectedVatCode(event) {
    this.data.DEST_PORT = event.VAT_CODE;
    this.data.VAT_DESC = event.VAT_DESC;
    this.data.VAT_FLAG = event.VAT_FLAG;
    this.data.VAT_RATE = event.VAT_RATE;
    this.data.TAX_FLAG = event.TAX_FLAG;
    this.data.TAX_RATE = event.TAX_RATE;
  }

  CalVatTotal() {

    this.data.TOTAL_NET_B = 0;
    this.data.TOTAL_VAT = 0;
    this.data.WHT_AMOUNT = 0;

    this.PartListData.forEach(x => {
      this.data.TOTAL_NET_B += x.AMOUNT
      //this.data.TOTAL_VAT += x.AMOUNT * (this.data.VAT_RATE / 100);
      //this.data.WHT_AMOUNT += x.AMOUNT * this.data.TAX_RATE
    });
    
    this.data.TOTAL_NET_B = this.global.Round(this.data.TOTAL_NET_B,2)
    setTimeout(() => {
      this.data.TOTAL_VAT = this.global.Round(this.data.TOTAL_NET_B * (this.data.VAT_RATE / 100),2);
      this.data.WHT_AMOUNT = this.data.TOTAL_NET_B * (this.data.TAX_RATE / 100)
    }, 100);

    //console.log('this.data.WHT_AMOUNT',this.data.WHT_AMOUNT)
  }

  TotalQty() {
    return this.PartListData.reduce((a, b) => a + (b.QUANTITY || 0), 0);
  }
  

  TotalExpense() {
    return this.PartListData?.reduce((a, b) => a + (b.MATERIAL_COST || 0), 0);
  }

  GrandTotal(){
    return this.data.TOTAL_NET_B + this.data.TOTAL_VAT + this.TotalExpense()
  }
  public ExportExcel(){


    let Data = {
      Table : this.tableData,
      ScreenID : "SNPE018_M"
    }
    this.http.Download("AC","Account_Receive_Download",Data)
    .subscribe(res =>{
      this.writeContents(res);
    })
  }

  private writeContents(content) {
    var currentDate = moment().format('DD-MM-YYYY');
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNPE018_M_" + currentDate + ".xlsx" ;
    a.click();
  }
}



