import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { ModalService } from '../../../core/modal.service';
import { NgForm } from '@angular/forms';
import * as moment from 'moment';
import { Globals } from 'src/app/core/global';
import { I } from '@angular/cdk/keycodes';

@Component({
  selector: 'SNPE020_OUM',
  templateUrl: './SNPE020_OUM.component.html',
  styleUrls: ['./SNPE020_OUM.component.css']
})

export class SNPE020_OUMComponent implements OnInit {


  constructor(
    private http: HttpService,
    private auth: AuthDecode,
    private viewref: ViewContainerRef,
    private modal: ModalService,
    private router: Router,
    private global: Globals
  ) { }
  public params: any = {
    DOCUMENT_DATE: moment()
  }
  public data: any = {};

  public BusinessPlaces: any = [
    '00000', '00001', '00002', '00003', '00004', '00005', '00006', '00007', '00008', '00009',
    '00010', '00011', '00012', '00013', '00014', '00015', '00016', '00017', '00018', '00019',
    '00020'
  ];

  public tblFooterDetail: any = [
    {
      fieldName: "QUANTITY",
      // value: false,
      show: true
    },
    {
      fieldName: "UNIT_PRICE",
      // value: false,
      show: true
    },
    {
      fieldName: "AMOUNT",
      // value: false,
      show: true
    }]
  public Flags: any = [
    { value: 'Y', viewValue: 'Yes' },
    { value: 'N', viewValue: 'No' }
  ];

  public tableData: any = [];
  public MainDatatable: any;
  public sDocData: any;
  public sReasonData: any;
  public sBranchData: any;
  public sPartData: any;
  public IsSearch: any = true;
  public CantDelivery: any = true;
  public IsAdd = false;
  public IsSaved = true;
  public IsRefDoc = true;
  public cantPart: any = true;
  public confirmHeader: boolean = false;

  @ViewChild("headerForm") headerForm: NgForm;

  ngOnInit() {
  }

  public ConfigDocType: any = {
    ColName: "LOOKUP_DOC_TYPE",
    PlaceholderText: "Select Document Type",
    SourceController: "AC",
    SourceMethodName: "SNPE020_OUM_GetDocType",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigRefDocType: any = {
    ColName: "LOOKUP_DOC_TYPE",
    PlaceholderText: "Select Ref Document Type",
    SourceController: "AC",
    SourceMethodName: "SNPE020_OUM_GetRefDocType",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigDoc: any = {
    ColName: "DOCUMENT_NO",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNPE020_OUM_GetDoc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: false
  }


  public ConfigRefDoc: any = {
    ColName: "LOOKUP_PART_NAME",
    PlaceholderText: "Select Ref Document No",
    SourceController: "AC",
    SourceMethodName: "SNPE020_OUM_Get_Ref_Doc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: true
  }

  public ConfigReason: any = {
    ColName: "REASON_CODE",
    ColValue: "REASON_CODE",
    PlaceholderText: "Select Reason Code",
    SourceController: "AC",
    SourceMethodName: "SNPE020_OUM_GetReason",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigReasonAdd: any = {
    ColName: "LOOKUP_REASON",
    PlaceholderText: "Select Reason Code",
    SourceController: "AC",
    SourceMethodName: "SNPE020_OUM_GetReason",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigVender: any = {
    ColName: "LOOKUP_VENDOR",
    PlaceholderText: "Select Vender",
    SourceController: "AC",
    SourceMethodName: "SNPE020_OUM_GetVender",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigPart: any = {
    ColName: "LOOKUP_PART",
    PlaceholderText: "Select Part",
    SourceController: "AC",
    SourceMethodName: "SNPE020_OUM_GetPart",
    NoOfShowRecords: 30,
    UseMinLengthSearch: true,
    MinLengthSearch: 0,
    UpperCase: true
  }

  GetDoc(Doc, t) {
    if (t === "s") {
      this.params.DOCUMENT_NO = Doc.DOCUMENT_NO;
    }
  }
  GetDocType(Doc, t) {
    if (t === "a") {
      this.data.DOCUMENT_TYPE = Doc.DOCUMENT_TYPE;
      this.data.DOC_TYPE_DESC = Doc.DOC_NAME;
      this.data.VAT_FLAG = Doc.VAT_FLAG;
    }
    if (t === "r") {
      this.data.REF_DOC_TYPE = Doc.DOCUMENT_TYPE;
      this.ConfigRefDoc.SourceParams = {};
      this.ConfigRefDoc.SourceParams = { REF_DOC_TYPE: this.data.REF_DOC_TYPE };
      this.IsRefDoc = false;
    }
  }

  GetDocRef(Doc) {
    this.data.REF_DOC_NO = Doc.DOCUMENT_NO;
    this.data.REF_INV_NO = Doc.REF_INV_NO;
    this.data.REF_INV_DATE = Doc.REF_INV_DATE;
    this.data.VENDOR_CODE = Doc.VENDOR_CODE;
    this.data.VENDER_DESC = Doc.VENDOR_NAME_EN;
    this.data.BUSINESS_PLACE = Doc.BUSINESS_PLACE;
    this.data.VAT_FLAG = Doc.VAT_FLAG
    this.ConfigPart.SourceParams = { REF_DOC_NO: this.data.REF_DOC_NO };
    this.cantPart = false;
    this.ChangeFlag();
    this.GetPartListDetail();
  }
  GetRefDoc(Doc) {
    this.data.REF_DOC_NO = Doc;
  }
  GetReason(Rea, t) {
    if (t === "s") {
      this.params.REASON_CODE = Rea;
    }
    if (t === "a") {
      this.data.REASON_CODE = Rea.REASON_CODE;
      this.data.DSP_REASON = Rea.REASON_DESC;
    }

  }
  GetCus(Cus) {
    this.params.CUSTOMER_CODE = Cus
  }
  public GetPartListDetail(){
    this.http.post("AC","SNPE020_OUM_GetPartListDetail",{REF_DOC_NO : this.data.REF_DOC_NO})
    .subscribe(res => {
      this.tableData = res.Table
      this.tableData.map(x =>{
        x.PART_NAME = x.PART_NAME_EN;
        x.UNIT_PRICE = x.UNIT_PRICE_B;
        x.TOTAL_RETURN = x.TOTAL_SUM_RETURN;
        x.RETURN_BALANCE = x.TOTAL_QTY - x.TOTAL_SUM_RETURN;
        x.QUANTITY = x.OH_QTY > x.RETURN_BALANCE ? x.RETURN_BALANCE : x.OH_QTY;
        x.TOTAL_RETURN = x.TOTAL_SUM_RETURN;
        if(this.data.DOCUMENT_TYPE != 'RJ'){
          x.QUANTITY = x.RETURN_BALANCE
        }
      })
      if(this.data.DOCUMENT_TYPE != 'RJ'){
        let filter = this.tableData.filter((v, i, s) => this.global.findUnique(v, i, s, "PART_NO"));
        filter.map(x =>{
          x.RETURN_BALANCE = this.tableData.filter(k=> k.PART_NO == x.PART_NO).reduce((prev, next) => prev + (next.RETURN_BALANCE || 0),0);
          x.QUANTITY = this.tableData.filter(k=> k.PART_NO == x.PART_NO).reduce((prev, next) => prev + (next.QUANTITY || 0),0);
          x.TOTAL_RETURN = this.tableData.filter(k=> k.PART_NO == x.PART_NO).reduce((prev, next) => prev + (next.TOTAL_RETURN || 0),0);
        })
        this.tableData = filter;
      }
    })
  }
  GetPart(evt, data, index) {
    if (evt) {
      if (this.tableData.find((v, i) => i !== index && v.EDIT === 'EDIT' && v.PART_NO === evt.PART_NO)) {
        this.modal.warning("Duplicate Part number!", this.viewref)
        data.PART_NO = null;
      } else {

        data.PART_NO = evt.PART_NO;
        data.PART_NAME = evt.PART_NAME_EN;
        data.ORDER_NO = evt.ORDER_NO;
        data.UNIT_PRICE = evt.UNIT_PRICE_B;
        data.UNIT_PRICE_B = evt.UNIT_PRICE_B;
        data.OH_QTY = evt.OH_QTY;
        data.TOTAL_RETURN = evt.TOTAL_SUM_RETURN;
        data.RETURN_BALANCE = evt.TOTAL_QTY - evt.TOTAL_SUM_RETURN;
        data.QUANTITY = data.OH_QTY > data.RETURN_BALANCE ? data.RETURN_BALANCE : data.OH_QTY;
        data.TOTAL_RETURN = evt.TOTAL_SUM_RETURN;
        data.BALANCE_CN = evt.BALANCE_CN

        if(this.data.DOCUMENT_TYPE == 'CN'){
          if(evt.UNIT_PRICE_B !== evt.BALANCE_CN){
            this.modal.warning("This parts has been document DN. Do you want to continue the transaction?",this.viewref)
            //data.UNIT_PRICE = evt.BALANCE_CN
          }
        }
        if(this.data.DOCUMENT_TYPE != 'RJ'){
          data.QUANTITY = data.RETURN_BALANCE
        }

        // if(this.data.DOCUMENT_TYPE == 'CN'){
        //   if(evt.UNIT_PRICE_B !== evt.BALANCE_CN){
        //     this.modal.warning("This parts has been document DN. Do you want to continue the transaction?",this.viewref)
        //     data.UNIT_PRICE = evt.BALANCE_CN
        //   }else{
        //     data.UNIT_PRICE = evt.UNIT_PRICE_B;
        //   }
        // }else{
        //   data.UNIT_PRICE = evt.UNIT_PRICE_B;
        // }

        // if(this.data.DOCUMENT_TYPE = 'RJ'){
        //   data.QUANTITY = data.OH_QTY > data.RETURN_BALANCE ? data.RETURN_BALANCE : data.OH_QTY;
        //   data.TOTAL_RETURN = evt.TOTAL_SUM_RETURN;
        //   data.RETURN_BALANCE = evt.TOTAL_QTY - evt.TOTAL_SUM_RETURN;
        // }else{
        //   data.QUANTITY = data.OH_QTY;
        //   data.TOTAL_RETURN = 0;
        //   data.RETURN_BALANCE = evt.TOTAL_QTY;
        // }
        
      }
    }
  }

  CheckQty(data) {
    if (data.QUANTITY > data.OH_QTY) {
      this.modal.warning("OH Qty less than input Qty.", this.viewref);
      data.QUANTITY = data.OH_QTY > data.RETURN_BALANCE ? data.RETURN_BALANCE : data.OH_QTY;
      return;
    }
    if (data.QUANTITY > data.RETURN_BALANCE) {
      this.modal.warning("Qty Balance less than input Qty.", this.viewref);
      data.QUANTITY = data.OH_QTY > data.RETURN_BALANCE ? data.RETURN_BALANCE : data.OH_QTY;
      return;
    }
  }

  CheckUnitPrice(data,event){
  
    if(this.data.DOCUMENT_TYPE == 'CN'){
      if(event > data.BALANCE_CN){
        this.modal.warning("You cannot input price " + event + " due to there is document type CN.So, you can input price from 0 - "+data.BALANCE_CN+".",this.viewref)
        data.UNIT_PRICE = data.UNIT_PRICE_B
      }
    }
  
  }


  ChangeFlag() {
    if (this.data.VAT_FLAG === "N") {
      this.data.VAT_RATE = "0";
    } else {
      this.LoadVat();
    }

  }

  LoadVat() {
    this.http.get("AC", "SNPE020_OUM_GetRate")
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.data.VAT_RATE = result.Table[0].VAT_RATE;
        }
      });
  }

  DeliveryChange(evt) {
    this.data.BUSINESS_PLACE = evt.value;
  }

  AddNew() {
    this.IsSearch = false;
    this.IsAdd = true;
    this.IsSaved = false;
    this.confirmHeader = false;
    this.data = {};
    this.data.DOCUMENT_DATE = moment();
    this.data.VAT_RATE = "0.00";
    this.data.VAT_FLAG = "Y";
    this.data.JOB_TYPE = "3";
    this.data.BUSINESS_PLACE = this.BusinessPlaces[0];
    this.data.LAST_UPD_DATE = new Date();
    this.data.LAST_UPD_NAME = this.global.GetTokenDetail("ssNameEN");
    this.tableData = [];
    this.LoadVat();
    this.CreateDetailRow(0);
  }

  Search() {
    this.params._DOCUMENT_DATE = this.global.ConvertDateToFormatSTD(this.params.DOCUMENT_DATE);

    this.http.post("AC", "SNPE020_OUM_GetList", this.params)
      .subscribe(result => {
        this.MainDatatable = result.Table;
      });
  }

  Edit(P_data) {
    this.data = {}
    this.tableData = [];
    this.IsSearch = false;
    this.IsAdd = false;
    this.IsSaved = true;
    this.confirmHeader = true;

    this.http.get("AC", "SNPE020_OUM_GetHead", P_data.DOCUMENT_NO)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.data = result.Table[0];
          this.http.get("AC", "SNPE020_OUM_GetDetailList", P_data.DOCUMENT_NO)
            .subscribe(result => {
              if (result.Table.length > 0) {
                this.tableData = result.Table;
              }
            });
        }
      });
  }

  CheckHeaderValid(tblIndex) {
    if (this.headerForm.valid && this.tableData[tblIndex].PART_NO) {
      this.CreateDetailRow(tblIndex);

      return true;
    }

    return false;
  }

  CreateDetailRow(tblIndex) {
    let currentMaxRow: number = this.tableData.length || 0;
    let nextMaxRow: number = (Math.floor(currentMaxRow / 10) + 1) * 10;

    if (currentMaxRow - tblIndex <= 2) {
      for (let i = currentMaxRow; i < nextMaxRow; i++) {
        this.tableData.push({
          EDIT: 'EDIT'
        });
      }

      this.tableData = [...this.tableData];
    }

  }


  ChenkBusinessplace(event){
    
    if(event.length <= 5){
      let getlenght = 5 - event.length
      switch(getlenght) 
      {
        case 0 :
          this.data.BUSINESS_PLACE = event
          break;
        case 1 :
          this.data.BUSINESS_PLACE = "0" + event
          break;
        case 2 :
          this.data.BUSINESS_PLACE = "00" + event
          break;
        case 3 :
          this.data.BUSINESS_PLACE = "000" + event
          break;
        case 4 :
          this.data.BUSINESS_PLACE = "0000" + event
          break;
        case 5 :
          this.data.BUSINESS_PLACE =  "00000"
          break;
        default:
          this.data.BUSINESS_PLACE = "00000"
          break;
      }
    }else{
      this.data.BUSINESS_PLACE = "00000"
    }
  }

  DeleteRow(index) {
    if (this.IsAdd) {
      this.modal.confirm("Are you sure to remove this row?", this.viewref,
        () => {
          this.tableData.splice(index, 1);
          this.tableData = [...this.tableData];
        }, () => { })
    }
  }

  Save() {
    if (this.headerForm.valid) {
      let detailRows = this.tableData.filter(v => v.PART_NO)

      if (detailRows.length <= 0) {
        this.modal.warning("Please select at least 1 Parts.", this.viewref)
        return;
      }
      const uniqueValues = new Set(detailRows.map(v => v.PART_NO));
      if (uniqueValues.size < detailRows.length) {
        this.modal.warning("Found duplicate Part number!, please check", this.viewref)
        return;
      }
      if (detailRows.find(v => v.EDIT === "EDIT" && ((!v.QUANTITY || v.QUANTITY === 0) || (!v.UNIT_PRICE || v.UNIT_PRICE === 0)))) {
        this.modal.warning("Some record in transaction detail have unfinished detail.", this.viewref);
        return;
      }
      this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSave);
    } else {
      this.modal.warning("Please fill all required(*) fields.", this.viewref);
    }
  }

  ConfirmSave = () => {
    let detailRows = this.tableData.filter(v => v.PART_NO)

    this.data._DOCUMENT_DATE = this.global.ConvertDateToFormatSTD(this.data.DOCUMENT_DATE);
    if (this.data.REF_INV_DATE) {
      this.data._REF_INV_DATE = this.global.ConvertDateToFormatSTD(this.data.REF_INV_DATE);
    }
    if (this.data.REF_OTHER_DATE) {
      this.data._REF_OTHER_DATE = this.global.ConvertDateToFormatSTD(this.data.REF_OTHER_DATE);
    }
    this.data.PART_LIST = [];
    this.data.PART_LIST = detailRows;
    this.http.post("AC", "SNPE020_OUM_Save", this.data)
      .subscribe(res => {
        this.IsSaved = true;
        this.data.DOCUMENT_NO = res.DOCUMENT_NO;
        this.Edit(this.data);
        this.modal.info('Transaction complete: applied and saved.', this.viewref);
      }, err => {
        this.modal.error(err.error, this.viewref);
      });
  }
  getDateParam(dt) {
    if (dt !== undefined) {
      dt = new Date(dt)
      let year = dt.getFullYear();
      let month = (1 + dt.getMonth()).toString().padStart(2, '0');
      let day = dt.getDate().toString().padStart(2, '0');
      var p_Date = year + '-' + month + '-' + day;
      return p_Date;
    }
  }

  Cancel() {
    this.IsSearch = true;
  }
  BackToGrid() {
    this.IsSearch = true;
  }


  CalTotalQTY() {
    return this.tableData.reduce((prev, currObj) => prev + parseFloat(currObj.QUANTITY || 0), 0);
  }

  CalTotalAmount() {
    return this.tableData.reduce((prev, currObj) => prev + (parseFloat(currObj.QUANTITY || 0) * parseFloat(currObj.UNIT_PRICE || 0)), 0);
  }

  CalTotalVat() {
    return this.tableData.reduce((prev, currObj) => prev + (parseFloat(currObj.QUANTITY || 0) * (parseFloat(currObj.UNIT_PRICE || 0) * this.data.VAT_RATE / 100)), 0);
  }

}

