import { Component, OnInit, ViewChild, ViewContainerRef, ElementRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import * as moment from 'moment';
import { NgForm } from '@angular/forms';

@Component({
  selector: 'snpe021',
  templateUrl: './snpe021.component.html',
  styleUrls: ['./snpe021.component.css']
})



export class SNPE021Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    public global: Globals,
    private auth: AuthDecode,
    private viewref: ViewContainerRef,
    private modal: ModalService,
    private el: ElementRef,
  ) { }


  public headerList: any;

  public data: any = {};

  public tableData: any = [];
  public MainDatatable: any;
  public dataList: any;
  public displayedColumns: string[] = [];
  public isCustomContent: boolean = false;
  public SelectList: any;
  public IsSearch: any = true;
  public IsEdit: any = false;
  public IsAdd: any = false;
  public IsSaved = false;
  public IsCancel: boolean = false;
  // public IsSheleved = true;
  // public SelectedInv = false;
  public confirmHeader: boolean = false;
  public CheckPo: any = [];

  @ViewChild("dialog", { static: true }) dialog: any;
  @ViewChild("headerForm") headerForm: NgForm;

  public temp_diff_amount: any = {}
  public params: any = {
    DOCUMENT_NO: null,
    VENDOR_CODE: null,
    INVOICE_NO: null
  }

  public ConfigDocNo: any = {
    ColName: "LOOKUP_DOC",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNPE021_GetDoc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: false
  }

  public ConfigDocS: any = {
    ColName: "DOCUMENT_NO",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNPE021_GetDoc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: true
  }

  public ConfigVendorS: any = {
    ColName: "LOOKUP_VENDOR",
    PlaceholderText: "Select Vendor Code",
    SourceController: "AC",
    SourceMethodName: "SNPE021_GetVendor",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigVendor: any = {
    ColName: "LOOKUP_VENDOR",
    PlaceholderText: "Select Vendor Code",
    SourceController: "AC",
    SourceMethodName: "SNPE021_GetVendor",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigInvS: any = {
    ColName: "INVOICE_NO",
    ColValue: "INVOICE_NO",
    PlaceholderText: "Select Invoice No",
    SourceController: "AC",
    SourceMethodName: "SNPE021_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      VENDOR_CODE: null
    }
  }

  public ConfigInv: any = {
    ColName: "INV_LOOKUP",
    PlaceholderText: "Select Invoice No",
    SourceController: "AC",
    SourceMethodName: "SNPE021_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      VENDOR_CODE: null
    }
  }

  public GetPart_M2: any = {
    ColName: "LOOKUP_PART",
    PlaceholderText: "Select Part",
    SourceController: "AC",
    SourceMethodName: "SNPE021_GetPart_M2",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      VENDOR_CODE: '',
      INVOICE_NO: ''
    }
  }


  ngOnInit() {
    // this.data = {};
    // this.ConfigInv.SourceParams = { VENDOR_CODE: "" };
    // this.ConfigInvS.SourceParams = { VENDOR_CODE: "" };
    // this.data.DOCUMENT_DATE = new Date();
  }

  Edit(P_data) {

    this.data = P_data;
    this.tableData = [];
    this.IsSearch = false;
    this.IsEdit = true;
    this.IsAdd = false;
    this.IsSaved = true;
    this.confirmHeader = true;
    this.IsCancel = false;
    this.http.get("AC", "SNPE021_GetPart", this.data.REF_INV_NO, this.data.DOCUMENT_NO)
      .subscribe(res => {
        if (res.Table.length > 0) {
          this.tableData = res.Table;
          // for (var i = 0; i < this.tableData.length; i++) {
          //   this.tableData[i].SEQ = i + 1;
          //   this.tableData[i].EDIT = 'DEL';
          // };
        }
      });
  }
  AddNew() {
    this.data = {};
    this.data.DOCUMENT_DATE = moment();
    this.ConfigInv.SourceParams.VENDOR_CODE = null;
    this.ConfigInvS.SourceParams.VENDOR_CODE = null;
    this.IsSearch = false;
    this.IsEdit = false;
    this.IsAdd = true;
    // this.SelectedInv = false;
    this.confirmHeader = false;
    // this.ngOnInit();
    this.tableData = [];
    this.tableData = [...this.tableData, { 'EDIT': 'ADD', 'SEQ': '' }];
  }

  // VendorChanged() {
  //   this.http.get("AC", "SNPE021_GetVendor", this.data.VENDOR_CODE, "30")
  //     .subscribe(res => {
  //       if (res.Table[0].STATUS != "FAIL") {
  //         for (var i = 0; i < res.Table.length; i++) {
  //           if (res.Table[i].VENDOR_CODE === this.data.VENDOR_CODE) {
  //             this.data.VENDOR_CODE = res.Table[i].VENDOR_CODE;
  //             this.data.VENDOR_NAME = res.Table[i].VENDOR_NAME_TH;
  //             this.data.VENDOR_TYPE = res.Table[i].VENDOR_TYPE;
  //             this.ConfigInv.SourceParams = { VENDOR_CODE: res.Table[i].VENDOR_CODE };
  //           }
  //         };
  //       }
  //     });
  // }
  // InvChanged() {
  //   this.http.post("AC", "SNPE021_GetInvP", this.data)
  //     .subscribe(res => {
  //       if (res.Table[0].STATUS != "FAIL") {
  //         for (var i = 0; i < res.Table.length; i++) {
  //           if (res.Table[i].INVOICE_NO === this.data.REF_INV_NO) {
  //             this.data.REF_INV_NO = res.Table[i].INVOICE_NO;
  //             this.data.REF_INV_DATE = res.Table[i].INVOICE_DATE;
  //             this.data.INV_STATUS = res.Table[i].TYPE_NAME_EN;
  //             this.data.TOTAL_QTY = res.Table[i].TOT_QTY;
  //             this.data.TOTAL_NET_B = res.Table[i].TOT_AMT_B;
  //             this.GetPart_M.SourceParams = { INVOICE_NO: res.Table[i].INVOICE_NO };
  //             this.SelectedInv = true;
  //           }
  //         };
  //       }
  //     });
  // }

  // GetPart(evt, data, index) {
  //   if (evt) {
  //     if (this.tableData.find((v, i) => i !== index && v.EDIT === 'EDIT' && v.ACCEPT_PART_NO === evt.PART_NO)) {
  //       this.modal.warning("Duplicate Part number!", this.viewref)
  //       data.PART_NO = null;
  //     } else {
  //       data.ACCEPT_PART_NO = evt.ACCEPT_PART_NO;
  //       data.ORDER_PART_NO = evt.ORDER_PART_NO;
  //       data.PO_NO = evt.PO_NO;
  //       data.QUANTITY = evt.QUANTITY;
  //       data.UNIT_PRICE = evt.UNIT_PRICE;
  //       data.AMOUNT = evt.AMOUNT;
  //       data.ORDER_QTY = evt.ORDER_QTY;
  //       data.ITEM_NO = evt.ITEM_NO;
  //       data.SUB_ITEM_NO = evt.SUB_ITEM_NO;
  //     }

  //     this.tableData = [...this.tableData]
  //   }
  // }



  GetPart(evt, elID, data, index) {

    if (evt == undefined) {
      data.ACCEPT_PART_NO = null;
      return
    }
    let currentElement = this.el.nativeElement.querySelector("#" + elID);
    this.http.get("AC", "SNPE021_CheckPo", this.data.VENDOR_CODE, this.data.REF_INV_NO, evt.PART_NO)
      .subscribe(res => {
        this.CheckPo = res.Table;
        //console.log('cccccccccccccccccccc',this.CheckPo)
        if (this.CheckPo.length == 1) {
          this.temp_diff_amount = this.CheckPo[0];
          this.SetPOMatchOne(data, index, this.CheckPo[0], currentElement)
        } else if (this.CheckPo.length > 1) {
          // this.SetPOMatchMore
          this.temp_diff_amount = this.CheckPo[0];
          this.CheckPo.forEach(d => d.CHECK = this.CheckIfExists(d));
          this.dialog.OpenDialog();
        } else {
          data.ACCEPT_PART_NO = null;
          currentElement.focus();
          this.modal.error("Unable to find matched PO.", this.viewref);
        }
      })


  }

  SetPOMatchOne(data: any, index: number, result: any, currentElement: any) {

    let foundDuplicate = this.tableData.find((d, i) => {
      return index !== i
        && result.ACCEPT_PART_NO === this.tableData[i].ACCEPT_PART_NO
        && result.PO_NO === this.tableData[i].PO_NO
        && result.ITEM_NO === this.tableData[i].ITEM_NO
        && result.SUB_ITEM_NO === this.tableData[i].SUB_ITEM_NO
    })

    if (foundDuplicate) {
      data.ACCEPT_PART_NO = null;
      currentElement.focus();
      this.modal.error("Unable to insert duplicated record.", this.viewref);
      return;
    }

    // data.CHECK = true;
    data.ACCEPT_PART_NO = result.ACCEPT_PART_NO;
    data.ORDER_PART_NO = result.ORDER_PART_NO;
    data.PO_NO = result.PO_NO;
    data.QUANTITY = result.QUANTITY;
    data.UNIT_PRICE = result.UNIT_PRICE;
    data.AMOUNT = result.AMOUNT;
    data.ORDER_QTY = result.ORDER_QTY;
    data.ITEM_NO = result.ITEM_NO;
    data.SUB_ITEM_NO = result.SUB_ITEM_NO;
    this.AppendRow();
    this.CheckDiff()
  }

  AcceptSelectedPO() {
    let thisPartNo = this.CheckPo[0].ACCEPT_PART_NO;

    let ActiveRow = this.tableData.filter((d, i) => this.CheckRequiredFields(i, false));
    let SelectedRow = this.CheckPo.filter(d => {
      
      //Add checking exists row for do not concat
      const found = ActiveRow.find(v => v.ACCEPT_PART_NO === d.ACCEPT_PART_NO && 
                                        v.PO_NO === d.PO_NO &&
                                        v.ITEM_NO === d.ITEM_NO &&
                                        v.SUB_ITEM_NO === d.SUB_ITEM_NO);
      
      return d.CHECK && !found
    })

    console.log('ActiveRow',ActiveRow)
    console.log('SelectedRow',SelectedRow)

    SelectedRow = SelectedRow.map(d => {
      return {
        // CHECK: true,
        EDIT: 'EDIT',
        ACCEPT_PART_NO: d.ACCEPT_PART_NO,
        ORDER_PART_NO: d.ORDER_PART_NO,
        PO_NO: d.PO_NO,
        QUANTITY: d.QUANTITY,
        UNIT_PRICE: d.UNIT_PRICE,
        AMOUNT: d.AMOUNT,
        ORDER_QTY: d.ORDER_QTY,
        ITEM_NO: d.ITEM_NO,
        SUB_ITEM_NO: d.SUB_ITEM_NO,
      }
    });

    this.tableData = ActiveRow.concat(SelectedRow)


    // console.log('tableData',this.tableData)
    this.CheckDiff()
    //this.tableData = this.tableData.slice();
    this.AppendRow2();
    this.dialog.Close();

  }

  CheckRequiredFields(tblIndex, allowUnChange: boolean = true) {
    let valid: boolean = (this.data.VENDOR_CODE && this.data.REF_INV_NO && this.data.REF_INV_DATE) ? true : false;

    if (valid) {
      let thisRow = this.tableData[tblIndex];
      let countChangeItems: number = 0;

      if (thisRow.ACCEPT_PART_NO) countChangeItems++;

      valid = (countChangeItems > 0 && thisRow.ACCEPT_PART_NO && thisRow.PO_NO) || (allowUnChange && countChangeItems === 0) ? true : false;
    }

    return valid;
  }


  CheckIfExists(data) {
    return this.tableData.find(d => {
      return d.ACCEPT_PART_NO === data.ACCEPT_PART_NO
        && d.PO_NO === data.PO_NO
        && d.ITEM_NO === data.ITEM_NO
        && d.SUB_ITEM_NO === data.SUB_ITEM_NO
    })
  }


  CheckActiveRow(tblIndex) {
    let valid: boolean = (this.data.VENDOR_CODE && this.data.REF_INV_NO && this.data.REF_INV_DATE) ? true : false;

    if (valid) {
      valid = (!this.tableData[tblIndex].INVOICE_PROCESS || this.tableData[tblIndex].INVOICE_PROCESS === 'N') && !this.data.DOCUMENT_NO;
    }

    if (valid && tblIndex > 0) {
      let prevRow = this.tableData[tblIndex - 1];

      valid = (prevRow.ACCEPT_PART_NO && prevRow.ITEM_QTY && prevRow.UNIT_PRICE_B) ? true : false;
    }

    if (valid) {
      this.CreateDetailRow(tblIndex);
    }

    return valid;
  }

  CreateDetailRow(tblIndex) {
    let currentMaxRow: number = this.tableData.length || 0;
    let nextMaxRow: number = (Math.floor(currentMaxRow / 10) + 1) * 10;

    if (currentMaxRow - tblIndex <= 2) {
      for (let i = currentMaxRow; i < nextMaxRow; i++) {
        this.tableData.push({
          INVOICE_PROCESS: 'N'
        });
      }

      this.tableData = this.tableData.slice();
    }

  }

  CheckDiff() {

    //console.log('xxxx',this.CalTotalAmount())

    let find = this.tableData.some(x => x.DIFF_FLAG)

    if (!find) {
      let index = this.tableData.findIndex(x => x.ACCEPT_PART_NO == this.temp_diff_amount.EX_ACCEPT_PART_NO)
      if (index > -1) {
        let amt = this.global.Round(this.tableData[index].AMOUNT + Number(this.temp_diff_amount.EX_DIFF_COST), 2)
        this.tableData[index].AMOUNT = amt
        this.tableData[index].DIFF_FLAG = true;
        this.tableData = this.tableData.slice();
      }

    }


  }

  GetDocNo(evt, t) {
    if (t === "s") {
      this.params.DOCUMENT_NO = evt.DOCUMENT_NO;
    }
    if (t === "a") {
      this.data.DOCUMENT_NO = evt.DOCUMENT_NO;
      this.data.DOCUMENT_DATE = evt.DOCUMENT_DATE;
    }
  }
  GetVendor(evt, t) {
    if (t === "s") {
      this.params.VENDOR_CODE = evt.VENDOR_CODE;
      this.ConfigInv.SourceParams = { VENDOR_CODE: evt.VENDOR_CODE };
    }
    if (t === "a") {
      this.data.VENDOR_CODE = evt.VENDOR_CODE;
      this.data.VENDOR_NAME = evt.VENDOR_NAME_TH;
      this.data.VENDOR_TYPE = evt.VENDOR_TYPE;
      this.ConfigInv.SourceParams = { VENDOR_CODE: evt.VENDOR_CODE };
      this.GetPart_M2.SourceParams.VENDOR_CODE = evt.VENDOR_CODE;
    }
  }
  GetInv(evt, t) {
    if (t === "s") {

      this.params.INVOICE_NO = evt;
    }
    if (t === "a") {
      this.data.REF_INV_NO = evt.INVOICE_NO;
      this.data.REF_INV_DATE = evt.INVOICE_DATE;
      this.data.INV_STATUS = evt.TYPE_NAME_EN;
      this.data.TOTAL_QTY = evt.TOT_QTY;
      this.data.TOTAL_NET_B = evt.TOT_AMT_IMPORT;
      this.data.FOUND_51_53 = evt.FOUND_51_53;
      this.GetPart_M2.SourceParams.INVOICE_NO = evt.INVOICE_NO;
      // this.SelectedInv = true;
      //console.log('evt',evt)
      this.confirmHeader = true;
      this.AppendRow();
    }
  }
  AppendRow() {

    this.tableData[this.tableData.length - 1].EDIT = "EDIT";

    this.tableData.push({
      EDIT: 'ADD'
    })

    this.tableData = [...this.tableData];

    // if (this.SelectedInv) {
    //   for (var i = 0; i < this.tableData.length; i++) {
    //     if (this.tableData[i].EDIT === "ADD") {
    //       this.tableData[i].EDIT = 'DEL';
    //       this.tableData[i].SEQ = this.tableData.length;
    //     }
    //   }
    //   this.tableData = [...this.tableData, { 'EDIT': 'ADD', 'SEQ': '' }];
    // }
  }

  AppendRow2() {

    this.tableData.push({
      EDIT: 'EDIT'

    })

    this.tableData.push({
      EDIT: 'ADD'
    })
    this.tableData = [...this.tableData];

  }

  DeleteRow(Item) {
    // console.log(Item)
    // console.log('table',this.tableData)
    // for (var i = 0; i < this.tableData.length; i++) {
    //   if (this.tableData[i].SEQ === Item) {
    //     this.tableData.splice(i, 1);
    //   }
    // }
    let index = this.tableData.findIndex(x => x == Item)
    this.tableData.splice(index, 1);
    this.tableData = [...this.tableData];
  }

  Search() {
    this.http.post("AC", "SNPE021_GetList", this.params)
      .subscribe(res => {
        this.MainDatatable = res.Table;
      });

  }
  BackToGrid() {
    this.IsSearch = true;
    this.Search();
  }
  Save() {
    if (this.confirmHeader) {
      if (this.tableData.filter(x => x.EDIT == 'EDIT' && x.ACCEPT_PART_NO).length < 1) {
        this.modal.warning("Please select at least 1 Parts.", this.viewref)
        return;
      }
      this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSave);
    } else {
      this.modal.warning("Please fill all required(*) fields.", this.viewref);
    }
  }
  ConfirmSave = () => {
    this.data._DOCUMENT_DATE = this.global.ConvertDateToFormatSTD(this.data.DOCUMENT_DATE);
    if (this.data.REF_INV_DATE) {
      this.data._REF_INV_DATE = this.global.ConvertDateToFormatSTD(this.data.REF_INV_DATE);
    }
    this.data.PART_LIST = [];
    this.data.PART_LIST = this.tableData.filter(v => v.EDIT === "EDIT" && v.ACCEPT_PART_NO);
    this.data.TOTAL_RECIEVE_QTY = this.CalTotalQTY()
    this.data.TOTAL_RECIEVE_AMOUNT = this.CalTotalAmount();
    this.http.post("AC", "SNPE021_Save", this.data)
      .subscribe(res => {
        console.log('res', res)
        if (res.STATUS == 'DONE') {
          this.IsSaved = true;
          // this.IsSheleved = false;
          this.data.DOCUMENT_NO = res.DOCUMENT_NO;
          this.data.LAST_UPD_DATE = new Date();
          this.data.UPDATE_BY_NAME = this.auth.getDetail().ssNameEN;
          this.Edit(this.data);
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
        } else if (res.STATUS == 'UNCONFIRM') {
          this.modal.warning("There is document no." + ' ' + res.DOCUMENT_NO + ' ' + "waiting to confirm. Please confirm before shelving the rest.", this.viewref)
        } else if (res.STATUS == 'PRICE_ERROR') {
          let detailPrice = res.DOCUMENT_NO.split(",");
          this.modal.error('Not allow to recieve part !!. Recieve Qty : A not equal to Invoice Qty :B or Recieve Amount :A not equal to Invoice Amount :B, ' + ':A : ' + detailPrice[0] + ' , ' + detailPrice[1] + ',' + ':B : ' + this.CalTotalQTY() + ' , ' + this.CalTotalAmount()
            , this.viewref, () => { }, { 'width': '650px', 'height': '350px' });
        }
      }, err => {
        this.modal.error('Found an error, please contact support team', this.viewref);
      });
  }

  getDateParam(dt) {
    if (dt !== undefined) {
      dt = new Date(dt)
      let year = dt.getFullYear();
      let month = (1 + dt.getMonth()).toString().padStart(2, '0');
      let day = dt.getDate().toString().padStart(2, '0');
      var p_Date = year + '-' + month + '-' + day;
      return p_Date;
    }
  }

  // ToShelve() {
  //   this.modal.confirm('Do you want to to shelve?', this.viewref, this.ConfirmToShelve)
  // }

  // ConfirmToShelve = () => {
  //   this.http.post("AC", "SNPE021_ToShelve", this.data)
  //     .subscribe(res => {
  //       if (res.Table[0].STATUS == 'DONE') {
  //         this.modal.info('Transaction complete: 1 record parts to shaled', this.viewref);
  //         // this.IsSheleved = true;
  //       }
  //       else {
  //         this.modal.warning(res.Table[0].MESSAGE, this.viewref);
  //       }
  //     });
  //   // this.IsSheleved = true;
  // }

  Cancel() {
    this.modal.confirm('Do you want to to cancel?', this.viewref, this.ConfirmCancel)

  }

  ConfirmCancel = () => {
    this.http.post("AC", "SNPE021_Concel", this.data)
      .subscribe(res => {
        if (res == 'DONE') {
          this.modal.info('Transaction complete: 1 record  Canceled', this.viewref);
          this.IsCancel = true;
        }
        else if (res == 'CONFIRMED') {
          this.modal.warning("Can not cancel document because this document confirmed", this.viewref);
        }
        else {
          this.modal.error('Found an error, please contact support team', this.viewref);
        }
      }, (err) => {
        this.modal.error('Found an error, please contact support team', this.viewref);
      });
  }

  ConfirmTransHeader() {
    if (this.headerForm.valid) {
      this.modal.confirm("Are you sure to confirm transaction header information?", this.viewref
        , () => {
          this.confirmHeader = true;
          this.AppendRow();
        }, () => { })
    } else {
      this.modal.warning("Please fill all required(*) fields.", this.viewref);
    }
  }

  CalTotalQTY() {
    return this.tableData.reduce((prev, currObj) => prev + (currObj.EDIT !== 'ADD' ? (currObj.QUANTITY || 0) : 0), 0);
  }

  CalTotalAmount() {

    return this.tableData.reduce((prev, currObj) => prev + (currObj.EDIT !== 'ADD' ? (currObj.AMOUNT || 0) : 0), 0);
  }


}


