import { Component, OnInit, ViewContainerRef } from "@angular/core";
import { Router } from "@angular/router";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";

@Component({
  selector: "list",
  templateUrl: "list.component.html",
  styleUrls: ["list.component.css"],
})
export class ListComponent implements OnInit {
  constructor(
    private router: Router,
    private http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef
  ) {}

  public manualList: any[] = [];
  public filterManual: string = "";

  ngOnInit() {
    this.GetManualList();
  }

  private GetManualList() {
    this.http.get("System", "GetManualDocumentList").subscribe(
      (manualList) => {
        this.manualList = manualList
      },
      (err) => {
        this.modal.warning(
          "Found an error, please contract support team",
          this.viewRef
        );
      }
    );
  }
  
  public ManualListFilter() {
    return this.manualList.filter(v => v.DOCUMENT_NAME?.toUpperCase().includes(this.filterManual?.toUpperCase()))
  }

  public ManualDownload(selectedManual: any) {
    const manual = selectedManual.options[0].value;
    window.open(manual.DOCUMENT_PATH, "_blank");
  }
}
