import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import * as moment from 'moment';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'monthrep',
  templateUrl: './MONTHREP.component.html',
  styleUrls: ['./MONTHREP.component.css']
})

export class MONTHREPComponent implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals
  ) { }

  public currentDate: moment.Moment;
  public countRow: number;

  ngOnInit() {
    this.currentDate = moment();
    // this.GetCurrentDate();
  }

  GetCurrentDate() {
    this.http.GetSystemDate()
      .subscribe(d => {
        this.currentDate = moment(d);
      })
  }

  RunReport(reportName) {
    let currentDate = this.global.ConvertDateToFormatSTD(this.currentDate);

    this.http.getParams("AC", ["MONTHREP", reportName, currentDate], { CURRENT_DATE: currentDate })
      .subscribe(result => {
        this.modal.info("Generate Monthly reports completed."
          , this.viewref);
      })
  }
}

