import { Component, ElementRef, OnInit, ViewContainerRef } from '@angular/core';
import { Globals } from 'src/app/core/global';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'runbat1_br',
    templateUrl: 'runbat1_br.component.html',
    styleUrls: ['runbat1_br.component.css']
})

export class RunBat1_BRComponent implements OnInit {
    constructor(
        private http: HttpService,
        private modal: ModalService,
        private viewref: ViewContainerRef,
        private el: ElementRef,
        private global: Globals
    ) { }

    ngOnInit() { }

    BeginProcess() {
        this.modal.confirm("Confirm to run Allocate BR (Noon)?", this.viewref
            , () => {
                this.http.post("SL", "RUNBAT1_BR_Process", null)
                    .subscribe(result => {
                        if(result.status == "Fail") {
                            this.modal.error(result.message, this.viewref);
                        } else {
                            this.modal.info("Process complete....", this.viewref);
                        }
                    }, err => {
                        this.modal.error("Found eror, please contact support team.", this.viewref);
                    })
            }, () => { })
    }
}