import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
//import { Router } from '@angular/router';
//import { AuthDecode } from 'src/app/core/auth-decode.service';
import { ModalService } from '../../../core/modal.service';
import { NgForm } from '@angular/forms';
import { Globals } from 'src/app/core/global';
import * as moment from 'moment';

@Component({
  selector: 'SNIE001_N',
  templateUrl: './SNIE001_N.component.html',
  styleUrls: ['./SNIE001_N.component.css']
})

export class SNIE001_NComponent implements OnInit {

  constructor(
    private http: HttpService,
   // private auth: AuthDecode,
    private viewRef: ViewContainerRef,
    private modal: ModalService,
   // private router: Router,
    private global: Globals
  ) { }
  public params: any = {}
  public data: any = {};
  public tblData: any = {};
  public hideCols: Array<string> = [];
  public reverseType: any = '';

  public tblFooterDetail: any = [
    {
      fieldName: "PART_NAME",
      value: "Total",
      show: true
    },
    {
      fieldName: "QUANTITY",
      // value: false,
      show: true
    },
    {
      fieldName: "UNIT_PRICE",
      // value: false,
      show: true
    },
    {
      fieldName: "AMOUNT",
      // value: false,
      show: true
    }]


  public tableData: any = [];
  public tableData2: any = [];
  public mainDatatable: any;

  public IsSearch: any = true;
  public IsAdd = false;
  public IsSaved = true;
  public editRefDoc: boolean = false;
  public confirmHeader: boolean = false;
  public currentDate: moment.Moment = moment();
  public lockReason: boolean = false;

  @ViewChild("headerForm") headerForm: NgForm;

  @ViewChild("autoCompleteReasonAdd") autoCompleteReasonAdd: any;

  public tblFooter: any = [
    {
      fieldName: "PART_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "QUANTITY",
      show: true
    },
    {
      fieldName: "AMOUNT",

      show: true
    }
  ]

  ngOnInit() {
    this.params.DOCUMENT_DATE = this.currentDate;
  }

  public ConfigDocS: any = {
    ColName: "LOOKUP_DOC",
    PlaceholderText: "Select Document No",
    SourceController: "SL",
    SourceMethodName: "SNIE001_N_GetDocList",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigDocType: any = {
    ColName: "LOOKUP_TYPE",
    PlaceholderText: "Select Document Type",
    SourceController: "SL",
    SourceMethodName: "SNIE001_N_GetDocType",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigReason: any = {
    ColName: "LOOKUP_REASON",
    PlaceholderText: "Select Reason Code",
    SourceController: "SL",
    SourceMethodName: "SNIE001_N_GetReason",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigReasonAdd: any = {
    ColName: "LOOKUP_REASON",
    PlaceholderText: "Select Reason Code",
    SourceController: "SL",
    SourceMethodName: "SNIE001_N_GetReason",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {}
  }

  public ConfigPart: any = {
    ColName: "LOOKUP_PART",
    PlaceholderText: "Select Part",
    SourceController: "SL",
    SourceMethodName: "SNIE001_N_GetPart",
    NoOfShowRecords: 50,
    MinLengthSearch: 3,
    SourceParams: {}
  }

  //GetDocType(Doc) {
  //  this.params.DOCUMENT_TYPE = Doc.DOCUMENT_TYPE;
  //}

  GetDocTypeAdd(Doc) {

    if (Doc) {
      this.data.DOCUMENT_TYPE = Doc.DOCUMENT_TYPE;
      this.data.DOC_TYPE_DESC = Doc.DOC_NAME;
      this.data.JOB_TYPE = Doc.JOB_TYPE;
      this.data.VAT_FLAG = Doc.VAT_FLAG;
      this.data.VAT_RATE = Doc.VAT_RATE;
      this.lockReason = false;

      //Set ref doc type
      if (this.data.DOCUMENT_TYPE === "RS") {
        this.data.REF_DOC_TYPE = "SP";
        this.data.REASON_CODE = 103;
        this.editRefDoc = false;
      } else if (this.data.DOCUMENT_TYPE === "SP") {
        this.data.REASON_CODE = 103;
        this.editRefDoc = true;
      } else if (this.data.DOCUMENT_TYPE === "RT") {
        this.data.REF_DOC_TYPE = "TF";
        this.editRefDoc = false;
      } else if (this.data.DOCUMENT_TYPE === "TF") {       
        this.editRefDoc = true;
      }

      if(this.data.DOCUMENT_TYPE === "SP" || this.data.DOCUMENT_TYPE === "RS") {
        this.lockReason = true;
        this.autoCompleteReasonAdd.textInput = 103;
        this.autoCompleteReasonAdd.query();
      }

      this.ConfigReasonAdd.SourceParams.JOB_TYPE = this.data.JOB_TYPE;

      this.ConfigPart.SourceParams = { REF_DOC_TYPE: "", REF_DOC_NO: "" };
    }
  }

  GetReason(Rea) {
    this.params.REASON_CODE = Rea.REASON_CODE;
  }

  GetPartNo(evt) {
    this.params.PART_NO = evt.PART_NO;
  }


  GetReasonAdd(Rea) {
    if (this.data.DOCUMENT_TYPE == "RS" || this.data.DOCUMENT_TYPE == "RT") {
      if (this.data.OLD_REASON_CODE != Rea.REASON_CODE && this.data.REF_DOC_NO != null) {
        this.modal.warning('Reason Code must be the same as reference document', this.viewRef)
        this.data.REASON_CODE = this.data.OLD_REASON_CODE
        return;
      }
    }
    if (Rea) {
    this.data.REASON_CODE = Rea.REASON_CODE;
    this.data.DSP_REASON = Rea.REASON_DESC;
    } else {
      this.data.REASON_CODE = null;
      this.data.DSP_REASON = null;
    }
  }

  CheckRefDocType() {
    if (this.data.DOCUMENT_TYPE == "RS" && this.data.REF_DOC_TYPE !== "SP") {
      this.modal.warning('Invalid Reference document Type', this.viewRef)
      this.data.REF_DOC_NO = null;
      return;
    }
    if (this.data.DOCUMENT_TYPE == "RT" && this.data.REF_DOC_TYPE !== "TF") {
      this.modal.warning('Invalid Reference document Type', this.viewRef)
      this.data.REF_DOC_NO = null;
      return;
    }
  }

  public GetPart(evt, data, index) {
    if (evt) {
      if (this.tableData.find((v, i) => i !== index && v.EDIT === 'EDIT' && evt.PART_NO && v.PART_NO === evt.PART_NO)) {
        this.modal.warning("Duplicate Part number!", this.viewRef)
        data.PART_NO = null;
      }
      else {
        data.PART_NO = evt.PART_NO;
        data.PART_NAME = evt.PART_NAME_EN;
        data.UNIT_PRICE = evt.UNIT_PRICE_B;
        data.TOTAL_VAT = evt.TOTAL_VAT;
        data.OH_QTY = evt.OH_QTY;
        data.INDENT_QTY = evt.INDENT_QTY;
        data.TRANSFER_QTY = evt.TRANSFER_QTY;
        data.SUSPEND_QTY = evt.SUSPEND_QTY;
        data.MAX_REVERSE_QTY = evt.MAX_REVERSE_QTY;
        data.MAX_REV_TRANSFER_QTY = (evt.TRANSFER_QTY > evt.MAX_REVERSE_QTY) ? evt.MAX_REVERSE_QTY : evt.TRANSFER_QTY;
        data.MAX_REV_SUSPEND_QTY = (evt.SUSPEND_QTY > evt.MAX_REVERSE_QTY) ? evt.MAX_REVERSE_QTY : evt.SUSPEND_QTY;
        if (this.data.DOCUMENT_TYPE === "RS") {
          data.QUANTITY = data.MAX_REV_SUSPEND_QTY;
        } else if (this.data.DOCUMENT_TYPE === "RT") {
          data.QUANTITY = data.MAX_REV_TRANSFER_QTY;
        } else {
          data.QUANTITY = 0;
        }
      }
    }
  }

  //CheckAvail(evt, data) {
  //  if (this.data.DOCUMENT_TYPE === "RS") {
  //    if (data.QUANTITY > data.MAX_REV_SUSPEND_QTY) {
  //      data.QUANTITY = data.MAX_REV_SUSPEND_QTY;
  //      this.tableData = [...this.tableData];
  //      this.modal.warning('QTY Balance less than input QTY.', this.viewRef)
  //      return false;
  //    }
  //  } else if (this.data.DOCUMENT_TYPE === "RT") {
  //    if (data.QUANTITY > data.MAX_REV_TRANSFER_QTY) {
  //      data.QUANTITY = data.MAX_REV_TRANSFER_QTY;
  //      this.tableData = [...this.tableData];
  //      this.modal.warning('QTY Balance less than input QTY.', this.viewRef)
  //      return false;
  //    }
  //  } else if (data.QUANTITY > data.OH_QTY) {
  //    data.QUANTITY = data.OH_QTY;
  //    this.tableData = [...this.tableData];
  //    this.modal.warning('QTY Balance less than input QTY.', this.viewRef)
  //    return false;
  //  }
  //}

  AddNew() {
    this.data = {};
    this.data.DOCUMENT_DATE = moment();
    this.data.DOCUMENT_NO = "AUTO";
    this.data.VAT_RATE = "0.00";

    this.IsSearch = false;
    this.IsAdd = true;
    this.IsSaved = false;
    this.confirmHeader = false;
    this.editRefDoc = false;
    this.tableData = [];
    this.CreateDetailRow(0);
    this.hideCols = [];
  }

  public Search() {
    this.params._DOCUMENT_DATE = this.global.ConvertDateToFormatSTD(this.params.DOCUMENT_DATE);

    this.http.post("SL", "SNIE001_N_GetList", this.params)
      .subscribe(result => {
        this.mainDatatable = result.Table;
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      });
  }


  public Edit(P_data) {
    this.data = {}
    this.tableData = [];
    this.IsSearch = false;
    this.IsAdd = false;
    this.IsSaved = true;
    this.confirmHeader = true;
    this.editRefDoc = false;
    this.hideCols = ["EDIT"]
    this.http.get("SL", "SNIE001_N_GetHead", P_data.DOCUMENT_NO)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.data = result.Table[0];
         // console.log('this.data.DOCUMENT_TYPE', this.data.DOCUMENT_TYPE);
          if (this.data.DOCUMENT_TYPE == 'SP') {
            this.reverseType = 'RS';
          } else if (this.data.DOCUMENT_TYPE == 'TF') {
            this.reverseType = 'RT';
          } else if (this.data.DOCUMENT_TYPE == 'RS') {
            this.reverseType = 'SP';
          } else if (this.data.DOCUMENT_TYPE == 'RT') {
            this.reverseType = 'TF';
          } else {
            this.reverseType = '';
          }
          this.http.get("SL", "SNIE001_N_GetPartList", P_data.DOCUMENT_NO)
            .subscribe(result => {
              if (result.Table.length > 0) {
                this.tableData = result.Table;
                this.tableData2 = result.Table1;
              }
            });
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      });
  }

  CheckHeaderValid(tblIndex) {
    if (this.headerForm.valid && this.tableData[tblIndex].PART_NO) {
      this.CreateDetailRow(tblIndex);

      return true;
    }

    return false;
  }

  CreateDetailRow(tblIndex, defaultMaxRow = 10) {
    let currentMaxRow: number = this.tableData.length || 0;
    let nextMaxRow: number = (Math.floor(currentMaxRow / defaultMaxRow) + 1) * defaultMaxRow;

    if (currentMaxRow - tblIndex <= 2) {
      for (let i = currentMaxRow; i < nextMaxRow; i++) {
        this.tableData.push({
          EDIT: 'EDIT',
        });
      }

      this.tableData = [...this.tableData];
    }

  }

  DeleteRow(index) {
    if (this.IsAdd) {

      this.modal.confirm("Are you sure to remove this row?", this.viewRef,
        () => {
          this.tableData.splice(index, 1);
          this.tableData = [...this.tableData];
        }, () => { })

    }
  }

  public ClearPart() {
    this.tableData = [];
    this.CreateDetailRow(0);
  }
  Save() {
    if (this.headerForm.valid) {
      let detailRows = this.tableData.filter(v => v.PART_NO)

      if (detailRows.length <= 0) {
        this.modal.warning("Please select at least 1 Parts.", this.viewRef)
        return;
      }
      if (detailRows.find(v => v.EDIT === "EDIT" && ((!v.QUANTITY || v.QUANTITY === 0) || (!v.UNIT_PRICE || v.UNIT_PRICE === 0)))) {
        this.modal.warning("Some record in transaction detail have unfinished detail.", this.viewRef);
        return;
      }
      this.modal.confirm('Do you want to save changed you have made?', this.viewRef, this.ConfirmSave);
    } else {
      this.modal.warning("Please fill all required(*) fields.", this.viewRef);
    }
  }

  public FindDocForRef() {
    this.data.REF_DOC_NO = this.data.REF_DOC_NO?.toUpperCase();
    
    if (this.data.DOCUMENT_TYPE === "RS" || this.data.DOCUMENT_TYPE === "RT") {
      if (this.data.REF_DOC_NO.substring(0, 2) !== this.data.REF_DOC_TYPE) {
        this.modal.warning('Invalid  Document No', this.viewRef)
        this.data.REF_DOC_NO = null;
        return;
      }

      this.ConfigPart.SourceParams = { REF_DOC_TYPE: this.data.REF_DOC_TYPE, REF_DOC_NO: this.data.REF_DOC_NO };

      this.http.get("SL", "SNIE001_N_GetDocDetail", this.data.REF_DOC_NO)
        .subscribe(result => {
          if (result.Table.length > 0) {
            var dataList = result.Table;
            let rscode = result.Table[0].REASON_CODE.toString();
            this.data.REASON_CODE = rscode;
            this.data.OLD_REASON_CODE = rscode;
            this.autoCompleteReasonAdd.textInput = rscode;
            this.autoCompleteReasonAdd.query();

            var i = 0;
            this.tableData = [];
            this.CreateDetailRow(0, dataList.length);
            dataList.forEach((e) => {
              this.tableData[i].PART_NO = e.PART_NO;
              this.tableData[i].PART_NAME = e.PART_NAME_EN;
              this.tableData[i].UNIT_PRICE = e.UNIT_PRICE_B;
              this.tableData[i].TOTAL_VAT = e.TOTAL_VAT;
              this.tableData[i].OH_QTY = e.OH_QTY;
              this.tableData[i].INDENT_QTY = e.INDENT_QTY;
              this.tableData[i].TRANSFER_QTY = e.TRANSFER_QTY;
              this.tableData[i].SUSPEND_QTY = e.SUSPEND_QTY;
              this.tableData[i].MAX_REVERSE_QTY = e.MAX_REVERSE_QTY;
              this.tableData[i].MAX_REV_TRANSFER_QTY = (e.TRANSFER_QTY > e.MAX_REVERSE_QTY) ? e.MAX_REVERSE_QTY : e.TRANSFER_QTY;
              this.tableData[i].MAX_REV_SUSPEND_QTY = (e.SUSPEND_QTY > e.MAX_REVERSE_QTY) ? e.MAX_REVERSE_QTY : e.SUSPEND_QTY;
              if (this.data.DOCUMENT_TYPE === "RS") {
                this.tableData[i].QUANTITY = this.tableData[i].MAX_REV_SUSPEND_QTY;
              } else if (this.data.DOCUMENT_TYPE === "RT") {
                this.tableData[i].QUANTITY = this.tableData[i].MAX_REV_TRANSFER_QTY;
              } else {
                this.tableData[i].QUANTITY = 0;
              }

              i = i + 1;
            });

          }
        }, (err) => {
          console.log(err, 'err');
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        });
    }
  }

  private ConfirmSave = () => {
    let detailRows = this.tableData.filter(v => v.PART_NO)

    this.data._DOCUMENT_DATE = this.global.ConvertDateToFormatSTD(this.data.DOCUMENT_DATE);
    this.data.PART_LIST = [];
    this.data.PART_LIST = detailRows;
    this.data.TOTAL_ITEM = detailRows.length;
    this.data.TOTAL_QTY = this.CalTotalQTY();
    this.http.post("SL", "SNIE001_N_Save", this.data)
      .subscribe(res => {
        this.IsSaved = true;
        this.data.DOCUMENT_NO = res.DOCUMENT_NO;
        this.Edit(this.data);
        this.modal.info('Transaction complete: applied and saved. The document no. is ' + res.DOCUMENT_NO, this.viewRef);
      }, err => {
        this.modal.error(err.message, this.viewRef);
      });
  }


  public SetOrderQty(data) {

    if (data.QUANTITY >= 0) {
      var dec = data.QUANTITY % 1;
      if (dec != 0) {
        this.modal.warning('Quantity must not be decimal', this.viewRef);
        data.QUANTITY = 1;
      } else if ((this.data.DOCUMENT_TYPE === "SP" || this.data.DOCUMENT_TYPE === "TF") &&  data.OH_QTY + data.INDENT_QTY < data.QUANTITY ) {
        this.modal.warning('Quantity not over O/H QTY + Indent QTY', this.viewRef);
        data.QUANTITY = data.OH_QTY + data.INDENT_QTY;
        data.AMOUNT = data.QUANTITY * data.UNIT_PRICE;
      } else if ((this.data.DOCUMENT_TYPE === "RS" || this.data.DOCUMENT_TYPE === "RT") && data.MAX_REVERSE_QTY < data.QUANTITY) {
        this.modal.warning('Quantity not over Max reverse QTY', this.viewRef);
        data.QUANTITY = data.OH_QTY + data.INDENT_QTY;
        data.AMOUNT = data.QUANTITY * data.UNIT_PRICE;
      } else {
        data.AMOUNT = data.QUANTITY * data.UNIT_PRICE;
      }
    }
    else {
      this.modal.warning('Quantity must be more than 0', this.viewRef);
      data.QUANTITY = 1;
    }
  }

  Cancel() {
    this.IsSearch = true;
  }
  BackToGrid() {
    this.IsSearch = true;
  }

  CalTotalQTY() {
    return this.tableData.reduce((prev, currObj) => prev + parseFloat((currObj.QUANTITY || 0)), 0);
  }


  CalTotalQTY2() {
    return this.tableData2.reduce((prev, currObj) => prev + parseFloat((currObj.QUANTITY || 0)), 0);
  }

  CalTotalAmount() {
    return this.tableData.reduce((prev, currObj) => prev + (parseFloat((currObj.QUANTITY || 0)) * parseFloat((currObj.UNIT_PRICE || 0))), 0);
  }

  CalTotalVat() {
    return this.tableData.reduce((prev, currObj) => prev + (parseFloat((currObj.QUANTITY || 0)) * (parseFloat((currObj.UNIT_PRICE || 0)) * this.data.VAT_RATE / 100)), 0);
  }

}

