import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Globals } from 'src/app/core/global';
import { NgForm } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';


@Component({
  selector: 'snse204_d',
  templateUrl: 'SNSE204_D.component.html',
  styleUrls: ['../domsale.component.css']
})

export class SNSE204_DComponent implements OnInit {

  public params: any = {}
  public selectedrow: any;
  public PROCESS_LOG: any = [];
  public formData: any = [];

  constructor(
    private http: HttpService,
    private global: Globals,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }



  public ConfigCustomerCode: any = {
    ColName: "CODE_NAME",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE204_D_GetCustomer",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigBranch: any = {
    ColName: "LOOKUP_BRANCH",
    PlaceholderText: "Select Branch Code",
    SourceController: "SL",
    SourceMethodName: "SNSE204_D_GetBranchCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: null
    },
  }

  public ConfigSearchOrder: any = {
    ColName: "ORDER_NO",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSE204_D_GetSearchOrderNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: null,
      BRANCH_CODE: null
    },
  }

  public ConfigOrder: any = {
    ColName: "ORDER_NO",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSE204_D_GetOrderNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: null,
      BRANCH_CODE: null
    },
  }

  public ConfigPart: any = {
    ColName: "LOOKUP",
    PlaceholderText: "Select Part No",
    SourceController: "SL",
    SourceMethodName: "SNSE204_D_GetPart",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: null,
      BRANCH_CODE: null,
      ORDER_NO: null
    },
  }

  public ConfigPO: any = {
    ColName: "PO_NO",
    PlaceholderText: "Select PO No",
    SourceController: "SL",
    SourceMethodName: "SNSE204_D_GetPO",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      ORDER_PART_NO: null,

    },
  }

  public ConfigInvoice: any = {
    ColName: "LOOKUP_INVOICE",
    PlaceholderText: "Select Invoice No",
    SourceController: "SL",
    SourceMethodName: "SNSE204_D_GetInvoice",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      ORDER_PART_NO: null,
      PO_NO: null
    },
  }

  public Configbr: any = {
    ColName: "BR_NO",
    PlaceholderText: "Select Br No",
    SourceController: "SL",
    SourceMethodName: "SNSE204_D_GetBrNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
  }


  @ViewChild("dialogProcess", { static: false }) dialogProcess: any;
  @ViewChild("dialogEffective", { static: false }) dialogEffective: any;
  @ViewChild("headerForm") headerForm: NgForm;

  public tableData: any = [];
  public DataIsSelected: any = [];
  public IsSearch: boolean = true;
  public paramsearch: any = {};
  public IsEdit: boolean = false;
  public IsAdd: boolean = false;
  public isSave: boolean = false;
  public tableHead: any = [];
  public hideCols: Array<string> = [];

  ngOnInit() { }

  public Search() {
    this.tableHead = []
    this.http.post('SL', 'SNSE204_D_GetData', this.paramsearch)
      .subscribe(res => {
        this.tableHead = res.Table;
      });
  }

  public rowClick(row) {
    this.params = {}
    this.params = row
    this.params.VOR = row.ATTRIBUTE1 == 'VOR' ? true : false;
    this.IsSearch = false
    this.IsEdit = true;
    this.IsAdd = false
    this.isSave = true;
    this.hideCols.push("EDIT");
    this.GetDetail(row)
  }

  public GetDetail(row) {
    this.tableData = [];
    let param = {
      BR_NO: row.BR_NO,
      CUSTOMER_CODE: row.CUSTOMER_CODE,
      BRANCH_CODE: row.BRANCH_CODE,
      ORDER_NO: row.ORDER_NO
    }
    this.http.post("SL", "SNSE204_D_GetDetail", param)
      .subscribe(res => {
        this.tableData = res.Table
      })
  }

  public BackToGrid() {
    this.IsSearch = true
    this.IsEdit = false
    this.IsAdd = false
    this.isSave = false;
  }

  public AddOrder() {
    this.hideCols = []
    this.params = {};
    this.params.VOR = false;
    this.IsSearch = false;
    this.IsEdit = false;
    this.IsAdd = true;
    this.isSave = false;

    this.tableData = []
    this.CreateDetailRow(0)
  }

  public SetSearchCustCode(values: any) {

    if (!values.CUSTOMER_CODE) {
      this.paramsearch.CUSTOMER_CODE = null;
      this.paramsearch.CUSTOMER_NAME = null;
      this.paramsearch.BRANCH_CODE = null;
      this.paramsearch.BRANCH_NAME = null
      this.paramsearch.ORDER_NO = null;
      this.ConfigBranch.SourceParams.CUSTOMER_CODE = null;
      this.ConfigSearchOrder.SourceParams.CUSTOMER_CODE = null;
      this.ConfigPart.SourceParams.CUSTOMER_CODE = null;
      return
    }


    if (values.CUSTOMER_CODE && values.LOCK_CUSTOMER != 0) {
      this.paramsearch.CUSTOMER_CODE = null;
      this.paramsearch.CUSTOMER_NAME = null;
      this.paramsearch.BRANCH_CODE = null;
      this.paramsearch.BRANCH_NAME = null
      this.paramsearch.ORDER_NO = null;
      this.ConfigBranch.SourceParams.CUSTOMER_CODE = null;
      this.ConfigSearchOrder.SourceParams.CUSTOMER_CODE = null;
      this.ConfigPart.SourceParams.CUSTOMER_CODE = null;
      this.modal.warning("This customer is lock customer!", this.viewref)
    } else {
      this.paramsearch.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.paramsearch.CUSTOMER_NAME = values.CUST_NAME_EN
      this.ConfigBranch.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.ConfigSearchOrder.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.ConfigPart.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;

      this.paramsearch.BRANCH_CODE = null
      this.paramsearch.ORDER_NO = null;
    }

  }

  public SetSearchBranchCode(values: any) {

    if (values.BRANCH_CODE && values.BRANCH_STATUS != 0) {
      this.paramsearch.BRANCH_CODE = null
      this.paramsearch.BRANCH_NAME = null
      this.ConfigSearchOrder.SourceParams.BRANCH_CODE = null
      this.ConfigPart.SourceParams.BRANCH_CODE = null
      this.modal.warning("This branch is lock because " + values.REASON_NAME_TH, this.viewref)
    } else {
      this.paramsearch.BRANCH_CODE = values.BRANCH_CODE;
      this.paramsearch.BRANCH_NAME = values.BRANCH_NAME_TH
      this.ConfigSearchOrder.SourceParams.BRANCH_CODE = values.BRANCH_CODE
      this.ConfigPart.SourceParams.BRANCH_CODE = values.BRANCH_CODE;
      this.paramsearch.ORDER_NO = null;
    }


  }

  public SetSearchOrderNo(values: any) {
    this.paramsearch.ORDER_NO = values.ORDER_NO;
    this.ConfigPart.SourceParams.ORDER_NO = values.ORDER_NO;
  }

  public SetCustCode(values: any) {

    if (!values.CUSTOMER_CODE) {
      this.params.CUSTOMER_CODE = null;
      this.params.CUSTOMER_NAME = null;
      this.params.BRANCH_CODE = null;
      this.params.BRANCH_NAME = null
      this.params.ORDER_NO = null;
      this.ConfigBranch.SourceParams.CUSTOMER_CODE = null;
      this.ConfigOrder.SourceParams.CUSTOMER_CODE = null;
      this.ConfigPart.SourceParams.CUSTOMER_CODE = null;
      return
    }


    if (values.CUSTOMER_CODE && values.LOCK_CUSTOMER != 0) {
      this.params.CUSTOMER_CODE = null;
      this.params.CUSTOMER_NAME = null;
      this.params.BRANCH_CODE = null;
      this.params.BRANCH_NAME = null
      this.params.ORDER_NO = null;
      this.ConfigBranch.SourceParams.CUSTOMER_CODE = null;
      this.ConfigOrder.SourceParams.CUSTOMER_CODE = null;
      this.ConfigPart.SourceParams.CUSTOMER_CODE = null;
      this.modal.warning("This customer is lock customer!", this.viewref)
    } else {
      this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.params.CUSTOMER_NAME = values.CUST_NAME_EN
      this.ConfigBranch.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.ConfigOrder.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.ConfigPart.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.params.BRANCH_CODE = null;
      this.params.BRANCH_NAME = null
      this.params.ORDER_NO = null;
      this.tableData = []
      this.CreateDetailRow(0)
    }

  }

  public SetBranchCode(values: any) {
    if (values.BRANCH_CODE && values.BRANCH_STATUS != 0) {
      this.params.BRANCH_CODE = null
      this.params.BRANCH_NAME = null
      this.ConfigOrder.SourceParams.BRANCH_CODE = null
      this.ConfigPart.SourceParams.BRANCH_CODE = null
      this.modal.warning("This branch is lock because " + values.REASON_NAME_TH, this.viewref)
    } else {
      this.params.BRANCH_CODE = values.BRANCH_CODE;
      this.params.BRANCH_NAME = values.BRANCH_NAME_TH
      this.ConfigOrder.SourceParams.BRANCH_CODE = values.BRANCH_CODE
      this.ConfigPart.SourceParams.BRANCH_CODE = values.BRANCH_CODE;
      this.params.ORDER_NO = null;
      this.tableData = []
      this.CreateDetailRow(0)
    }
  }

  public SetOrderNo(values: any) {
    this.params.ORDER_NO = values.ORDER_NO;
    this.ConfigPart.SourceParams.ORDER_NO = values.ORDER_NO;
    this.tableData = []
    this.CreateDetailRow(0)
  }

  public SetNewPartNo(part: any, data: any) {

    if (part.ORDER_PART_NO) {
      data.ORDER_PART_NO = part.ORDER_PART_NO
      Object.assign(data, part);
      let foundDup = this.tableData.filter(x => x.ORDER_PART_NO == part.ORDER_PART_NO)
      if (foundDup.length > 1) {
        this.modal.warning("Order Part No. : " + part.ORDER_PART_NO + " is duplicated!", this.viewref)
        data.ORDER_PART_NO = null
        data.ORDER_PART_NAME = null
        data.PO_NO = null
        data.INVOICE_NO = null
        data.REF_ORDER_QTY = null
        data.ORDER_QTY = null
        data.LOCATION_NO = null
        return
      }

    } else {
      data.ORDER_PART_NO = null
      data.ORDER_PART_NAME = null
      data.PO_NO = null
      data.INVOICE_NO = null
      data.REF_ORDER_QTY = null
      data.ORDER_QTY = null
      data.LOCATION_NO = null
      return
    }

    if (part.ORDER_PART_NO && part.LOCK_SALES != 0) {
      this.modal.warning("Part no is lock sales!", this.viewref);
      data.ORDER_PART_NO = null
      data.ORDER_PART_NAME = null
      data.PO_NO = null
      data.INVOICE_NO = null
      data.REF_ORDER_QTY = null
      data.ORDER_QTY = null
      data.LOCATION_NO = null
      return
    }

    let param = {
      CUSTOMER_CODE: this.params.CUSTOMER_CODE,
      BRANCH_CODE: this.params.BRANCH_CODE,
      ORDER_NO: this.params.ORDER_NO,
      ORDER_PART_NO: part.ORDER_PART_NO
    }

    this.http.post("SL", "SNSE204_D_CheckPO", param)
      .subscribe(res => {

        if (res.Table[0].PO_STATUS == 'NO_PO') {
          this.modal.warning("No PO for this part!", this.viewref)
          data.ORDER_PART_NO = null
          data.ORDER_PART_NAME = null
          data.PO_NO = null
          data.INVOICE_NO = null
          data.REF_ORDER_QTY = null
          data.ORDER_QTY = null
          data.LOCATION_NO = null
          return
        }

        data.ORDER_PART_NO = part.ORDER_PART_NO
        data.ORDER_PART_NAME = part.PART_NAME_EN
        data.LOCATION_NO = part.LOCATION_NO
        data.REF_ORDER_QTY = res.Table[0].REF_ORDER_QTY
        data.REF_ORDER_ITEM_NO = part.ITEM_NO
        data.REF_ORDER_SUB_ITEM_NO = part.SUB_ITEM_NO
        data.REF_VOR_STATUS = part.VOR_STATUS
        data.VENDOR_CODE = part.VENDOR_CODE
        data.VENDOR_TYPE = part.VENDOR_TYPE
      })

  }

  public SetSourcePO(data) {
    this.ConfigPO.SourceParams.ORDER_PART_NO = data.ORDER_PART_NO
  }

  public SetSourceInvoice(data) {
    this.ConfigInvoice.SourceParams.ORDER_PART_NO = data.ORDER_PART_NO
    this.ConfigInvoice.SourceParams.PO_NO = data.PO_NO
  }

  public SetselectInvoice(event, data) {
    data.INVOICE_NO = event.INVOICE_NO
  }

  public CheckQTY(data, event) {

    if (!data.PO_NO) {
      this.modal.warning("Please Insert PO No", this.viewref);
      data.ORDER_QTY = null
      return
    }

    let sumQTY = this.tableData.filter((x) => x.ORDER_PART_NO == data.ORDER_PART_NO).reduce((pre, next) => pre + Number(next.ORDER_QTY), 0)

    if (sumQTY > Number(data.REF_ORDER_QTY)) {
      this.modal.warning("Total Borrow QTY > Order QTY!", this.viewref)
      data.ORDER_QTY = null
      return;
    }

    if (data.ORDER_QTY <= 0 || !data.ORDER_QTY) {
      this.modal.warning("Order Qty. must Not Null and more than 0!", this.viewref)
      data.ORDER_QTY = null
      return;
    }

    let param = {
      PO_NO: data.PO_NO,
      INVOICE_NO: data.INVOICE_NO ? data.INVOICE_NO : null,
      ORDER_PART_NO: data.ORDER_PART_NO
    }

    this.http.post("SL", "SNSE204_D_CheckQTY", param)
      .subscribe(res => {
        let total_sum = res.SUM_QTY + data.ORDER_QTY
        data.LEFT_INDENT = res.REF_INDENT

        if (total_sum > res.REF_INDENT) {
          this.modal.warning("Order Qty. more than PO Qty!", this.viewref)
          data.ORDER_QTY = null;
        }
      })
  }

  public CheckActiveRow(index, data) {
    if (this.headerForm.valid && data.ORDER_PART_NO) {
      this.CreateDetailRow(index);
      return true;
    }
    return false;
  }

  private CreateDetailRow(tblIndex) {
    let currentMaxRow: number = this.tableData.length || 0;
    let nextMaxRow: number = (Math.floor(currentMaxRow / 10) + 1) * 10;

    if (currentMaxRow - tblIndex <= 2 && !this.IsEdit) {
      for (let i = currentMaxRow; i < nextMaxRow; i++) {
        this.tableData.push({
          ITEM_NO: i + 1
        });
      }
      this.tableData = this.tableData.slice();
    }
  }

  public DeleteRow(index) {
    this.modal.confirm("Are you sure to remove this row?", this.viewref
      , () => {
        this.tableData.splice(index, 1);
        this.tableData = [...this.tableData];
        //this.ExpenseChanged()
      }, () => { })
  }

  public Save() {
    if (!this.headerForm.valid) {
      this.modal.error("Please input all required fields.", this.viewref);
      return;
    }
    if (this.tableData.filter(x => x.ORDER_PART_NO && x.PO_NO && x.ORDER_QTY > 0).length == 0) {
      this.modal.warning("An Order Entry must have more or equal than 1 detail", this.viewref)
      return;
    }
    var err = 0;
    this.tableData.forEach((e) => {
      if (e.ORDER_PART_NO && !e.PO_NO) {
        this.modal.warning("Please Insert PO No at Item No. : " + e.ITEM_NO, this.viewref);
        err++;
        return
      }

      let sumQTY = this.tableData.filter((x) => x.ORDER_PART_NO == e.ORDER_PART_NO).reduce((pre, next) => pre + Number(next.ORDER_QTY), 0)

      if (e.ORDER_PART_NO && sumQTY > Number(e.REF_ORDER_QTY)) {
        this.modal.warning("Total Borrow QTY > Order QTY!", this.viewref)
        err++;
        return;
      }

      if (e.ORDER_PART_NO && (e.ORDER_QTY <= 0 || !e.ORDER_QTY)) {
        this.modal.warning("Order Qty. must Not Null and more than 0!", this.viewref)
        err++;
        return;
      }
    });

    if (err == 0) {
      this.modal.confirm("Do you want to save change you have made?", this.viewref, this.ConfirmSave)
    }
  }

  private ConfirmSave = () => {

    let DetailSave = this.tableData.filter(x => x.ORDER_PART_NO && x.PO_NO && (x.ORDER_QTY > 0))
    this.params.VOR_STATUS = this.params.VOR ? "VOR" : null;
    this.params.Detail = DetailSave
    this.http.post("SL", "SNSE204_D_Save", this.params)
      .subscribe(res => {
        if (res.status == "fail") {
          console.log(res.massage)
          this.modal.warning("Found an error, please contact support team", this.viewref);
        } else {
          this.isSave = true;
          this.IsEdit = true;
          this.params.BR_NO = res.br_no
          this.params.UPDATE_BY = this.global.GetTokenDetail("ssNameEN")
          this.params.UPDATE_DATE = new Date();
          this.modal.info("Transaction complete record apply and save", this.viewref)
        }
      }, err => {
        this.modal.warning("Found an error, please contact support team", this.viewref);
      })
  }

  public TotalQty() {
    return this.tableData.reduce((pre, next) => pre + (next.ORDER_QTY | 0), 0)
  }

  public OpenReport() {
    if (this.params.NEW_REP) {
      this.global.GoToReport("PMS_RPT_SALES_SNSE_204_R_A4", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_BR_NO_FROM: this.params.BR_NO,
        P_BR_NO_TO: this.params.BR_NO,
        P_DELIVERY_CODE: this.params.DELIVERY_CODE,
        P_RE_PRINT: null
      })
    } else {
      this.global.GoToReport("PMS_RPT_SALES_SNSE_204_R", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_BR_NO_FROM: this.params.BR_NO,
        P_BR_NO_TO: this.params.BR_NO,
        P_DELIVERY_CODE: this.params.DELIVERY_CODE,
        P_RE_PRINT: null
      })
    }
  }
}
