import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';
import * as moment from 'moment';

@Component({
  selector: 'snse204_p',
  templateUrl: './snse204_p.component.html',
  styleUrls: ['../domsale.component.css']
})



export class SNSE204_PComponent implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private global: Globals,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public Configbr: any = {
    ColName: "BR_NO",
    PlaceholderText: "Select Br No",
    SourceController: "SL",
    SourceMethodName: "SNSE204_P_GetBrNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
  }


  public params: any = {};
  ngOnInit() {

  }


  OpenReport(type) {
    if (!this.params.BR_NO_FROM || !this.params.BR_NO_TO) {
      this.modal.warning("Please Input Borrow Sheet No.", this.viewref)
      return;
    }

    if (this.params.BR_NO_FROM > this.params.BR_NO_TO) {

      this.modal.warning("BR No to cannot more than BR No from", this.viewref)
      return;
    }

    //console.log('this.params.BR_NO_TO',this.params.BR_NO_TO.replace(/BR|-|/gi,''))


    if (type == 0) {
      this.global.GoToReport("PMS_RPT_SALES_SNSE_204_R", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_BR_NO_FROM: this.params.BR_NO_FROM ? this.params.BR_NO_FROM.toUpperCase() : null,
        P_BR_NO_TO: this.params.BR_NO_TO ? this.params.BR_NO_TO.toUpperCase() : null,
        P_DELIVERY_CODE: this.params.DELIVERY_CODE,
        P_RE_PRINT: 'RE-PRINTED'
      })
    } else if (type == 1) {
      this.global.GoToReport("PMS_RPT_SALES_SNSE_204_R_A4", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_BR_NO_FROM: this.params.BR_NO_FROM ? this.params.BR_NO_FROM.toUpperCase() : null,
        P_BR_NO_TO: this.params.BR_NO_TO ? this.params.BR_NO_TO.toUpperCase() : null,
        P_DELIVERY_CODE: this.params.DELIVERY_CODE,
        P_RE_PRINT: 'RE-PRINTED'
      })
    }
  }

  OpenReportBlank() {
    this.global.GoToReport("PMS_RPT_SALES_SNSE_204_R_A4_BLANK", {
      P_COMPANY_CODE: null,
      P_BR_NO_FROM: null,
      P_BR_NO_TO: null,
      P_DELIVERY_CODE: null,
      P_RE_PRINT: null
    })
  }
}
