import { Component, OnInit,ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'snsq092',
    templateUrl: './SNSQ092.component.html',
    styleUrls: ['./SNSQ092.component.css']
})



export class SNSQ092Component implements OnInit {

    constructor(
        private http: HttpService,
        private viewref: ViewContainerRef,
        private modal: ModalService
    ) { }

  public data: any;

  public paramSearch: any = {};
  public tableData: any = [];
  public totalRecord = 0;
  public PROCESS_LOG: any = [];

  ngOnInit() {
    this.paramSearch.CHECK_QTY = 'N';
    this.paramSearch.LOCK_SALES = 'A';
    var date = new Date();
    date.setMonth(date.getMonth() - 6);
    this.paramSearch.FROM_ORDER_DATE = date;
    this.paramSearch.ORDER_DATE_TO = new Date();
  }

  public ConfigPartNo: any = {
    ColName: "LOOKUP_PART_NO",
    PlaceholderText: "Select Part No",
    SourceController: "SL",
    SourceMethodName: "SNSQ092_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigCustomerCode: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    ColValue: "",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ092_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigOrderNo: any = {
    ColName: "LOOKUP_ORDER",
    ColValue: "",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSQ092_GetOrderNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetPartNo(value: any) {
    this.paramSearch.ORDER_PART_NO = value.ORDER_PART_NO;
    this.paramSearch.PART_NAME_EN = value.PART_NAME_EN;
  }

  public SetCustCode(value: any) {
    this.paramSearch.CUSTOMER_CODE = value.CUSTOMER_CODE;
  }

  public SetOrderNo(value: any) {
    this.paramSearch.ORDER_NO = value.ORDER_NO;
  }
 
  public Search() {
    console.log(this.paramSearch)
    this.tableData = [];
    this.http.post("SL", "SNSQ092_GET_LIST", this.paramSearch)
      .subscribe(res => {
        this.tableData = res.Table;
        this.totalRecord = this.tableData.length;
      }, (err) => {
          console.log(err, 'err');
          this.modal.warning("Found an error, please contact support team", this.viewref);
      });
  }

  public ExportExcel() {

    this.http.Download("SL", "SNSQ092_Export_Excle", JSON.stringify(this.tableData))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
          this.modal.info('Export complete ' + this.tableData.length + ' records.', this.viewref);
        } else {
          this.modal.error('Download not complete', this.viewref);
        }
      }, (err) => {
          console.log(err, 'err');
          this.modal.warning("Found an error, please contact support team", this.viewref);
      })
  }

  private WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    var date_export = new Date();
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ092" + "_" + date_export.getFullYear() + (date_export.getMonth() + 1) + date_export.getDate() + ".xlsx";
    a.click();
  }


}
