import { Component, OnInit, ViewEncapsulation, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';
import { SelectionModel } from '@angular/cdk/collections';

@Component({
  selector: 'snse053_m',
  templateUrl: './SNSE053_M.component.html',
  styleUrls: ['./SNSE053_M.component.css'],
  encapsulation: ViewEncapsulation.None
})



export class SNSE053_MComponent implements OnInit {


  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals
  ) { }

  public selection = new SelectionModel<any>(true, []);
  public selection2 = new SelectionModel<any>(true, []);

  public tableData: any = [];
  public dataSelected: any = [];

  public tableData2: any = [];
  public tableData2All: any = [];

  public tableData3: any = [];
  public tableData3All: any = [];
  public tableData4: any = [];
  public tableData4All: any = [];

  public tableData5: any = [];
  public dataSelected5: any = [];
  public formData: any = {};
  public dataHeader: any = {};

  public params: any = {};

  public selectCase: any = {};
  public selectCase5: any = {};

  public activeCase: any = {};
  public activeCase2: any = {};


  public tblFooter: any = [
    {
      fieldName: "NB_DG",
      value: "Total",
      show: true
    },
    {
      fieldName: "GROSS_WEIGHT",

      show: true
    },
    {
      fieldName: "GROSS_MM",

      show: true
    },
    {
      fieldName: "PACK_QTY",

      show: true
    },
    {
      fieldName: "ACCEPT_QTY",

      show: true
    }

  ]

  public tblFooter2: any = [
    {
      fieldName: "SUB_ITEM_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "PACK_QTY",

      show: true
    },
    {
      fieldName: "ACCEPT_QTY",

      show: true
    }

  ]

  public docDate: any;

  ngOnInit() {
    this.docDate = new Date();
    this.params.ATTACH_SHEET = 'Y';
  }

  initData() {
    this.tableData = [];
    this.dataSelected = [];
    this.selection.clear()
    this.selectCase.TotolSelect = 0;
    this.selectCase.TotolCase = 0;
    this.selectCase.TotalError = 0;

    this.tableData5 = [];
    this.dataSelected5 = [];
    this.selection2.clear()
    this.selectCase5.TotolCase = 0;
  }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE053_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public lookupPreInvoice: any = {
    ColName: "PINVOICE_TEXT",
    PlaceholderText: "Select Pre-invoice no.",
    SourceController: "SL",
    SourceMethodName: "SNSE053_GetPreInvoiceSea",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: "",
      BRANCH_CODE: "01"
    }
  }

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUSTOMER_NAME;
    this.params.BRANCH_CODE = values.BRANCH_CODE;
    this.params.BRANCH_NAME = values.BRANCH_NAME;
    this.params.COUNTRY = values.COUNTRY;
    this.params.CURRENCY_CODE = values.CURRENCY_CODE;
    this.params.PAYMENT_TERM = values.PAYMENT_TERM;
    this.params.EXCHANGE_RATE = values.EXCHANGE_RATE;
    this.lookupPreInvoice.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.lookupPreInvoice.SourceParams.BRANCH_CODE = values.BRANCH_CODE;
    this.GetData();
  }

  private GetData = () => {
    this.initData()
    this.http.post('SL', 'SNSE053_GetData', this.params)
      .subscribe(res => {
        this.tableData = res.Table;
        if (this.tableData.length > 0) {
          this.tableData.forEach((e) => {
            this.dataSelected.push(e)
            this.selection.select(e)
            this.selectCase.TotolSelect += e.PACK_QTY;
          });
        }

        this.tableData2 = res.Table1;
        this.tableData2All = res.Table1;

        this.tableData5 = res.Table;
        if (this.tableData5.length > 0) {
          this.tableData5.forEach((e) => {
            this.dataSelected5.push(e)
            this.selection2.select(e)
          });
          this.selectCase5.TotolCase = this.dataSelected5.length;
        }
        this.ProcessCondition();
      })
  }

  public isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tableData.length;
    return numSelected === numRows;
  }

  public Toggle() {
    if (this.isAllSelected()) {
      this.selection.clear()
      this.tableData.map(x => {
        this.dataSelected = [];
        this.selectCase.TotolSelect = 0;
      })
    } else {
      this.tableData.forEach(row => this.selection.select(row));
      this.dataSelected = [];
      this.selectCase.TotolCase = 0;
      this.selectCase.TotolSelect = 0;
      this.tableData.map(x => {
        this.dataSelected.push(x);
        this.selectCase.TotolSelect += x.PACK_QTY;
      })
    }
    this.selectCase.TotolCase = this.dataSelected.length;
  }

  public CheckToPack(event, data) {
    if (event.checked) {
      this.dataSelected.push(data);
      this.selectCase.TotolCase += 1;
      this.selectCase.TotolSelect += data.PACK_QTY;
    }
    else {
      this.dataSelected.splice(this.dataSelected.indexOf(data), 1);
      this.selectCase.TotolCase -= 1;
      this.selectCase.TotolSelect -= data.PACK_QTY;
    }
  }

  public ModifyPre() {
    this.modal.confirm("Are you sure to modify Pre-invoice ?", this.viewRef,
      () => {

        this.tableData3.forEach((value) => {
          if (value.CHK_BOX === true || value.CHK_BOX === 1) {
            value.PINVOICE_NO = this.params.PINVOICE_NO;
            value.CHK_BOX = 1;
          } else {
            value.PINVOICE_NO = null;
            value.PINVOICE_DATE = null;
            value.CHK_BOX = 0;
          }
        });

        this.tableData3.slice();

        this.http.post("SL", "SNSE053_ModifyPre", JSON.stringify(this.tableData3))
          .subscribe(result => {
            if (result == "DONE") {
              this.GetDataModify();
              this.modal.info("Confirm operation successfully : " + result, this.viewRef);
            } else {
              this.GetDataModify();
              this.modal.warning("Found an error, please contract support team", this.viewRef);
            }
          }, (err) => {
            console.log(err, 'err');
            this.GetDataModify();
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          })
      }, () => { })
  }

  public isAllSelected2() {
    const numSelected = this.selection2.selected.length;
    const numRows = this.tableData5.length;
    return numSelected === numRows;
  }

  public Toggle2() {
    if (this.isAllSelected2()) {
      this.selection2.clear()
      this.tableData5.map(x => {
        this.dataSelected5 = [];
      })
    } else {
      this.tableData5.forEach(row => this.selection2.select(row));
      this.dataSelected5 = [];
      this.tableData5.map(x => {
        this.dataSelected5.push(x);
      })
    }
    this.selectCase5.TotolCase = this.dataSelected5.length;
  }

  public CheckToPack2(event, data) {
    if (event.checked) {
      this.dataSelected5.push(data);
      this.selectCase5.TotolCase += 1;
    }
    else {
      this.dataSelected5.splice(this.dataSelected5.indexOf(data), 1);
      this.selectCase5.TotolCase -= 1;
    }
  }

  public CheckPrintChange(value) {
    if (value.checked == true) {
      this.params.ATTACH_SHEET = 'Y'
    }
    else {
      this.params.ATTACH_SHEET = 'N'
    }
  }

  public SelectPreInvoice(values: any) {

    this.params.PINVOICE_NO = values.PINVOICE_NO;
    this.params.PINVOICE_DATE = values.PINVOICE_DATE;
    this.params.DOC_TYPE = values.DOC_TYPE;
    if (this.params.PINVOICE_NO) {
      this.GetDataModify();
    }
  }

  private GetDataModify = () => {
    this.tableData = [];
    this.dataSelected = [];
    this.selection.clear()
    this.selectCase.TotolSelect = 0;
    this.selectCase.TotolCase = 0;
    this.selectCase.TotalError = 0;
    this.http.post('SL', 'SNSE053_GetDataModify', this.params)
      .subscribe(res => {
        this.tableData3 = res.Table;
        this.tableData3All = res.Table;
        this.tableData4 = res.Table1;
        this.tableData4All = res.Table1;
        this.onClickRow3(res.Table[0])  //initial select Sub(Modify) on first record
      })
  }

  public ConfirmPre() {
    //this.dataSelected = this.tableData.filter(v => v.CHK_BOX === true);

    ////console.log('dataSelected :', this.dataSelected);
    //if (this.selectCase.TotolCase == 0) {
    //  this.modal.warning("Found an error, please contract support team", this.viewRef);
    //}

    if (this.dataSelected.length > 0) {
      this.modal.confirm("Are you sure to confirm Pre-invoice ?", this.viewRef, () => {
        this.http.post("SL", "SNSE053_ConfirmPre", JSON.stringify(this.dataSelected))
          .subscribe(result => {
            if (result.substring(0, 4) == "DONE") {
              this.GetData();
              this.modal.info("Confirm successfully [Pre-Invoice no.] : " + result.substring(5, 14), this.viewRef);

              if (this.params.ATTACH_SHEET == 'Y') {
                this.OpenReport(result.substring(5, 14));
              }
            } else {
              this.GetData();
              this.modal.warning("Found an error, please contract support team", this.viewRef);
            }
          }, (err) => {
            this.GetData();
            console.log(err, 'err')
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          })


      }, () => { })
    } else {
      this.modal.warning("Please select data for confirm Pre-invoice.", this.viewRef);
    }
  }

  public ConfirmDelete() {
    //this.dataSelected5 = this.tableData5.filter(v => v.CHK_BOX === true);
    //console.log('dataSelected :', this.dataSelected);
    //if (this.selectCase.TotolCase == 0) {
    //  this.modal.warning("Found an error, please contract support team", this.viewRef);
    //}

    if (this.dataSelected5.length > 0) {
      this.modal.confirm("Are you sure to delete case?", this.viewRef, () => {
        this.http.post("SL", "SNSE032_ConfirmDelete", JSON.stringify(this.dataSelected5))
          .subscribe(result => {
            if (result.substring(0, 4) == "DONE") {
              this.GetData();
              this.modal.info("Delete case successfully", this.viewRef);
            } else {
              this.GetData();
              this.modal.warning("Found an error, please contract support team", this.viewRef);
            }
          }, (err) => {
            this.GetData();
            console.log(err, 'err')
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          })
      }, () => { })
    } else {
      this.modal.warning("Please select data for delete case.", this.viewRef);
    }
  }

  private ProcessCondition() {

    var countError = 0;
    this.tableData.forEach((value) => {

      if (value.GROSS_WEIGHT == '' && value.GROSS_WEIGHT > 0) {
        if (value.NET_WEIGHT > value.GROSS_WEIGHT) {
          value.CHK_BOX = false;
          value.ERROR = 1;
          value.REMARK = 'GW error';
          countError = countError + 1;
          value.CHECK = 0;
        }
        else {
          value.CHK_BOX = true;
          value.SELECT = value.ACCEPT_QTY;
          value.CHECK = 1;
        }
      }
      else {
        value.CHK_BOX = true;
        value.SELECT = value.ACCEPT_QTY;
        value.CHECK = 1;
      }
    });
    this.selectCase.TotolCase = this.tableData.length;
    this.selectCase.TotalError = countError;

    var event;
    var data;
    //this.CheckToPack(event, data)

  }

  public onClickRow(data) {
    this.tableData2 = this.tableData2All.filter(v => v.CASE_NO === data.CASE_NO);
    this.activeCase.CASE_NO = data.CASE_NO;
    this.activeCase.PACK_DATE = data.PACK_DATE;
    this.activeCase.PACK_TIME = data.PACK_TIME;
    this.activeCase.PACK_BY = data.PACK_BY;
    this.activeCase.DSP_PACK_BY = data.DSP_PACK_BY;
    this.activeCase.GROSS_MM = data.GROSS_MM;
    this.activeCase.GROSS_WEIGHT = data.GROSS_WEIGHT;
    this.activeCase.PACK_QTY = data.PACK_QTY;
    this.activeCase.ACCEPT_QTY = data.ACCEPT_QTY;
  }

  public onClickRow3(data) {
    this.tableData4 = this.tableData4All.filter(v => v.CASE_NO === data.CASE_NO);
    this.activeCase2.CASE_NO = data.CASE_NO;
    this.activeCase2.PACK_DATE = data.PACK_DATE;
    this.activeCase2.PACK_TIME = data.PACK_TIME;
    this.activeCase2.PACK_BY = data.PACK_BY;
    this.activeCase2.GROSS_MM = data.GROSS_MM;
    this.activeCase2.GROSS_WEIGHT = data.GROSS_WEIGHT;
    this.activeCase2.PACK_QTY = data.PACK_QTY;
    this.activeCase2.ACCEPT_QTY = data.ACCEPT_QTY;
  }

  private OpenReport(preInovice) {
    this.global.GoToReport("PMS_RPT_SALES_SNSE032R_N", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_CUST_S: this.params.CUSTOMER_CODE,
      P_CUST_E: this.params.CUSTOMER_CODE,
      P_PINV_NO_START: preInovice,
      P_PINV_NO_END: preInovice,
      P_PINV_DATE_S: this.global.ConvertDateToFormatSTD(this.docDate),
      P_PINV_DATE_E: this.global.ConvertDateToFormatSTD(this.docDate),
      P_SENT_BY: 'S'
    })
  }

  public ChangeCurrentTab(tab) {
    if ((tab.index == 0 || tab.index == 4) && this.params.CUSTOMER_CODE) {
      this.GetData();
    }
    if (tab.index == 2 && this.params.CUSTOMER_CODE && this.params.PINVOICE_NO) {
      this.GetDataModify();
    }
  }
}
