import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { Globals } from 'src/app/core/global';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'bo-release',
    templateUrl: 'BO_RELEASE.component.html'
})

export class BOReleaseComponent implements OnInit {
    constructor(
        private http: HttpService,
        private global: Globals,
        private modal : ModalService,
        private viewref : ViewContainerRef
    ) { }

    ngOnInit() { }

    public GenerateData(){
        this.http.Download("IC","BO_Release_Generate",{})
        .subscribe(res => {
            this.WriteContents(res);
            //this.modal.info("Generate data complete",this.viewref)
        },err =>{
            this.modal.error('Generate data fail', this.viewref);
        })
    }

    public ExportData(){
        this.http.Download("IC","BO_Release_Download",{})
        .subscribe(res => {
            this.WriteContents(res);
        },err => {
            console.log(err,'error')
        })
    }

    WriteContents(content) {
        const a = document.createElement('a');
        const file = new Blob([content], { type: content.type });
        a.href = URL.createObjectURL(file);
        a.download = "BO_Release" + this.global.CurrentDate() + ".xlsx";
        a.click();
        this.modal.info("Generate data complete",this.viewref)
      }

}