import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from '../../../core/global';

@Component({
  selector: 'SNPR008',
  templateUrl: './SNPR008.component.html',
  styleUrls: ['./SNPR008.component.css']
})



export class SNPR008_Component implements OnInit {

//For dev show data set
//   displayedColumns: string[] = [
//     'COMPANY_CODE' , 
//     'GROUP_PART_NO' , 
//     'VENDOR_CODE' , 
//     'VENDOR_TYPE' , 
//     'ONLINE_FLAG' , 
//     'PART_CATEGORY' , 
//     'ORDER_QTY_EDF' , 
//     'SUGGEST_STATUS' , 
//     'PO_PROCESS_DATE' , 
//     'ORDER_QTY_MANUA' , 
//     'ORDER_STATUS' , 
//     'ORDER_QTY_N_01' , 
//     'ORDER_QTY_N_02' , 
//     'ORDER_QTY_N_03' , 
//     'ORDER_QTY_N_04' , 
//     'ORDER_QTY_N_05' , 
//     'ORDER_QTY_N_06' , 
//     'ORDER_QTY_N_07' , 
//     'ORDER_QTY_N_08' , 
//     'ORDER_QTY_N_09' , 
//     'ORDER_QTY_N_10' , 
//     'ORDER_QTY_N_11' , 
//     'ORDER_QTY_N_12' , 
//     'OH_QTY' , 
//     'BO_QTY' , 
//     'PO_QTY' , 
//     'BASE_PRICE' , 
//     'ORDER_SC' , 
//     'CREATE_BY' , 
//     'CREATE_DATE' , 
//     'LAST_UPD_PGM' , 
//     'LAST_UPD_BY' , 
//     'LAST_UPD_DATE' , 
//     'ATTRIBUTE01' , 
//     'ATTRIBUTE02' , 
//     'ATTRIBUTE03' , 
//     'ATTRIBUTE04' , 
//     'ATTRIBUTE05'
// ];
//public DataResult: PeriodicElement[];//shema of dataset result
//end//For dev show data set

public Vendor_Type_List: any = [];//for combobox show data

  constructor(
    private HttpService: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals 
  ) { 

  }

public lookupConfigVendor: any = {
  ColName: "LOOKUP_VENDOR_NAME",
  ColValue: "",
  PlaceholderText: "Select Vendor",
  SourceController: "wPMS",
  SourceMethodName: "GetVendorCode",
  NoOfShowRecords: 50,
  MinLengthSearch: 1,
  UpperCase: true
}

SetSelectVendorFrom(event){
  console.log("Show me",event);
  console.log(event.VENDOR_CODE);
  this.ListDataReportCondition.VENDOR_CODE_FROM = event.VENDOR_CODE;
}

SetSelectVendorTo(event){
  this.ListDataReportCondition.VENDOR_CODE_TO = event.VENDOR_CODE;
}

public lookupConfigPart: any = {
  ColName: "LOOKUP_PART_NAME",
  ColValue: "PART_NO",
  PlaceholderText: "Select Part No.",
  SourceController: "wPMS",
  SourceMethodName: "GetPartNo",
  NoOfShowRecords: 100,
  MinLengthSearch: 5,
  UpperCase: true
}

//for config autoc version KK
public ListDataReportCondition: any = {      
        
  VENDOR_CODE_FROM : null,
  VENDOR_CODE_TO : null,
  VENDOR_TYPE_FROM : null,
  VENDOR_TYPE_TO : null,
  PART_NO_FROM : null,
  PART_NO_TO : null,
  //Staff_ID : null,  
};

  ngOnInit() {
    this.Vendor_Type_List = [{ ID: '', TEXT: "" },{ ID: 'J', TEXT: "J:Japan" }, { ID: 'K', TEXT: "K:Import(Not Japan)" }, { ID: 'L', TEXT: "L:Local" }]
  }

  Search() {
    //Comment By: BF [14M1Y2020]
    //For: Show report viewer, screen will not show table dataset.     
    //this.CheckSearchCondition();
    // this.HttpService.post('IC', 'SNPR008_M_Get_Suggest_Order', this.ListDataReportCondition)
    //     .subscribe(res => {
    //         console.log("res",res);
    //         this.DataResult = res.Table;//pointer with []
    //     })
    //end comment

    if(this.CheckSearchCondition()){
      this.GoToReport();//show roport viewer.
    }
  }

  GoToReport() {
    console.log('Show list data report',this.ListDataReportCondition);
    this.global.GoToReport("PMS_RPT_IC_SNPR008", {  P_PART_NO_FROM: this.ListDataReportCondition.PART_NO_FROM, 
                                                    P_PART_NO_TO: this.ListDataReportCondition.PART_NO_TO, 
                                                    P_VENDOR_CODE_FROM: this.ListDataReportCondition.VENDOR_CODE_FROM,
                                                    P_VENDOR_CODE_TO: this.ListDataReportCondition.VENDOR_CODE_TO,
                                                    P_VENDOR_TYPE_FROM: this.ListDataReportCondition.VENDOR_TYPE_FROM,
                                                    P_VENDOR_TYPE_TO: this.ListDataReportCondition.VENDOR_TYPE_TO  
                                                  })
  }

  CheckSearchCondition():boolean{
    let boolHadSelectedCondition : boolean;
    boolHadSelectedCondition = false;//maening: User is not selecting condition search report.
    //define Emply string to Null, when call report, emply string will not sent to server report.
    if(!this.ListDataReportCondition.VENDOR_CODE_FROM){this.ListDataReportCondition.VENDOR_CODE_FROM =null;}
    if(!this.ListDataReportCondition.VENDOR_CODE_TO){this.ListDataReportCondition.VENDOR_CODE_TO = null;} 
    
    if(!this.ListDataReportCondition.VENDOR_TYPE_FROM){this.ListDataReportCondition.VENDOR_TYPE_FROM = null;} 
    if(!this.ListDataReportCondition.VENDOR_TYPE_TO){this.ListDataReportCondition.VENDOR_TYPE_TO = null;} 

    if(!this.ListDataReportCondition.PART_NO_FROM){this.ListDataReportCondition.PART_NO_FROM = null;}
    if(!this.ListDataReportCondition.PART_NO_TO){this.ListDataReportCondition.PART_NO_TO = null;}
    //console.log("When clear emply string:",this.ListDataReportCondition);

    //check From and To condition when user select only from or only to. must put value to it.
    if(this.ListDataReportCondition.VENDOR_CODE_FROM == null){this.ListDataReportCondition.VENDOR_CODE_FROM = this.ListDataReportCondition.VENDOR_CODE_TO; boolHadSelectedCondition = true;}
    if(this.ListDataReportCondition.VENDOR_CODE_TO == null){this.ListDataReportCondition.VENDOR_CODE_TO = this.ListDataReportCondition.VENDOR_CODE_FROM; boolHadSelectedCondition = true;} 
    
    if(this.ListDataReportCondition.VENDOR_TYPE_FROM == null){this.ListDataReportCondition.VENDOR_TYPE_FROM = this.ListDataReportCondition.VENDOR_TYPE_TO; boolHadSelectedCondition = true;} 
    if(this.ListDataReportCondition.VENDOR_TYPE_TO == null){this.ListDataReportCondition.VENDOR_TYPE_TO = this.ListDataReportCondition.VENDOR_TYPE_FROM; boolHadSelectedCondition = true;} 

    if(this.ListDataReportCondition.PART_NO_FROM == null){this.ListDataReportCondition.PART_NO_FROM = this.ListDataReportCondition.PART_NO_TO; boolHadSelectedCondition = true;}
    if(this.ListDataReportCondition.PART_NO_TO == null){this.ListDataReportCondition.PART_NO_TO = this.ListDataReportCondition.PART_NO_FROM; boolHadSelectedCondition = true;}

      return boolHadSelectedCondition;
  }//end CheckSearchCondition

}//end class

// //for Column of Data set (Report Viewer)
// export interface PeriodicElement {
    
//   COMPANY_CODE: string ; 
//   GROUP_PART_NO: string ; 
//   VENDOR_CODE: string; 
//   VENDOR_TYPE: string; 
//   ONLINE_FLAG: string; 
//   PART_CATEGORY: number; 
//   ORDER_QTY_EDF: number; 
//   SUGGEST_STATUS: string; 
//   PO_PROCESS_DATE: Date; 
//   ORDER_QTY_MANUA: number; 
//   ORDER_STATUS: string; 
//   ORDER_QTY_N_01: number; 
//   ORDER_QTY_N_02: number; 
//   ORDER_QTY_N_03: number; 
//   ORDER_QTY_N_04: number; 
//   ORDER_QTY_N_05: number; 
//   ORDER_QTY_N_06: number; 
//   ORDER_QTY_N_07: number; 
//   ORDER_QTY_N_08: number; 
//   ORDER_QTY_N_09: number; 
//   ORDER_QTY_N_10: number; 
//   ORDER_QTY_N_11: number; 
//   ORDER_QTY_N_12: number; 
//   OH_QTY: number; 
//   BO_QTY: number; 
//   PO_QTY: number; 
//   BASE_PRICE: number; 
//   ORDER_SC: number; 
//   CREATE_BY: string; 
//   CREATE_DATE: Date; 
//   LAST_UPD_PGM: string; 
//   LAST_UPD_BY: string; 
//   LAST_UPD_DATE: Date; 
//   ATTRIBUTE01: string; 
//   ATTRIBUTE02: string; 
//   ATTRIBUTE03: string; 
//   ATTRIBUTE04: string; 
//   ATTRIBUTE05: string;
// }
