import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewContainerRef, ViewChild } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snsq094',
  templateUrl: './snsq094.component.html',
  styleUrls: ['./snsq094.component.css']
})



export class SNSQ094Component implements OnInit {


  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals,
    private router: Router
  ) { }

  public params: any = {};
  public dataHeader: any = [];
  public dataDetail: any = {};
  public dataSummary: any = [];
  public dataPartList: any = {};

  public InvoiceConfig: any = {
    ColName: "INVOICE_VENDOR",
    ColValue: "",
    PlaceholderText: "Select Invoice No.",
    SourceController: "wPMS",
    SourceMethodName: "GetInvoiceImport",
    NoOfShowRecords: 50,
    MinLengthSearch: 3,
    UpperCase: true
  }

  public tblFooter: any = [
    {
      fieldName: "ACCEPT_PART_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "CIF_FREIGHT_AMT_B",
      show: true
    },
    {
      fieldName: "CIF_INSURANCE_AMT_B",
      show: true
    },
    {
      fieldName: "CIF_OTHER_AMT_B",
      show: true
    },
    {
      fieldName: "EXP_CLEANRANCE_AMT_B",
      show: true
    },
    {
      fieldName: "EXP_FREIGHT_AMT_B",
      show: true
    },
    {
      fieldName: "EXP_OTHER_AMT_B",
      show: true
    },
    {
      fieldName: "INCOME_TAX",
      show: true
    },
    {
      fieldName: "EXCISE_TAX",
      show: true
    },
    {
      fieldName: "INTERIOR_TAX",
      show: true
    },
    {
      fieldName: "RACK_DUTY",
      show: true
    },
    {
      fieldName: "OTHER_TAX",
      show: true
    },
    {
      fieldName: "TOT_AMT_B",
      show: true
    },
    {
      fieldName: "TOT_AMT_C",
      show: true
    },
    {
      fieldName: "FREIGHT_AMT_B",
      show: true
    },
    {
      fieldName: "INS_AMT_B",
      show: true
    },
    {
      fieldName: "EXPENSE_AMT_B",
      show: true
    },
    {
      fieldName: "DUTY_AMT_B",
      show: true
    },
    {
      fieldName: "OTHER_AMT_B",
      show: true
    },
    {
      fieldName: "TOT_AMT_CIF_B",
      show: true
    },
    {
      fieldName: "TOT_QTY",
      show: true
    },
    {
      fieldName: "TOT_GOODS",
      show: true
    },
    {
      fieldName: "TOT_GOODS_CUSTOM",
      show: true
    },
    {
      fieldName: "TOT_AMT_ALL",
      show: true
    }


  ]

  ngOnInit() {
    this.dataHeader.C_AUTO_CAL_DUTY = true;
  }

  public InvoiceChanged(value: any) {
    this.params.INVOICE_NO = value.INVOICE_NO;
    this.params.INVOICE_DATE = value.INVOICE_DATE;
    this.params.VENDOR_CODE = value.VENDOR_CODE;
    this.params.VENDOR_NAME = value.VENDOR_NAME;
    this.GetpartList();
  }

  public GetpartList() {
    this.http.post("AC", "SNPE007_GetPartExpList", this.params)
      .subscribe(result => {
        if (result != 'Error') {
          this.dataPartList = result.Table;
        } else {
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        }
      }, err => {
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public Report() {
    this.global.GoToReport("PMS_RPT_ACC_SNPE007",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_INVOICE_NO: this.params.INVOICE_NO,
        P_INVOICE_DATE: this.params.INVOICE_DATE,
        P_VENDOR_CODE: this.params.VENDOR_CODE
      }
    );
  }
}
