import { Component, OnInit, ViewEncapsulation, ViewChild, ViewContainerRef, ElementRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snm033p',
  templateUrl: './snm033p.component.html',
  styleUrls: ['./snm033p.component.css'],
  encapsulation: ViewEncapsulation.None
})



export class SNM033PComponent implements OnInit {
  options: FormGroup;
  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewRef: ViewContainerRef
  ) {


  }



  @ViewChild("dialogEdit", { static: false }) dialogEdit: any;
  @ViewChild("dialogAdd", { static: false }) dialogAdd: any; //dialogUpload
  @ViewChild("dialogUpload", { static: false }) dialogUpload: any; //dialogUpload
  @ViewChild("fileInput") fileInput: ElementRef;


  public tableDataUpload : any = [];
  public correctData : any = [];
  private file : any;
  public fileNameInput: string = "";
  public isSave : boolean = false;
  public CustomerList: any;
  private loaded: boolean = false;
  public tableData: any = [];
  //public Update: any = [];
  public tableName: string;
  public show: boolean = true;
  public locationNo: string = '';
  public updateData: any = {};
  public addData: any = {};

  public ConfigLocation: any = {
    ColName: "LOCATION_NO",
    ColValue: "LOCATION_NO",
    PlaceholderText: "Select Location",
    SourceController: "wPMS",
    SourceMethodName: "GetLocation",
    NoOfShowRecords: 30,
    MinLengthSearch: 3,
    UpperCase: true
  }


  public ConfigRackCode: any = {
    ColName: "RACK_CODE",
    ColValue: "RACK_CODE",
    PlaceholderText: "Select Rack Code",
    SourceController: "wPMS",
    SourceMethodName: "GetRackCode",
    NoOfShowRecords: 100,
    MinLengthSearch: 0,
  }

  public ConfigRackGroupCode: any = {
    ColName: "RACK_GROUP_CODE",
    ColValue: "RACK_GROUP_CODE",
    PlaceholderText: "Select Rack Group Code",
    SourceController: "wPMS",
    SourceMethodName: "GetRackGroupCode",
    NoOfShowRecords: 30
  }

  public ConfigReasonCode: any = {
    ColName: "LOOKUP_REASON",
    ColValue: "REASON_CODE",
    PlaceholderText: "Select Reason Code",
    SourceController: "wPMS",
    SourceMethodName: "GetReasonCode",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
  }

  public ConfigPart: any = {
    ColName: "LOOKUP_PART_NAME",
    ColValue: "PART_NO",
    PlaceholderText: "Select Part No",
    SourceController: "wPMS",
    SourceMethodName: "GetPartNo",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
  }

  public CategolyList = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]

  ngOnInit() {

    this.locationNo = '';
  }

  public PrepareAdd() {
    this.addData = {};

    this.addData.LOCATION_NO = '';
    this.addData.PART_NO = '';
    this.addData.DIMENSION_MAX = 0;
    this.addData.DIMENSION_MID = 0;
    this.addData.DIMENSION_MIN = 0;
    this.addData.RACK_CODE = '';
    this.addData.RACK_GROUP_CODE = '';
    this.addData.SEQUENCE_NO = '';
    this.addData.PART_CATEGORY = '';
    this.addData.LOCK_LOCATION = '';
    this.addData.FLOOR_NO = '';
    this.addData.MAX_WEIGHT = 0;
    this.addData.CAPACITY_QTY = 0;
    this.addData.SHELVE_QTY = 0;

    this.addData.TEMP_LOCATION = '';
    this.addData.DISTANCE_RECEIVE1 = 0;
    this.addData.DISTANCE_RECEIVE2 = 0;
    this.addData.DISTANCE_RECEIVE3 = 0;
    this.addData.DISTANCE_DELIVERY1 = 0;
    this.addData.DISTANCE_DELIVERY2 = 0;
    this.addData.DISTANCE_DELIVERY3 = 0;
    this.addData.ATTRIBUTE2 = '';
    this.addData.ATTRIBUTE5 = '';

    this.dialogAdd.OpenDialog();
  }


  public Search() {

    if (this.locationNo.length < 4) {
      this.modal.warning("Please input location at less 4 characters.", this.viewRef);
      return;
    } else {
      this.tableData = [];
      this.http.get('WH', 'SNM033P_GetData', this.locationNo.toUpperCase())
        .subscribe(res => {
          this.tableData = res.Table;
          //this.updateData = this.tableData.filter((x, i) => x.LOCATION_NO == this.updateData.LOCATION)[0];

          //let filter = this.designNoteList.filter((x, i) => x.DESIGN_NOTE_NUMBER == event.DESIGN_NOTE_NUMBER && index != i)
          // console.log('res',res)
          //this.Update = this.tableData.reduce((prev, current) => (prev.LAST_UPD_DATE > current.LAST_UPD_DATE) ? prev : current)
        }, (err) => {
          console.log(err, 'err');
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
    }
  }



  public EditRow(row) {
    this.updateData = row;
    this.updateData.TEMP_LOCATION == 'N' ? (
      this.updateData.LOCATION_STATUS = '',
      this.updateData.ATTRIBUTE5 = ''
    ) : (
      this.updateData.LOCATION_STATUS,
      this.updateData.ATTRIBUTE5
    ) 
    this.dialogEdit.OpenDialog();
    //console.log('updateData',this.updateData)
  }


  public SaveAdd() {
    // console.log(this.addData);
    this.modal.confirm('Do you want to save changed you have made?', this.viewRef, this.ConfirmSaveAdd)
  }


  public ConfirmSaveAdd = () => {

    this.addData.LOCATION_NO = this.addData.LOCATION_NO.toUpperCase();
    this.http.post('WH', 'SNM033P_InsertLocation', this.addData)
      .subscribe(res => {

        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Successfully to add new location : ' + this.addData.LOCATION_NO, this.viewRef);
          this.dialogAdd.Close()
          this.locationNo = this.addData.LOCATION_NO;
          this.Search();
        } else if (res.Table[0].STATUS == 'DUPPLICATE') {
          this.modal.warning('Found dupplicate location.', this.viewRef);
        } else {
          this.modal.error('Transaction not complete 1 record not applied', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }

  public SaveEdit() {
    this.modal.confirm('Do you want to save changed you have made?', this.viewRef, this.ConfirmSaveEdit)

  }

  public ConfirmSaveEdit = () => {
    this.http.post('WH', 'SNM033P_UpdateLocation', this.updateData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Successfully to edit the location data', this.viewRef);
          this.dialogEdit.Close();
          this.Search();
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }

  public CancelEdit() {
    this.dialogEdit.Close();
  }


  public Delete(data) {

    if (data.PART_NO) {
      this.modal.warning('Can not delete part no error', this.viewRef)
    } else {
      this.modal.confirm('Do you want to delete record?', this.viewRef, () => this.ConfirmDelete(data))
    }
  }

  public ConfirmDelete = data => {

    this.http.get('WH', 'SNM033P_Delete', data.LOCATION_NO.toUpperCase())
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Delete completed!', this.viewRef);
          this.dialogEdit.Close()
          this.Search();
        } else {
          this.modal.info('Delete not completed!', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }

  public CancelAdd() {
    this.dialogAdd.Close();
  }

  public ClearLocatePart() {
    this.modal.confirm('Do you want to remove this part?', this.viewRef, this.ConfirmClearPart)
  }
  public ConfirmClearPart = () => {
    this.http.post('WH', 'SNM033P_ClearPart', this.updateData)
      .subscribe(res => {
        this.updateData = res.Table[0];
        this.updateData.LAST_UPD_DATE = '';
        this.modal.info('Transaction completed', this.viewRef);
        //this.dialogEdit.Close()
        this.Search();
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }


  public OpenUpload(){
    this.isSave =false;
    this.tableDataUpload = [];
    this.fileNameInput = ""
    this.correctData = []
    this.dialogUpload.OpenDialog()
  }

  public OpenFileBrowser() {
    this.fileNameInput = "";
    this.fileInput.nativeElement.value = '';
    this.fileInput.nativeElement.click();
  }

  public SelectFile(evt) {
    let Files: Array<File> = evt.target.files;

    if (Files.length > 0) {
      //let File: File = Files[0];
      this.file = Files[0];
      this.fileNameInput = this.file.name;
    }
  }

  public PreView() {

    if (!this.fileInput) {
      this.modal.warning("Please Open File First...", this.viewRef)
      return;
    }
    
        let formData = new FormData();
        formData.append('file', this.file);
        this.tableDataUpload = []
        this.http.postFile("WH", "SNM033P_UploadFile", formData)
            .subscribe(result => {
              
              this.modal.info("Upload complete",this.viewRef);      
              this.tableDataUpload = result.filter(x => x.LOCATION_NO)
              this.correctData = this.tableDataUpload.filter(x => x.ERR_FLAG == 'N')
              this.isSave = false;
              

            }, err => {
              this.modal.error("Upload not complete", this.viewRef);
            })

    
  }

  public SaveByUpload (){

    this.modal.confirm("Do you want to save location master?",this.viewRef,() => ConfirmSave())


    let ConfirmSave = () =>{

      let data = {
        DETAIL : this.correctData
      }
  
      this.http.post("WH","SNM033P_SaveByUpload",data)
      .subscribe(res => {
          if (res.STATUS == 'DONE'){
            this.isSave = true
            this.modal.info("Save location master " + this.correctData.length + " records complete",this.viewRef)
          }else{
            this.modal.error('Found an error, please contact support team', this.viewRef);
          }
      },err => {
        this.modal.error('Found an error, please contact support team', this.viewRef);
      })

    }
   
  }

  public DownloadTemplate(){
    let link = "assets/templates/New_Location_template.xlsx"
    window.open(link,'_blank')
  }

}

