import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'snm101p',
    templateUrl: './SNM101P.component.html',
    styleUrls: ['./SNM101P.component.css']
})



export class SNM101PComponent implements OnInit {


    constructor(
        private http: HttpService,
        private modal: ModalService,
        private viewref: ViewContainerRef
    ) { }

    public ConfigPart: any = {
        ColName: "LOOKUP",
        PlaceholderText: "Select Part No.",
        SourceController: "MKT",
        SourceMethodName: "SNM101P_GetPart",
        NoOfShowRecords: 30
    }

    public ConfigPartMaster: any = {
        ColName: "LOOKUP",
        PlaceholderText: "Select Part No.",
        SourceController: "MKT",
        SourceMethodName: "SNM101P_GetPartMaster",
        NoOfShowRecords: 30
    }

    public CustomerList: any = [];
    public paramData: any = {};
    public paramSearch: any = {};
    public isAdd: boolean = false;
    public tabledata: any = [];
    @ViewChild("dialog", { static: false }) dialog: any;

    ngOnInit() {

    }

    public Search() {
        this.http.post("MKT","SNM101P_Search",this.paramSearch)
        .subscribe(res =>{
            this.tabledata = res.Table
        })
    }

    Add(){
        this.paramData = {}
        this.isAdd = true
        this.dialog.title = "Add Parts"
        this.dialog.OpenDialog();
      }

    EditRow(data){
    

        this.http.post("MKT","SNM101P_Search",data)
        .subscribe(res =>{
          
          if(res.Table.length > 0){
            this.isAdd = false;
            this.paramData = res.Table[0];
            this.dialog.title = "Edit Parts"
            this.dialog.OpenDialog();
          }else{
            this.modal.warning("Parts not found",this.viewref)
          }
        })
      }


    public SetPartNo(event) {
        this.paramData.PART_NO = event.PART_NO
        this.paramData.PART_NAME_EN = event.PART_NAME_EN
        this.paramData.PART_NAME_TH = event.PART_NAME_TH
        this.paramData.DIMENSION_MAX = event.DIMENSION_MAX
        this.paramData.DIMENSION_MID = event.DIMENSION_MID
        this.paramData.DIMENSION_MIN = event.DIMENSION_MIN
    }


    public Save() {
        this.modal.confirm("Do you want to save you have made?", this.viewref,this.ConfirmSave)
    }

    private ConfirmSave = () => {
        if (this.isAdd) {
            this.http.post("MKT", "SNM101P_Insert", this.paramData)
                .subscribe(res => {
                    if (res.STATUS_MSG == 'DONE') {
                        this.modal.info('Transaction complete: applied and saved.', this.viewref);
                        if (this.tabledata.length > 0) {
                            this.Search();
                        }
                        this.dialog.Close();
                    } else if (res.STATUS_MSG == 'DUPPLICATE') {
                        this.modal.info('No change to save. Found duplicate record.', this.viewref);
                    }
                    else {
                        this.modal.warning('No change to save. Add fail.', this.viewref);
                    }
                }, (err) => {
                    this.modal.warning('No change to save. Add fail.', this.viewref);
                })
        }
        else {
            this.http.post("MKT", "SNM101P_Update", this.paramData)
                .subscribe(res => {
                    if (res.STATUS_MSG == 'DONE') {
                        this.modal.info('Transaction complete: applied and saved.', this.viewref);
                        this.Search();
                        this.dialog.Close();
                    }
                    else {
                        this.modal.warning('No change to save. Update fail.', this.viewref);
                    }
                }, (err) => {
                    this.modal.warning('No change to save. update fail.', this.viewref);
                })
        }
    }


    Delete(data){
        this.modal.confirm("Do you want to delete racord?",this.viewref,() =>{
          this.http.post("MKT","SNM101P_Delete",data)
          .subscribe(res =>{
            if (res.STATUS_MSG == 'DONE') {
              this.modal.info('Transaction complete: 1 record applied and deleted.', this.viewref);
              this.Search();
              this.dialog.Close();
            }
            else {
                this.modal.warning('Delete fail.', this.viewref);
            }
          },err => {
            this.modal.warning('Delete fail.', this.viewref);
          })
        })
      }

}
