import { SelectionModel } from "@angular/cdk/collections";
import { CdkDragDrop, moveItemInArray } from "@angular/cdk/drag-drop";
import { Component, ElementRef, HostListener, OnInit, ViewChild, ViewContainerRef } from "@angular/core";
import { MatTable, MatTableDataSource } from "@angular/material/table";
//import { AutoTableeorderComponent } from "src/app/components/shared/auto-table-reoder/auto-table-reorder.component";
import { Globals } from "src/app/core/global";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";
import { SignalrService } from "src/app/core/signalr.service";

@Component({
  selector: 'SNWR020',
  templateUrl: 'SNWR020.component.html',
  styleUrls: ['SNWR020.component.css']
})
export class SNWR020Component implements OnInit {

  public mode: number = 2
  public message: string;
  public tableDataNopick: any = [];
  public tableDataPicking: any = [];
  public tableDataPicked: any = [];
  public tableDataNopickCust: any = [];
  public tableDataPickingCust: any = [];
  public tableDataPickedCust: any = [];
  public border: any = ["2px solid red", "2px solid green", "2px solid blue"];
  public headerListByCust: any = [];
  public headerListByPick: any = [];
  public displayedColumns: string[] = [];
  public displayedColumnsByCust: string[] = [];
  public displayedColumnsByPick: string[] = [];
  public maxHight = '40vh';
  @ViewChild('tableCustNopick') tableCustNopick: MatTable<any>;
  @ViewChild('tableCustPicking') tableCustPicking: MatTable<any>;
  @ViewChild('tableCustPicked') tableCustPicked: MatTable<any>;
  private MainInterval: any;
  //@ViewChild("reOrderPickedCust", { static: false }) reOrderPickedCust: AutoTableeorderComponent;
  constructor(
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private http: HttpService,
    private el: ElementRef,
    private global: Globals,
    private signalR: SignalrService
  ) {
    this.signalR.initiateSignalrConnection();
    this.signalR.proxy.on('nopick', (data: any) => this.GetNopickData(data));
    this.signalR.proxy.on('picking', (data: any) => this.GetPickingData(data));
    this.signalR.proxy.on('picked', (data: any) => this.GetPickedData(data));
    this.signalR.proxy.on('nopickcust', (data: any) => this.GetNopickCustData(data));
    this.signalR.proxy.on('pickingcust', (data: any) => this.GetPickingCustData(data));
    this.signalR.proxy.on('pickedcust', (data: any) => this.GetPickedCustData(data));
    //this.signalR.connection.start();
    this.signalR.connection.start().done((dataconnect: any) => {
      this.AutoGetData();
    }).fail((error: any) => {
      console.log('Could not connect ' + error);
    });
  }

  @HostListener('window:beforeunload', [ '$event' ])
  beforeUnloadHandler(event) {
    this.DeleteTask();
  }

  ngOnInit(): void {
    //this.StartService();
    this.getTableHeader();

    setTimeout(() => {
      this.AutoGetData();
      this.SetTask();
    }, 1000);
    
   this.MainInterval = setInterval(() => {
      //this.AutoGetData();
      this.SetIntervar();
    },3000)
    
  }

  private SetTask(){
    this.http.get("WH","SNWR020_SetTask")
    .subscribe(res =>{
    })
  }

  private DeleteTask(){
    this.http.get("WH","SNWR020_DeleteTask")
    .subscribe(res =>{

    })
  }

  getTableHeader() {
    let data = {
      BY_CUST: 'SNWR020_CUST',
      BY_PICK: 'SNWR020_PICKER'
    }
    this.http.post("System", "GetHeaderGridViewMonitor", data)
      .subscribe(result => {
        console.log('reeee', result)
        this.headerListByCust = result.Table.filter(v => v.VISIBILITY === true);
        this.headerListByPick = result.Table1.filter(v => v.VISIBILITY === true);
        this.ArrangeShowColumn(this.headerListByCust);
      })
  }

  ArrangeShowColumn(data) {
    this.displayedColumnsByCust = this.headerListByCust.map(v => v.FIELD_NAME);
    this.displayedColumnsByPick = this.headerListByPick.map(v => v.FIELD_NAME);
    // this.displayedColumnsNopick = this.headerListByCust.filter(v => v.FIELD_NAME != 'PICK_QTY')
    // .map(v => v.FIELD_NAME);
  }

  private AutodropTable1(data: any, table: any) {
    moveItemInArray(data, 0, data.length);
    table.renderRows();
  }

  private AutodropTable2(data: any, table: any) {
    moveItemInArray(data, 0, data.length);
    table.renderRows();
  }

  private AutodropTable3(data: any, table: any) {
    moveItemInArray(data, 0, data.length);
    table.renderRows();
  }

  dropTable(event: CdkDragDrop<any[]>) {
    // const prevIndex = this.tableNopickCust.findIndex((d) => d === event.item.data);
    // moveItemInArray(this.tableNopickCust, prevIndex, event.currentIndex);
    //this.table.renderRows();
  }




  ngOnDestroy(): void {
    this.signalR.connection.stop();
  }

  private AutoGetData() {
    //this.signalR.proxy.invoke("GetNoPick")
    //this.signalR.proxy.invoke("GetPicking")
    //this.signalR.proxy.invoke("GetPicked")
    this.signalR.proxy.invoke("GetNoPickCust")
    this.signalR.proxy.invoke("GetPickingCust")
    this.signalR.proxy.invoke("GetPickedCust")
  }

  private GetNopickData(data: any) {
    this.tableDataNopick = data.Table;
  }

  private GetPickingData(data: any) {
    this.tableDataPicking = data.Table;
  }

  private GetPickedData(data: any) {
    this.tableDataPicked = data.Table;
  }

  private GetNopickCustData(data: any) {
    this.tableDataNopickCust = [];
    this.tableDataNopickCust = data.Table;
  }

  private GetPickingCustData(data: any) {
    this.tableDataPickingCust =[]
    this.tableDataPickingCust = data.Table;
  }

  private GetPickedCustData(data: any) {
    this.tableDataPickedCust = []
    this.tableDataPickedCust = data.Table;
  }

  private SetIntervar(){
    this.AutodropTable1(this.tableDataNopickCust, this.tableCustNopick)
    this.AutodropTable2(this.tableDataPickingCust, this.tableCustPicking)
    this.AutodropTable3(this.tableDataPickedCust, this.tableCustPicked)
}


}
