import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snse140',
  templateUrl: 'SNSE140.component.html'
})

export class SNSE140Component implements OnInit {
  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef
  ) { }

  public ParamsSearch: any = {};
  public TableData: any[] = [];
  
  public SupplierConfig: any = {
    ColName: "LOOKUP_VENDOR_NAME",
    ColValue: "",
    PlaceholderText: "Select Supplier Code",
    SourceController: "wPMS",
    SourceMethodName: "GetVendorCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0
  }
  public PartConfig: any = {
    ColName: "LOOKUP_PART",
    PlaceholderText: "Select Part no",
    SourceController: "wPMS",
    SourceMethodName: "GetPartNo",
    NoOfShowRecords: 50,
  }
  
  ngOnInit() { 
    this.ParamsSearch = {
      RECEIVED_STATUS: "A"
    }
  }

  public GetPrice() {
    this.TableData = []
    this.http.post("TI", "SNSE140_GetPrice", this.ParamsSearch)
      .subscribe(res => {
        console.log(res)
        this.TableData = res.Table;
      })
  }
}