import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';
import { MatDatepicker } from '@angular/material/datepicker';

enum PageAction {
  Search = 0,
  Detail,
  Retrive
}

@Component({
  selector: 'snse052M',
  templateUrl: './SNSE052M.component.html',
  styleUrls: ['./SNSE052M.component.css']
})

export class SNSE052MComponent implements OnInit {

  constructor(
    private Http: HttpService,
    private global: Globals,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  @ViewChild("dialogMain", { static: false }) dialogMain: any;

  public tableData: any = [];
  public tableData2: any = [];
  public tableData3: any = [];
  public formData: any = {
    CUSTOMER_CODE_0: null,
    CUSTOMER_CODE_1: null,
    CUSTOMER_CODE_2: null,
    CUSTOMER_CODE_3: null,
    CUSTOMER_CODE_4: null,
    PICKING_LIST_NO_0: null,
    PICKING_LIST_NO_1: null,
    PICKING_LIST_NO_2: null,
    PICKING_LIST_NO_3: null,
    PICKING_LIST_NO_4: null,
  };
  public params: any = {}

  public combine: any = {}
  public IsCombine: boolean = false;

  public dataIsSelected: any = [];
  public selection = new SelectionModel<any>(true, []);
  public PageAction: number;


  ngOnInit() {
    this.params.ALLOCATE_DATE_FROM = new Date("2000-01-01");
    this.params.ALLOCATE_DATE_TO = new Date();
    //this.GetFromDate();
    //this.GetToDate();
    this.params.CNT_REC = 0;
    this.params.PICK_LOT_DATE = new Date();
    this.params.PICK_LOT_SEQ = 1;
    this.params.CNT_SEL = 0;
    this.params.LOCATION = "0";
    this.params.AUTO_PRINT = "0";
    this.params.ORDER_CLASS = "";
    this.params.PRINTER_NAME = "0";
    this.params.PRINTER = "3";
    this.params.LOCATION_FROM = "1A";
    this.params.LOCATION_TO = "1B";
    this.NewCombine();
  }


  //------------------SEARCH NORMAL--------------------
  public lookupFromAllocateDateConfig: any = {
    ColName: "DIS_ALLOCATE_DATE",
    PlaceholderText: "Select From Allocate Date",
    SourceController: "SL",
    SourceMethodName: "SNSE052M_getAllocateFromDate",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedFromAllocateDate(values: any) {
    this.params.FROM_DATE = values.DIS_ALLOCATE_DATE;
    this.params.ALLOCATE_DATE_FROM = values.ALLOCATE_DATE;
  }

  public lookupToAllocateDateConfig: any = {
    ColName: "DIS_ALLOCATE_DATE",
    PlaceholderText: "Select To Allocate Date",
    SourceController: "SL",
    SourceMethodName: "SNSE052M_getAllocateToDate",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedToAllocateDate(values: any) {
    this.params.TO_DATE = values.DIS_ALLOCATE_DATE;
    this.params.ALLOCATE_DATE_TO = values.ALLOCATE_DATE;
  }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE052M_getCustomerCode",
    NoOfShowRecords: 100,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUSTOMER_NAME;
  }

  public lookupOrderNoConfig: any = {
    ColName: "LOOKUP_ORDER_NO",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSE052M_GetOrderNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedOrderNo(value: any) {
    this.params.ORDER_NO = value.ORDER_NO;
  }

  public lookupAcceptPartNoConfig: any = {
    ColName: "LOOKUP_ACCEPT_PART_NO",
    PlaceholderText: "Select Accept Part No",
    SourceController: "SL",
    SourceMethodName: "SNSE052M_GetAcceptPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedAcceptPartNo(value: any) {
    this.params.ACCEPT_PART_NO = value.ACCEPT_PART_NO;
  }

  public lookupFromPickListNoConfig: any = {
    ColName: "PICK_LIST_NO_LOOKUP",
    PlaceholderText: "Select From Picking List",
    SourceController: "SL",
    SourceMethodName: "SNSE052M_GetPickingListNoFrom",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedFromPickListNo(values: any) {
    this.params.FROM_PICK_LIST_NO = values.PICK_LIST_NO;

    if (!this.params.TO_PICK_LIST_NO) {
      this.params.TO_PICK_LIST_NO = values.PICK_LIST_NO;
    }
  }

  public lookupToPickListNoConfig: any = {
    ColName: "PICK_LIST_NO_LOOKUP",
    PlaceholderText: "Select To Picking List",
    SourceController: "SL",
    SourceMethodName: "SNSE052M_GetPickingListNoTo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedToPickListNo(values: any) {
    this.params.TO_PICK_LIST_NO = values.PICK_LIST_NO;
  }
  //------------------END NORMAL--------------------

  //----------------SEARCH COMBINE------------------
  public lookupCombineCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE052M_getCombineCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedCombineCustomerCode(values: any, data: any) {
    data.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.combine.CUSTOMER_CODE = values.CUSTOMER_CODE;
  }

  public lookupCombinePickNoConfig: any = {
    ColName: "PICK_LIST_NO",
    PlaceholderText: "Select Picking List No",
    SourceController: "SL",
    SourceMethodName: "SNSE052M_getCombinePickNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.combine
    },
    UpperCase: true
  }

  public SetSelectedCombinePickNo(values: any, data: any) {
    data.PICKING_LIST_NO = values.PICK_LIST_NO;
    data.ORDER_CLASS = values.ORDER_CLASS;
    data.PICK_LOT_DATE = values.PICK_LOT_DATE;
    data.PICK_LOT_SEQ = values.PICK_LOT_SEQ;
    data.FIRST_PRINT_DATE = values.PICK_LOT_DATE;
  }
  //-----------------END COMBINE-------------------

  public Search = () => {
    this.dataIsSelected = [];
    this.selection.clear()
    this.tableData = [];
    if (this.IsCombine) {
      for (var i = 0; i < this.tableData3.length; i++) {
        this.formData['CUSTOMER_CODE_' + i] = this.tableData3[i].CUSTOMER_CODE
        this.formData['PICKING_LIST_NO_' + i] = this.tableData3[i].PICKING_LIST_NO
      }
      this.Http.post('SL', 'SNSE052M_getDataCombinePL', this.formData)
        .subscribe(res => {
          this.tableData = res.Table;
          this.params.CNT_SEL = 0
          this.params.CNT_REC = this.tableData.length
        });
    }
    else {
      this.Http.post('SL', 'SNSE052M_getData', this.params)
        .subscribe(res => {
          this.tableData = res.Table;
          this.params.CNT_SEL = 0
          this.params.CNT_REC = this.tableData.length
        });
    }
  }

  public isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tableData.length;
    return numSelected === numRows;
  }

  public Toggle() {
    if (this.isAllSelected()) {
      this.selection.clear()
      this.tableData.map(x => {
        this.dataIsSelected = [];
      })
    }
    else {
      this.tableData.forEach(row => this.selection.select(row));
      this.dataIsSelected = [];
      this.tableData.map(x => {
        this.dataIsSelected.push(x);
      })
    }
    this.params.CNT_SEL = this.dataIsSelected.length;
  }

  public CheckboxChange(event, data) {
    if (event.checked) {
      this.dataIsSelected.push(data);
    }
    else {
      this.dataIsSelected.splice(this.dataIsSelected.indexOf(data), 1);
    }
    this.params.CNT_SEL = this.dataIsSelected.length;
  }

  public CombinePL() {
    this.tableData2 = [];
    if (this.tableData3.length > 0) {
      this.tableData3.forEach((e, index, object) => {
        if (e.CUSTOMER_CODE == null && e.PICKING_LIST_NO == null) {
          object.splice(index, 1);
        }
      });
      this.tableData2 = this.tableData3
      this.tableData2.push({
        'EDIT': 'ADD',
        'SEQ': null,
        'CUSTOMER_CODE': null,
        'PICKING_LIST_NO': null,
        'ORDER_CLASS': null,
        'PICK_LOT_DATE': null,
        'PICK_LOT_SEQ': null,
        'FIRST_PRINT_DATE': null,
        'COMBINE_DATE': null
      });
    }
    else {
      this.NewCombine();
    }
    this.dialogMain.OpenDialog();
  }

  private NewCombine() {
    this.tableData2 = [];
    this.tableData2.push({
      'EDIT': 'ADD',
      'SEQ': null,
      'CUSTOMER_CODE': null,
      'PICKING_LIST_NO': null,
      'ORDER_CLASS': null,
      'PICK_LOT_DATE': null,
      'PICK_LOT_SEQ': null,
      'FIRST_PRINT_DATE': null,
      'COMBINE_DATE': null
    });
    this.tableData2 = this.tableData2.slice();
    this.PageAction = PageAction.Retrive;
  }

  public AppendRow() {
    for (var i = 0; i < this.tableData2.length; i++) {
      if (this.tableData2[i].EDIT === "ADD") {
        this.tableData2[i].EDIT = 'DEL';
        this.tableData2[i].SEQ = this.tableData2.length;
      }
    }
    if (this.tableData2.length < 5) {
      this.tableData2.push({
        'EDIT': 'ADD',
        'SEQ': null,
        'CUSTOMER_CODE': null,
        'PICKING_LIST_NO': null,
        'ORDER_CLASS': null,
        'PICK_LOT_DATE': null,
        'PICK_LOT_SEQ': null,
        'FIRST_PRINT_DATE': null,
        'COMBINE_DATE': null
      });
    }
    this.tableData2 = this.tableData2.slice();
  }

  public DeleteRow(Item) {
    if (this.PageAction == PageAction.Retrive) {
      let index = this.tableData2.findIndex(x => x == Item)
      this.tableData2.splice(index, 1);
      if (this.tableData2.find(e => e.EDIT === 'ADD') == undefined) {
        this.tableData2.push({
          'EDIT': 'ADD',
          'SEQ': null,
          'CUSTOMER_CODE': null,
          'PICKING_LIST_NO': null,
          'ORDER_CLASS': null,
          'PICK_LOT_DATE': null,
          'PICK_LOT_SEQ': null,
          'FIRST_PRINT_DATE': null,
          'COMBINE_DATE': null
        });
      }
      this.tableData2 = this.tableData2.slice();
    }
  }

  public AcceptCombine() {
    this.tableData3 = [];
    this.tableData2.forEach((e) => {
      if (e.CUSTOMER_CODE != null && e.PICKING_LIST_NO != null) {
        this.tableData3.push(e)
      }
      else {
        this.NewCombine();
      }
    });
    this.tableData2 = [];
    this.dialogMain.Close();
  }

  public ClearData() {
    this.NewCombine();
    this.tableData3 = [];
    this.dialogMain.Close();
  }

  public ConfirmProcess() {


    if (this.dataIsSelected.length > 0) {
      this.modal.confirm('Do you want to process and print picking cards? ' + '[Selected : ' + this.params.CNT_SEL + ' Items]', this.viewref, this.Condition)
    }
    else {
      this.modal.warning("No data selected.", this.viewref);
    }
  }


  public SetFromTo() {
    if (this.params.LOCATION == "1") {
      this.selection.clear();
      this.dataIsSelected = [];
      this.tableData.forEach((row) => {
        if (row.LOCATION_NO) {
          if (row.LOCATION_NO.substring(0, 2).toUpperCase() >= this.params.LOCATION_FROM.substring(0, 2).toUpperCase() && row.LOCATION_NO.substring(0, 2).toUpperCase() <= this.params.LOCATION_TO.substring(0, 2).toUpperCase()) {
            this.dataIsSelected.push(row);
            this.selection.select(row)

          }
          this.params.CNT_SEL = this.dataIsSelected.length;
        }
      });
    } else {
      this.selection.clear();
      this.dataIsSelected = [];
      this.tableData.forEach((row) => {
        this.dataIsSelected.push(row);
        this.selection.select(row)
        this.params.CNT_SEL = this.dataIsSelected.length;
      });
    }
  }


  private Condition = () => {
    if (this.tableData.length > 0) {
      if (this.dataIsSelected.length > 0) {
        this.dataIsSelected.forEach((e) => {
          e.LOCATION = this.params.LOCATION
          e.FROM_LOCATION = this.params.FROM_LOCATION
          e.TO_LOCATION = this.params.TO_LOCATION
        });
        this.Http.post('SL', 'SNSE052M_genCondition', this.dataIsSelected)
          .subscribe(res => {
            if (res.Table[0].STATUS == 'DONE') {
              if (this.IsCombine == true) {
                this.Http.post('SL', 'SNSE052M_combinePL', this.tableData3)
                  .subscribe(res => {
                    if (res.Table[0].STATUS == 'DONE') {             
                      this.OpenReport()
                    } else {
                      this.modal.warning("CombinePL Fail!!", this.viewref);                    }
                  }, (err) => {
                    console.log(err, 'err')
                    this.modal.warning("Found an error, please contract support team", this.viewref);
                  })
              }
              else {
            
                this.OpenReport()
              }
            }
            else {
              this.modal.warning("Generate Condition Fail!!", this.viewref);
            }
          }, (err) => {
            console.log(err, 'err')
            this.modal.warning("Found an error, please contract support team", this.viewref);
          })
      }
      else {
        this.modal.warning("No Select Data For Print", this.viewref);
      }
    }
    else {
      this.modal.warning("No Data Found For Print", this.viewref);
    }
  }

  private async OpenReport() {
    function delay(ms: number) {
      return new Promise(resolve => setTimeout(resolve, ms));
    }
    await delay(1000);
    if (this.IsCombine == true) {
      this.global.GoToReport("PMS_RPT_SALES_SNSE052R4_N",
        {
          P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
          P_IP: this.global.GetTokenDetail("ssUserName")
        });
    }
    else {
      this.global.GoToReport("PMS_RPT_SALES_SNSE052R3_N",
        {
          P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
          P_CUST_CODE: this.params.CUSTOMER_CODE,
          P_ORDER_NO: this.params.ORDER_NO,
          P_ALLOCATE_DATE_S: this.global.ConvertDateToFormatSTD(this.params.ALLOCATE_DATE_FROM),
          P_ALLOCATE_DATE_E: this.global.ConvertDateToFormatSTD(this.params.ALLOCATE_DATE_TO),
          P_PICK_LIST_NO_S: this.params.FROM_PICK_LIST_NO,
          P_PICK_LIST_NO_E: this.params.TO_PICK_LIST_NO,
          P_CREATE_BY: this.global.GetTokenDetail("ssUserName"),
          P_IP: this.global.GetTokenDetail("ssIPAddress"),
          P_TYPE: "REPRINT"
        });
    }
  }

  //GetToDate() {
  //  this.params.ALLOCATE_DATE = 'TO'
  //  this.Http.post('SL', 'SNSE052M_FirstLast_Date', this.params)
  //    .subscribe(res => {
  //      this.params.TO_DATE = res.Table[0].DIS_ALLOCATE_DATE
  //      this.params.ALLOCATE_DATE_TO = res.Table[0].ALLOCATE_DATE;
  //    });
  //}

  //GetFromDate() {
  //  this.params.ALLOCATE_DATE = 'FROM'
  //  this.Http.post('SL', 'SNSE052M_FirstLast_Date', this.params)
  //    .subscribe(res => {
  //      this.params.FROM_DATE = res.Table[0].DIS_ALLOCATE_DATE
  //      this.params.ALLOCATE_DATE_FROM = res.Table[0].ALLOCATE_DATE;
  //    });
  //}

  public OpendateFromPopup(datepicker: MatDatepicker<any>) {
    datepicker.open();
  }

  public OpendateToPopup(datepicker: MatDatepicker<any>) {
    datepicker.open();
  }
}
