import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from '../../../core/global';

@Component({

  selector: 'snse126_2_P',
  templateUrl: './SNSE126_2_P.component.html',
  styleUrls: ['./SNSE126_2_P.component.css']

})

export class SNSE126_2_PComponent implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private router: Router,
    private global: Globals
  ) { }


  public CustomerList: any;
  private loaded: boolean = false;
  public Date: any = new Date();
  public month: any = this.Date.getMonth() + 1;
  public year: any = this.Date.getFullYear();

  ngOnInit() {


    //this.CustomerList = [{ ID: 1, CUSTOMER_CODE: "AAA" }, { ID: 2, CUSTOMER_CODE: "BBB" }, { ID: 3, CUSTOMER_CODE: "CCC" }]

    //this.loaded = true;
  }

  public GoToReport_SNSE126_2() {
    this.global.GoToReport("PMS_RPT_TI_SNSE126_2", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year.toString(),
      P_PROCESS_MONTH: this.month.toString()
      })
  }


  public GoToReport_SNSE135R() {
    this.global.GoToReport("PMS_RPT_TI_SNSE135R", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }

  public GoToReport_SNSE123() {
    this.global.GoToReport("PMS_RPT_TI_SNSE123", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }

  public GoToReport_SNSE126_3() {
    this.global.GoToReport("PMS_RPT_TI_SNSE126_3", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year.toString(),
      P_PROCESS_MONTH: this.month.toString()
      })
  }


  public GoToReport_SNSE117() {
    this.global.GoToReport("PMS_RPT_TI_SNSE117", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }

  public GoToReport_SNSE124() {
    this.global.GoToReport("PMS_RPT_TI_SNSE124", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }


  public GoToReport_SNSE128R() {
    this.global.GoToReport("PMS_RPT_TI_SNSE128R", {})
  }


  public GoToReport_SNSE118() {
    this.global.GoToReport("PMS_RPT_TI_SNSE118", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }

  public GoToReport_SNSE125() {
    this.global.GoToReport("PMS_RPT_TI_SNSE125", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }

  public GoToReport_SNSE129R() {
    this.global.GoToReport("PMS_RPT_TI_SNSE129R", {})
  }


  public GoToReport_SNSE119() {
    this.global.GoToReport("PMS_RPT_TI_SNSE119", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }

  public GoToReport_SNSE130R() {
    this.global.GoToReport("PMS_RPT_TI_SNSE130R", {})
  }


  public GoToReport_SNSE120() {
    this.global.GoToReport("PMS_RPT_TI_SNSE120", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }

  public GoToReport_SNSE133R() {
    this.global.GoToReport("PMS_RPT_TI_SNSE133R", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }
  public GoToReport_SNSE121() {
    this.global.GoToReport("PMS_RPT_TI_SNSE121", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }

  public GoToReport_SNSE134R() {
    this.global.GoToReport("PMS_RPT_TI_SNSE134R", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }
  public GoToReport_SNSE122() {
    this.global.GoToReport("PMS_RPT_TI_SNSE122", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_PROCESS_YEAR: this.year,
      P_PROCESS_MONTH: this.month
    })
  }


}
