import { Component, OnInit, ViewChild, ViewContainerRef, ElementRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { SelectionModel } from '@angular/cdk/collections';
import { ModalService } from 'src/app/core/modal.service';
import { AutoCompleteQueryComponent } from '../../../components/shared/auto-complete-query/auto-complete-query.component';
import * as moment from 'moment';

@Component({
  selector: 'SNSE206',
  templateUrl: './SNSE206.component.html',
  styleUrls: ['./SNSE206.component.css']
})

export class SNSE206Component implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  @ViewChild("dialogLogin", { static: false }) dialogLogin: any;

  public tableData = [];
  public dataSelected: any = [];
  public APPROVE_STATUS: any = [];
  public conditionHeader: any = {};
  public CHK_DISABLE: any = [];
  public data: any = {};
  public isDisabled: boolean;
  public selection = new SelectionModel<any>(true, []);

  public isSearchApprove: boolean;

  public params: any = {};
  public paramLogin: any = {};
  @ViewChild("autoCompleteDocCode") autoCompleteDocCode: AutoCompleteQueryComponent;

  ngOnInit() {
    this.params.CHK_APPROVE = false;
    this.params.STATUS = '0';
    this.params.TOTAL_COST = 0;
    this.params.TOTAL_COST_SELECTED = 0;
    this.GetMaxApprove();
    this.isSearchApprove = false;
  }

  public ConfigDocCode: any = {
    ColName: "LOOKUP_CC_DOC_ID",
    PlaceholderText: "Select Document Code",
    SourceController: "SL",
    SourceMethodName: "SNSE206_GetDocNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetDocCode(value: any) {
    this.params.CANCEL_DOC_ID = value.CANCEL_DOC_ID;
    this.params.ORDER_NO = value.ORDER_NO;
    this.params.APPROVE_STATUS_NAME = value.APPROVE_STATUS_NAME;
    this.params.CUSTOMER_CODE = value.CUSTOMER_CODE;
    this.params.CUST_NAME_TH = value.CUST_NAME_TH;
    this.params.CREATE_DATE = value.CREATE_DATE;
    this.params.LAST_UPD_DATE = value.LAST_UPD_DATE;

  }



  public ConfigReasonCode: any = {
    ColName: "LOOKUP_REASON_CODE",
    PlaceholderText: "Select Reason Code",
    SourceController: "SL",
    SourceMethodName: "SNSE206_Reason_Code",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetReasonCodehead(value: any, data: any) {
    data.REASON_CODE = value.REASON_CODE;
    this.tableData.forEach((head) => {
      head.REASON_CODE = data.REASON_CODE;
    });
  }

  public SetReasonCodeRow(value: any, data: any) {
    data.CHK_REASON = null;
    data.REASON_CODE = value.REASON_CODE;
    data.CHK_REASON = value.CHK_REASON;
    let chkReason = this.tableData.filter(x => x.REASON_CODE == data.REASON_CODE)
    if (chkReason.length == this.tableData.length) {
      this.conditionHeader.REASON_CODE = value.REASON_CODE;
      }
    else {
      this.conditionHeader.REASON_CODE = null;
    }
  }

  public GetMaxApprove() {
    this.http.get('SL', 'SNSE206_GetMaxApprove')
      .subscribe(res => {
        if (res.Table[0].MAX_APPROVE) {
        this.params.MAX_APPROVE = res.Table[0].MAX_APPROVE;
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewref);
      });
  }

  public CheckApprove(event) {
    this.params.CHK_APPROVE == true ? this.params.STATUS = '1' : this.params.STATUS = '0';
  }

  public RadioChangeAll(event: any) {
    this.dataSelected = [];
    this.tableData.forEach((head) => {
      head.APPROVE_STATUS = event;
    });
  }

  public RadioChangeRow(event: any, data: any) {
    data.APPROVE_STATUS = event;
    this.params.TOTAL_COST_SELECTED = 0;
    this.tableData.forEach((e) => {
      if (e.APPROVE_STATUS == 'A' || e.APPROVE_STATUS == 'R') {
        this.params.TOTAL_COST_SELECTED = this.params.TOTAL_COST_SELECTED + e.COST;
      }
    });
    let chkStats = this.tableData.filter(x => x.APPROVE_STATUS == data.APPROVE_STATUS)
    if (chkStats.length == this.tableData.length) {
      if (event == 'A') {
        this.conditionHeader.APPROVE_STATUS = 'A';
      }
      else {
        this.conditionHeader.APPROVE_STATUS = 'R';
      }
    }
    else {
      this.conditionHeader.APPROVE_STATUS = null;
    }

  }

  public Search = () => {
    this.conditionHeader = {}

    //if (this.params.CANCEL_DOC_ID == '' || this.params.CANCEL_DOC_ID == null) {
    //  this.modal.warning("Please select the Document No.", this.viewref);
    //  return;
    //}
    //else {
      this.tableData = [];
      this.params.TOTAL_COST = 0;
      this.params.TOTAL_COST_SELECTED = 0;
      this.params.TOTAL_AMOUNT = 0
      this.http.post("SL", "SNSE206_GET_DATA", this.params)
        .subscribe(res => {
          this.tableData = res.Table;
          if (this.tableData.length > 0) {
            //res.Table[0].TOTAL_COST = null ? this.params.TOTAL_COST = null : this.params.TOTAL_COST = res.Table[0].TOTAL_COST;
            if (this.params.STATUS == '1') {
              this.isSearchApprove = true;
            } else {
              this.isSearchApprove = false;
            }
            var stuA = 0;
            var stuR = 0;

            this.tableData.forEach((e) => {
              this.params.TOTAL_COST = this.params.TOTAL_COST + e.COST
              this.params.TOTAL_AMOUNT = this.params.TOTAL_AMOUNT + e.NET_AMT_B
              e.CHK_DISABLE = e.APPROVE_STATUS;
              if (e.APPROVE_STATUS == 'A') {
                stuA++;
              }
              else if (e.APPROVE_STATUS == 'R') {
                stuR++;
              }
            });
            this.isDisabled = false;
            this.isDisabled = (stuA > 0 || stuR > 0);
          }
        }, (err) => {
          console.log(err, 'err');
          this.modal.warning("Found an error, please contact support team", this.viewref);
        });
/*    }*/
  }

  public Confirm() {
    var chkreason = 0;
    var chkreason2 = 0;
    var chkstatus = 0;
    var nochange = 0;


    if (this.params.isSearchApprove == true) {
      this.modal.warning("Not allow to update data in search with all approve status", this.viewref);
      return;
    }

 

    this.tableData.forEach((e) => {
      if (e.APPROVE_STATUS_OLD != e.APPROVE_STATUS) {
        nochange = 1;

        if (e.APPROVE_STATUS_OLD == 'A' || e.APPROVE_STATUS_OLD == 'R') {
          chkstatus = 1;
        }
        if (e.APPROVE_STATUS == 'R' && !e.REASON_CODE) {
          chkreason = 1;
        }
        if (e.APPROVE_STATUS == 'R' && e.CHK_REASON != 1) {
          chkreason2 = 1;
        }
      }
    });
    if (nochange == 0) {
      this.modal.warning('There is no data change.', this.viewref);
      return;
    }

    if (nochange > 0) {
      if (chkstatus == 0 && chkreason == 0 && chkreason2 == 0) {



        if (this.params.TOTAL_COST_SELECTED > this.params.MAX_APPROVE) {
          this.modal.warning("You cannot approve this document due to total cost is over your approve limit", this.viewref, this.dialogLogin.OpenDialog());
          return;
        } else {
          this.modal.confirm('Please confirm to update Data?', this.viewref, this.Save);
        }


        



      }
      else if (chkstatus > 0) {
        this.modal.warning('Cannot change approve status.', this.viewref, this.Search);
      }
      else if (chkreason > 0) {
        this.modal.warning('Please input Reject Reason for all reject item.', this.viewref);
      }
      else if (chkreason2 > 0) {
        this.modal.warning('Reason Code not found.', this.viewref);
      }
    }
  }

  public Save = () => {
    this.dataSelected = [];
    this.tableData.forEach((e) => {
      e.USERNAME_AUTH = null;
      this.dataSelected.push(e);
    });

    this.http.post('SL', 'SNSE206_UPDATE', this.dataSelected)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Complete Update Data', this.viewref, this.Search);
          this.autoCompleteDocCode.query();
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewref);
      });
  }


  public SaveAuth = () => {
    this.dataSelected = [];
    this.tableData.forEach((e) => {
      e.USERNAME_AUTH = this.paramLogin.USERNAME;
        this.dataSelected.push(e);
    });

    this.http.post('SL', 'SNSE206_UPDATE', this.dataSelected)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Complete Update Data', this.viewref, this.Search);
          this.autoCompleteDocCode.query();
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewref);
      });
  }

  CloseDialog() {
    this.InitData();
    this.dialogLogin.Close();
  }

  InitData() {
    this.paramLogin = {};
  }

  public LoginAuth() {
    this.dialogLogin.Close();
    this.http.post('SL', 'SNSE206_ApproveAuth', this.paramLogin)
      .subscribe(res => {
/*        console.log(res)*/
        if (!res.Table[0].MESSAGE) {

          if (res.Table[0].MAX_APPROVE >= this.params.TOTAL_COST_SELECTED) {
/*            console.log(res.Table[0].MAX_APPROVE)*/

            this.modal.confirm('Please confirm to update Data?', this.viewref, this.SaveAuth);
          }
          else {
            this.modal.warning("You cannot approve this document due to total cost is over your approve limit", this.viewref, this.dialogLogin.OpenDialog());
          }
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewref);
      });

  }
  public ClearReasonCode(data) {
    data.CHK_REASON = null;
  }
  public ExportExcel(){
    console.log('xxx',this.tableData)
    this.http.Download("SL","SNSE206_ExportExcel",this.tableData)
    .subscribe(res =>{
      this.writeContents(res);
    })
  }
  private writeContents(content) {
    var currentDate = moment().format('DD-MM-YYYY');
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSE206_" + currentDate + ".xlsx" ;
    a.click();
  }
}
