
import { Component, OnInit,  ViewChild, ViewContainerRef} from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';


import { ModalService } from 'src/app/core/modal.service';
import { MatDialog } from '@angular/material/dialog';


@Component({
  selector: 'SNSQ005_C',
  templateUrl: './SNSQ005_C.component.html',
  styleUrls: ['./SNSQ005_C.component.css']
})

export class SNSQ005_CComponent implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    public dialog: MatDialog,
    private viewRef: ViewContainerRef
  ) { }


  public info: any = {};
  public partData: any = {};
  public ExiseTax: any = {};
  public PartOption: any = {};
  public stockData: any = {};
  public dataList: any = [];

  public dataListBackOrder: any = [];
  public dataListAllocate: any = [];
  public dataListChainPart: any = [];

  public iActiveTab: number = 0;

  public partNumber: string;

  public lookupConfig: any = {
    ColName: "LOOKUP_PART_VALUE",
    PlaceholderText: "Select Part",
    SourceController: "IC",
    SourceMethodName: "SNSQ005_GetPart",
    NoOfShowRecords: 50,
    UpperCase: true
  }

  ngOnInit() {
    this.partNumber = '';
    this.partData.PART_NO = ''; //'402063HA0A'; //H210A3GFMA
    this.iActiveTab = 0;
    this.partData.SPPS_CODE = null;
    this.partData.DESIGN_NOTE_NUMBER = null;
  }

  public SetSelectedPart(value: any) {
    this.partData.PART_NO = value.PART_NO;
    this.partNumber = value.PART_NO

    this.GetDataTab1();
    this.SetActiveTab();
  }

  public TabChanged(event) {
    this.iActiveTab = event.index;
    this.SetActiveTab();
  }

  private SetActiveTab() {
    if (this.iActiveTab == 0) {

    } else if (this.iActiveTab == 1) {
      this.GetDataTab2();
    } else if (this.iActiveTab == 2) {
      this.GetDataTab3();
    } else if (this.iActiveTab == 3) {
      this.GetDataTab4();
    }
  }

  private GetDataTab1() {

    this.stockData = {};
    this.info = {};
    if (this.partData.PART_NO.length >= 3) {
      this.http.get("IC", "SNSQ005_GetPartInfo", this.partData.PART_NO)
        .subscribe(result => {
          this.partData = result.Table[0];
          this.stockData = result.Table1[0];
          this.info = result.Table2[0];
        })

      this.http.get("IC", "SNSQ005_GetPartInfo_G2", this.partData.PART_NO)
        .subscribe(result => {
          this.ExiseTax = result.Table[0] || {};
          this.PartOption = result.Table1[0] || {};
        })


    } else {

    }
  }

  private GetDataTab2() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G3", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListBackOrder = result.Table; // Tab 2 : Back order
      })
  }

  private GetDataTab3() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G4", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListAllocate = result.Table; // Tab 3 : allocate
      })
  }


  private GetDataTab4() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G6", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListChainPart = result.Table; // Tab 4 : ChainPart
      })
  }

}
