import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { FormControl, Validators } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';


@Component({
  selector: 'snsq043_001',
  templateUrl: './SNSQ043_001.component.html',
  styleUrls: ['./SNSQ043_001.component.css']

})


export class SNSQ043_001Component implements OnInit {

  public params: any = {};

  public tableData: any = [];
  public TOTAL_RECORD: any = 0;

  constructor(
    private Http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public lookupPartNoConfig: any = {
    ColName: "LOOKUP_PART_NAME",
    PlaceholderText: "Select Part No.",
    SourceController: "SL",
    SourceMethodName: "SNSQ043_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 1,
    UpperCase: true
  }

  public SetSelectedPartNo(value: any) {
    this.params.PART_NO = value.PART_NO;
    this.params.PART_NAME = value.PART_NAME;
  }

  ngOnInit() {
    var date = new Date();
    this.params.FROM_DATE = new Date(date.getFullYear(), date.getMonth(), 2);
    this.params.TO_DATE = new Date();
  }

  Search() {
    this.tableData = []
    this.Http.post("SL", "SNSQ043_getData", this.params)
      .subscribe(res => {
        this.tableData = res.Table;
        this.TOTAL_RECORD = this.tableData[0].TOTAL_RECORD;
      })
  }

  ExportExcel() {
    this.Http.Download('SL', 'SNSQ043_getData_Export', JSON.stringify(this.params))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
        } else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ043.csv";
    a.click();
  }
}
