import { Component, OnInit, ViewContainerRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from '../../../core/modal.service';
import { Globals } from '../../../core/global';


@Component({
  selector: 'snsq046_001',
  templateUrl: './SNSQ046_001.component.html',
  styleUrls: ['./SNSQ046_001.component.css']
})

export class SNSQ046_001Component implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private route: ActivatedRoute,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) {
  }
  public tabledata: any = [];
  public PROCESS_LOG: any = [];


  public params: any = {};

  ngOnInit() {
    var date = new Date();
    this.params.FROM_DATE = new Date(date.getFullYear(), date.getMonth(), 2);
    this.params.TO_DATE = new Date();
  }

  public ConfigBuyerCode: any = {
    ColName: "LOOKUP_BUYER_CODE",
    PlaceholderText: "Select Buyer Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ046_001_BUYER_CODE",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public Search() {
    this.tabledata = [];
    this.http.post("SL", "SNSQ046_001_getSearch", this.params)
      .subscribe(res => {
        this.tabledata = res.Table;
      })
  }


  public ExportExcel() {
    this.http.Download("SL", "SNSQ046_001_Export_Excel", JSON.stringify(this.tabledata))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
          this.PROCESS_LOG.push('Export complete ' + this.tabledata.length + ' records.');
        } else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  public WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    var date_export = new Date();
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ046" + "_" + date_export.getFullYear() + "/" + (date_export.getMonth() + 1) + "/"+ date_export.getDate() + ".csv";
    a.click();
  }

  //public ShowLog() {

  //}

  public SetBuyerCode(values: any) {
    this.params.BUYER_CODE = values.BUYER_CODE
  }

}
