import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { ModalService } from '../../../core/modal.service';
import { Globals } from '../../../core/global';
import { MatTableDataSource } from '@angular/material/table';


@Component({
  selector: 'snsq080_001',
  templateUrl: './SNSQ080_001.component.html',
  styleUrls: ['./SNSQ080_001.component.css']
})

export class SNSQ080_001Component implements OnInit {

  public params = {
    INVOICE_NO: null
  }

  //**Add Element [invoiceNo]="yourVariable" into html.**
  @Input("invoiceNo") invoiceNo: string;

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private auth: AuthDecode,
    private global: Globals
  ) { }

  public lookupInvoiceNoConfig: any = {
    ColName: "INVOICE_NO",
    PlaceholderText: "Select Invoice No.",
    SourceController: "AC",
    SourceMethodName: "GetInvoiceNo",
    NoOfShowRecords: 100,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedInvoiceNo(value: any) {
    this.params.INVOICE_NO = value.INVOICE_NO;
  }

  //Tab 1
  public DataTableHeadTC: any = null;
  public DataTableTC: any = null;
  public TotalRecordHeadTC = '0'
  public TotalRecordTC = '0'
  public CheckBox: boolean = false;
  public CheckBoxAll: boolean = false;
  public DataIsSelected: any = [];

  //Tab 2
  public DataTableCC: any = null;
  public TotalRecordCC = '0'

  //Tab 3
  public DataTableQA: any = null;
  public TotalRecordQA = '0'
  public CheckBoxQA: boolean = false;
  public CheckBoxAllQA: boolean = false;
  public DataIsSelectedQA: any = [];

  //Tab 4
  public DataTableSA: any = null;
  public DataTableHeadSA: any = null;
  public TotalRecordSA = '0'
  public TotalRecordHeadSA = '0'
  public CheckBoxSA: boolean = false;
  public CheckBoxAllSA: boolean = false;
  public DataIsSelectedSA: any = [];

  //Tab 5
  public DataTable4Invoice: any = null;
  public DataTable4Status: any = null;
  public DataTable4Indent: any = null;
  public filterStatus: any = null;
  public filterIndent: any = null;
  public TotalRecord4Invoice = '0'
  public TotalRecord4Status = '0'
  public TotalRecord4Indent = '0'

  //Tab 6
  public DataTable5Invoice: any = null;
  public DataTable5Status: any = null;
  public DataTable5Indent: any = null;
  public filterStatus5: any = null;
  public filterIndent5: any = null;
  public TotalRecord5Invoice = '0'
  public TotalRecord5Status = '0'
  public TotalRecord5Indent = '0'

  ngOnInit(): void {
    if (this.invoiceNo) {
      this.params.INVOICE_NO = this.invoiceNo
      this.Search('0')
    }
  }
  tabClick(tab: any) {
    if (this.invoiceNo) {
      this.Search(tab.toString())
    }
  }

  Search(type: any) {
    if (type === '0') {
      this.TotalRecordHeadTC = '0'
      this.TotalRecordTC = '0'
      this.http.post('AC', 'SNSQ080_GetDataHeadTariff', this.params)
        .subscribe(res => {
          this.DataTableHeadTC = res.Table;
          this.TotalRecordHeadTC = this.DataTableHeadTC.length;
          if (this.DataTableHeadTC.length > 0) {
            this.http.post('AC', 'SNSQ080_GetDataTariff', this.DataTableHeadTC[0])
              .subscribe(res => {
                this.DataTableTC = res.Table;
                if (this.DataTableTC) {
                  this.TotalRecordTC = this.DataTableTC.length;
                }
              })
          }
        })
    }

    else if (type === '1') {
      this.http.post('AC', 'SNSQ080_GetDataCC', this.params)
        .subscribe(res => {
          this.DataTableCC = res.Table;
          this.TotalRecordCC = this.DataTableCC.length;
        })
    }

    else if (type === '2') {
      this.http.post('AC', 'SNSQ080_GetDataQA', this.params)
        .subscribe(res => {
          this.DataTableQA = res.Table;
          this.TotalRecordQA = this.DataTableQA.length;
        })
    }

    else if (type === '3') {
      this.http.post('AC', 'SNSQ080_GetDataHeadSA', this.params)
        .subscribe(res => {
          this.DataTableHeadSA = res.Table;
          this.TotalRecordHeadSA = this.DataTableHeadSA.length;
          if (this.DataTableHeadSA.length > 0) {
            this.http.post('AC', 'SNSQ080_GetDataSA', this.params)
              .subscribe(res => {
                this.DataTableSA = res.Table;
                this.TotalRecordSA = this.DataTableSA.length;
              })
          }
        })

    }

    else if (type === '4') {
      this.ClearDataIG();
      this.http.post('AC', 'SNSQ080_GetDataInvoiceNo_T5', this.params)
        .subscribe(res => {
          this.DataTable4Invoice = res.Table;
          this.TotalRecord4Invoice = this.DataTable4Invoice.length;
          this.http.post('AC', 'SNSQ080_GetDataStatusCode_T5', this.params)
            .subscribe(res => {
              this.DataTable4Status = res.Table;
              if (this.TotalRecord4Invoice) {
                this.filterStatus = this.DataTable4Status.filter(value => value.INVOICE_NO === this.DataTable4Invoice[0].INVOICE_NO);
                this.TotalRecord4Status = this.filterStatus.length;
                if (this.filterStatus) {
                  this.http.post('AC', 'SNSQ080_GetDataIndentStatus_T5', this.params)
                    .subscribe(res => {
                      this.DataTable4Indent = res.Table;
                      var StatusCode = this.filterStatus[0].STATUS_CODE;
                      if (this.filterStatus[0].STATUS_CODE === '60') { StatusCode = 'D1' }
                      this.filterIndent = this.DataTable4Indent.filter(value => value.SHIPPED_DATE === this.filterStatus[0].SHIPPED_DATE && (value.STATUS_CODE === StatusCode) && (value.STATUS_ACCOUNT === this.filterStatus[0].STATUS_ACCOUNT));
                      this.TotalRecord4Indent = this.filterIndent.length;
                    })
                }
              }
            })
        })
    }

    else if (type === '5') {
      this.ClearDataIA();
      this.http.post('AC', 'SNSQ080_GetDataInvoiceNo_T6', this.params)
        .subscribe(res => {
          this.DataTable5Invoice = res.Table;
          this.TotalRecord5Invoice = this.DataTable5Invoice.length;
          this.http.post('AC', 'SNSQ080_GetDataStatusCode_T5', this.params)
            .subscribe(res => {
              this.DataTable5Status = res.Table;
              if (this.DataTable5Invoice) {
                this.filterStatus5 = this.DataTable5Status.filter(value => value.INVOICE_NO === this.DataTable5Invoice[0].INVOICE_NO);
                this.TotalRecord5Status = this.filterStatus5.length;
                if (this.filterStatus5) {
                  this.http.post('AC', 'SNSQ080_GetDataIndentStatus_T5', this.params)
                    .subscribe(res => {
                      this.DataTable5Indent = res.Table;
                      var StatusCode = this.filterStatus5[0].STATUS_CODE;
                      if (this.filterStatus5[0].STATUS_CODE === '60') { StatusCode = 'D1' }
                      this.filterIndent5 = this.DataTable5Indent.filter(value => (value.SHIPPED_DATE === this.filterStatus5[0].SHIPPED_DATE) && (value.STATUS_CODE === StatusCode) && (value.STATUS_ACCOUNT === this.filterStatus5[0].STATUS_ACCOUNT));
                      this.TotalRecord5Indent = this.filterIndent5.length;
                    })
                }
              }
            })
        })
    }
  }

  //Tariff Code
  onClickRowTariff(row: any) {
    this.http.post('AC', 'SNSQ080_GetDataTariff', row)
      .subscribe(res => {
        this.DataTableTC = res.Table;
        this.TotalRecordTC = this.DataTableTC.length;
      })
  }

  onCheckedAll(isChecked: boolean) {
    if (isChecked) {
      this.CheckBox = true;
    } else {
      this.CheckBox = false;
    }
  }

  onChecked(data: any, isChecked: boolean) {
    if (isChecked) {
      this.DataIsSelected.push(data);
    } else {
      this.DataIsSelected.splice(this.DataIsSelected.indexOf(data), 1);
    }
    if (this.DataTableHeadTC.length == this.DataIsSelected.length) {
      this.CheckBoxAll = true;
    }
    else {
      this.CheckBoxAll = false;
    }
  }

  ConfirmUTD() {
    if (this.DataIsSelected.length != 0) {
      this.modal.confirm('Do you want to update on this data?', this.viewref, this.reUpdateTariffCode)
    } else {
      this.modal.info('Please select data.', this.viewref);
    }
  }

  reUpdateTariffCode = () => {
    this.http.post('AC', 'SNSQ080_ReUpdateTariff', this.DataIsSelected)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.DataIsSelected = [];
          this.modal.info('Done.', this.viewref);
          this.Search('TC');
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }

  //Quantity Amount
  onCheckedAllQA(isChecked: boolean) {
    if (isChecked) {
      this.CheckBoxQA = true;
    } else {
      this.CheckBoxQA = false;
    }
  }

  onCheckedQA(data: any, isChecked: boolean) {
    if (isChecked) {
      this.DataIsSelectedQA.push(data);
    } else {
      this.DataIsSelectedQA.splice(this.DataIsSelectedQA.indexOf(data), 1);
    }
    if (this.DataTableQA.length == this.DataIsSelectedQA.length) {
      this.CheckBoxAllQA = true;
    }
    else {
      this.CheckBoxAllQA = false;
    }
  }

  ConfirmUTDQA() {
    if (this.DataIsSelectedQA.length != 0) {
      this.modal.confirm('Do you want to update on this data?', this.viewref, this.UpdateInvoiceHead)
    } else {
      this.modal.info('Please select data.', this.viewref);
    }
  }

  UpdateInvoiceHead = () => {
    this.http.post('AC', 'SNSQ080_UpdateInvoiceHead', this.DataIsSelectedQA)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.DataIsSelectedQA = [];
          this.modal.info('Done.', this.viewref);
          this.Search('QA');
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }

  //Shipped Arrival
  onClickRowShipped(row: any) {
    this.http.post('AC', 'SNSQ080_GetDataSA', row)
      .subscribe(res => {
        this.DataTableSA = res.Table;
        this.TotalRecordSA = this.DataTableSA.length;
      })
  }

  onCheckedAllSA(isChecked: boolean) {
    if (isChecked) {
      this.CheckBoxSA = true;
    } else {
      this.CheckBoxSA = false;
    }
  }

  onCheckedSA(data: any, isChecked: boolean) {
    if (isChecked) {
      this.DataIsSelectedSA.push(data);
    } else {
      this.DataIsSelectedSA.splice(this.DataIsSelectedSA.indexOf(data), 1);
    }
    if (this.DataTableHeadSA.length == this.DataIsSelectedSA.length) {
      this.CheckBoxAllSA = true;
    }
    else {
      this.CheckBoxAllSA = false;
    }
  }

  ConfirmUTDSA() {
    if (this.DataIsSelectedSA.length != 0) {
      this.modal.confirm('Do you want to update on this data?', this.viewref, this.UpdateShippedDate)
    } else {
      this.modal.info('Please select data.', this.viewref);
    }
  }

  UpdateShippedDate = () => {
    this.http.post('AC', 'SNSQ080_UpdateShippedDate', this.DataIsSelectedSA)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.DataIsSelectedSA = [];
          this.modal.info('Done.', this.viewref);
          this.Search('SA');
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }

  //Invoice Group (Validate)
  ClearDataIG() {
    this.TotalRecord4Invoice = '0'
    this.TotalRecord4Status = '0'
    this.TotalRecord4Indent = '0'
    this.filterStatus = null;
    this.filterIndent = null;
  }

  onClickRow(row: any) {
    var StatusCode = row.STATUS_CODE
    if (row.STATUS_CODE === '60') { StatusCode = 'D1' }
    this.filterIndent = {};
    this.filterIndent = this.DataTable4Indent.filter(value => (value.SHIPPED_DATE === row.SHIPPED_DATE) && (value.STATUS_CODE === StatusCode) && (value.STATUS_ACCOUNT === row.STATUS_ACCOUNT));
    this.TotalRecord4Indent = this.filterIndent.length;
  }

  //Invoice All (Not Validate)
  ClearDataIA() {
    this.TotalRecord5Invoice = '0'
    this.TotalRecord5Status = '0'
    this.TotalRecord5Indent = '0'
    this.filterStatus5 = null;
    this.filterIndent5 = null;
  }

  onClickRow2(row: any) {
    var StatusCode = row.STATUS_CODE
    if (row.STATUS_CODE === '60') { StatusCode = 'D1' }
    this.filterIndent5 = {};
    this.filterIndent5 = this.DataTable5Indent.filter(value => (value.SHIPPED_DATE === row.SHIPPED_DATE) && (value.STATUS_CODE === StatusCode) && (value.STATUS_ACCOUNT === row.STATUS_ACCOUNT));
    this.TotalRecord5Indent = this.filterIndent5.length;
  }
}
