import { Component, ElementRef, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { FormControl, Validators } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snm121p',
  templateUrl: './SNM121P.component.html',
  styleUrls: ['./SNM121P.component.css']
})



export class SNM121PComponent implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal : ModalService,
    private viewref : ViewContainerRef
  ) { }

  public ConfigFamily: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Family Code",
    SourceController: "TI",
    SourceMethodName: "SNM121P_Family_Code",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  @ViewChild("dialog",{static: false}) dialog : any;
  public ParamSearch :any ={};
  public ParamData :any ={};
  public tabledata : any = [];
  public isAdd : boolean = false;

  ngOnInit() {

  }

  Search(){
    this.tabledata = []
    this.http.post("TI","SNM121P_Search",this.ParamSearch)
    .subscribe(res =>{
          this.tabledata = res.Table
    })

  }
 

  Add(){
    this.ParamData = {}
    this.isAdd = true

    this.dialog.title = "Add Family Master"
    this.dialog.OpenDialog();
  }

  EditRow(data){

    this.http.post("TI","SNM121P_Search",data)
    .subscribe(res =>{
      if(res.Table.length > 0){
        this.isAdd = false;
        this.ParamData = res.Table[0];
        this.dialog.title = "Edit Family Master"
        this.dialog.OpenDialog();
      }else{
        this.modal.warning("Family code not found",this.viewref)
      }
    })
  }

  Delete(data){
    this.modal.confirm("Do you want to delete racord?",this.viewref,() =>{
      this.http.post("TI","SNM121P_Delete",data)
      .subscribe(res =>{
        if (res.STATUS_MSG == 'DONE') {
          this.modal.info('Transaction complete: 1 record applied and deleted.', this.viewref);
          this.Search();
          this.dialog.Close();
            
        }
        else {
            this.modal.warning('Delete fail.', this.viewref);
        }
      },err => {
        this.modal.warning('Delete fail.', this.viewref);
      })
    })
  }


  Save(){
    this.modal.confirm("Do you want to save change you have made?",this.viewref,this.ConfirmSave)
  }

  ConfirmSave = () =>{

    if(this.isAdd){
      this.http.post("TI","SNM121P_Insert",this.ParamData)
      .subscribe(res => {
        if (res.STATUS_MSG == 'DONE') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          if(this.tabledata.length > 0){
            this.Search();
          }
          this.dialog.Close();                                 
        } else if (res.STATUS_MSG == 'DUPPLICATE') {
            this.modal.info('No change to save. Found duplicate record.', this.viewref);
        }
        else {
            this.modal.warning('No change to save. Add fail.', this.viewref);
        }
      },(err)=>{
        this.modal.warning('No change to save. Add fail.', this.viewref);
      })
    }else{
      this.http.post("TI","SNM121P_Update",this.ParamData)
      .subscribe(res => {
        if (res.STATUS_MSG == 'DONE') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.Search();
          this.dialog.Close();
            
        } else {
            this.modal.warning('No change to save. Update fail.', this.viewref);
        }
      },(err)=>{
        this.modal.warning('No change to save. update fail.', this.viewref);
      })
    }

  }
  Cancel(){
    this.dialog.Close();
  }
  
  

}
