import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snse207',
  templateUrl: './SNSE207.component.html',
  styleUrls: ['./SNSE207.component.css']
})


export class SNSE207Component implements OnInit{


    constructor(
        private http : HttpService,
        private modal : ModalService,
        private viewref : ViewContainerRef
    ){}

    public ConfigCustomer: any = {
      ColName: "LOOKUP",
      PlaceholderText: "Select Customer",
      SourceController: "TI",
      SourceMethodName: "SNSE207_GetCustomer",
      NoOfShowRecords: 50,
      MinLengthSearch: 0
    }

    public ConfigOrder: any = {
      ColName: "LOOKUP",
      PlaceholderText: "Select Order",
      SourceController: "TI",
      SourceMethodName: "SNSE207_GetOrder",
      NoOfShowRecords: 50,
      MinLengthSearch: 2
    }



    public params : any = {}
    public tableData : any = [];
    ngOnInit(){
        
    }


    GetCustomer(event){
      this.params.CUSTOMER_CODE = event.CUSTOMER_CODE
      this.params.CUSTOMER_NAME = event.CUSTOMER_NAME
    }

    GetOrder(event){
      this.params.ORDER_NO = event.ORDER_NO
      this.params.ORDER_CLASS = event.ORDER_CLASS
    }
}