import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';



@Component({
  selector: 'snsq031',
  templateUrl: './SNSQ031.component.html',
  styleUrls: ['./SNSQ031.component.css']
})



export class SNSQ031Component implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
  ) { }
  @ViewChild("dialog", { static: false }) dialog: any;

  public params: any = {};
  public tableData: any = [];

  public ConfigSupplier: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Supplier Code",
    SourceController: "TI",
    SourceMethodName: "SNSQ030_GetSupplier",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public SetSupplierCode(values: any) {
    this.params.SUPPLIER_CODE = values.AP_VENDOR_CODE;
    this.params.SUPPLIER_NAME = values.VENDOR_NAME;
    this.ConfigPart.SourceParams.SUPPLIER_CODE = values.VENDOR_CODE

    this.Search();
  }

  public ConfigPart: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Part",
    SourceController: "TI",
    SourceMethodName: "SNSQ030_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      SUPPLIER_CODE: null
    },
  }

  ngOnInit() {
    this.params.DATE_FROM = new Date("2000-01-01");
    this.params.DATE_TO = new Date();
    this.Search()
  }

  public Search() {
    this.tableData = []
    this.http.post("TI", "SNSQ031_GetData", this.params)
      .subscribe(res => {
        this.tableData = res.Table
      })
  }

  //public ExportExcel() {
  //  if (this.tableData.length == 0) {
  //    this.modal.warning("No data for export!", this.viewref);
  //  } else {
  //    this.http.Download("TI", "SNSQ031_Download", this.tableData)
  //      .subscribe(res => {
  //        this.modal.info("Export Complete", this.viewref);
  //        this.writeContents(res)
  //      })
  //  }
  //}

  public writeContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ031_FILE" + '-' + this.FormateDate() + '' + ".csv";
    a.click();
  }

  public FormateDate() {
    let d = new Date()
    let day = d.getDate();
    let newDay = day.toString().length < 2 ? 0 + '' + day.toString() : day.toString();
    let m = d.getMonth() + 1;
    let newMonth = m.toString().length < 2 ? 0 + '' + m.toString() : m.toString();
    let y = d.getFullYear();
    let hours = d.getHours();
    let minute = d.getMinutes();
    let seconds = d.getSeconds();
    return y + '' + newMonth + '' + newDay + '_' + hours + ':' + minute + ':' + seconds;
  }

  public SetSuplierCode(value) {
    this.params.SUPPLIER_CODE = value.AP_VENDOR_CODE;
    this.params.SUPPLIER_NAME = value.VENDOR_NAME;
    this.ConfigPart.SourceParams.SUPPLIER_CODE = value.VENDOR_CODE
    this.Search();
  }

  public SetPartNo(value) {
    this.params.PART_NUMBER = value.PART_NO
    this.params.PART_NAME = value.PART_NAME_EN
    this.Search();
  }

  public ExportExcel() {
    if (this.tableData.length == 0) {
      this.modal.warning("No data for export!", this.viewref);
    } else {
      this.http.Download('TI', 'SNSQ031_getDataForExport', JSON.stringify(this.params))
        .subscribe(res => {
          if (res) {
            this.WriteContents(res)
          } else {
            this.modal.error('Download not complete', this.viewref)
          }
        })
    }
  }

  WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ031.csv";
    a.click();
  }
}

