
import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snsq039_001',
  templateUrl: './snsq039_001.component.html',
  styleUrls: ['./snsq039_001.component.css']
})



export class SNSQ039_001Component implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
  ) { }

  public data: any;
  public params: any = {};
  public tableData: any = [];
  public totalRecord = 0;
  public PROCESS_LOG: any = [];

  ngOnInit() {
    var date = new Date();
    this.params.FROM_DATE = new Date(date.getFullYear(), date.getMonth(), 2);
    this.params.TO_DATE = new Date();
  }

    
  public ConfigPartNo: any = {
    ColName: "LOOKUP_PART_NO",
    PlaceholderText: "Select Part No",
    SourceController: "TI",
    SourceMethodName: "SNSQ039_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetPartNo(value: any) {
    this.params.PART_NUMBER = value.PART_NUMBER;
  }

  public Search() {
    console.log(this.params)
    this.tableData = [];
    this.http.post("TI", "SNSQ039_GetData", this.params)
      .subscribe(res => {
        this.tableData = res.Table;
        this.totalRecord = this.tableData.length
      })

  }

  public ExportExcel() {
    this.http.Download("TI", "SNSQ039_Export_Excle", JSON.stringify(this.tableData))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
          this.PROCESS_LOG.push('Export complete ' + this.tableData.length + ' records.');
        } else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  private WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    var date_export = new Date();
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ039" + "_" + date_export.getFullYear() + (date_export.getMonth() + 1) + date_export.getDate() + ".csv";
    a.click();
  }

}
