import { Component, OnInit} from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snpr029_m',
  templateUrl: './snpr029_m.component.html',
  styleUrls: ['./snpr029_m.component.css']
})



export class SNPR029_MComponent implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private global : Globals
  ) { }

  public data: any = [];
  public SelectList: any;
  public BranchList: any = [];

  public CustomerConfig: any = {
    ColName: "CODE_NAME",
    ColValue: "",
    PlaceholderText: "Select Customer",
    SourceController: "wPMS",
    SourceMethodName: "GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 2,
    UpperCase: true
}

public ConfigPart: any = {
  ColName: "LOOKUP_PART",
  ColValue: "",
  PlaceholderText: "Select Part No.",
  SourceController: "WH",
  SourceMethodName: "SNPR029_GetPart",
  NoOfShowRecords: 30,
  MinLengthSearch: 5,
  UpperCase: true
}



public Params: any = {
  CUSTOMER_CODE: null,
  CUSTOMER_NAME : null,
  BRANCH_CODE: null,
  BRANCH_NAME:null,
  BRANCH : {},
  CRATE : null
};

public Opened : boolean = true;

  ngOnInit() {
      let i = 0;
      while(i < 5){
        this.data.push({
          PART_NO: '',
          PART_NAME: '',
          LOCATION: '',
          QTY: '',
          PRN: '',
          REMARK:''
        }) 
        i++
      }

 
  }

  GetBranch(){
    this.http.get("WH","SNPR029_M_Branch",this.Params.CUSTOMER_CODE)
    .subscribe(res => {
      this.BranchList = res.Table;
    })
  }

  AddRecord(){
    this.data.push({
      PART_NAME: '',
      LOCATION: '',
      QTY: '',
      PRN: '',
      REMARK : ''
    })

   this.data =  this.data.slice();
  }

  SelectedCustomer(event){

    this.Params.CUSTOMER_CODE = event.CUSTOMER_CODE
    this.Params.CUSTOMER_NAME = event.CUST_NAME_TH
    this.GetBranch();
  }

  SelectedPart(data,event){
    data.PART_NO = event.PART_NO
    data.PART_NAME = event.PART_NAME_EN
    data.LOCATION = event.LOCATION_NO
    data.QTY = 1
    data.PRN = 1

  }


  selectionChanged(event){
    this.Params.BRANCH_CODE = event.value.BRANCH_CODE
    this.Params.BRANCH_NAME = event.value.FULL_NAME
  }

  OpenReport(){
    let data = []
    this.data.map(z => z.REMARK = this.Params.CRATE) 
    data = this.data.filter(x => x.PART_NO)

    if(data.length > 0){
      this.http.post('WH','SNPR029_M_INSERT',data)
      .subscribe(res =>{
        if(res){
          this.global.GoToReport("PMS_RPT_WH_SNPR029_M", 
          {  P_CUSTOMER_CODE: this.Params.CUSTOMER_CODE,
             P_BRANCH_CODE: this.Params.BRANCH_CODE
          }
          );
        }
      })
    }else{

      this.global.GoToReport("PMS_RPT_WH_SNPR029_M", 
      {  P_CUSTOMER_CODE: this.Params.CUSTOMER_CODE,
         P_BRANCH_CODE: this.Params.BRANCH_CODE
      }
      );
    }
 
  }

}

