import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';



@Component({
  selector: 'snse157',
  templateUrl: './SNSE157.component.html',
  styleUrls: ['./SNSE157.component.css']
})



export class SNSE157Component implements OnInit {

  public Data: any = {};
  public OldData: any = {};

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
  ) { }

  ngOnInit() {
    this.GetData()
  }

  private GetData() {
    this.http.get('WH', 'SNSE157_GetData')
      .subscribe(res => {
        this.Data = res.Table[0];
        this.OldData = JSON.parse(JSON.stringify(this.Data));
      })
  }

  public CalculateTotal() {
    this.Data.TOTAL_WH = this.Data.WH_SHELVE + this.Data.WH_RECEIVING + this.Data.WH_ALLOCATE + this.Data.WH_PICKING
    this.Data.TOTAL_EXP = this.Data.EXP_RECEIVING + this.Data.EXP_PACKING + this.Data.EXP_PRE_INV + this.Data.EXP_BOOKING + this.Data.EXP_INVOICE + this.Data.EXP_LOADING
    this.Data.TOTAL_ALL = this.Data.TOTAL_WH + this.Data.TOTAL_EXP
  }

  Update() {
    console.log(this.Data.WH_SHELVE, this.OldData.WH_SHELVE)
    if (this.OldData.WH_SHELVE != this.Data.WH_SHELVE || this.OldData.WH_RECEIVING != this.Data.WH_RECEIVING
      || this.OldData.WH_ALLOCATE != this.Data.WH_ALLOCATE || this.OldData.WH_PICKING != this.Data.WH_PICKING
      || this.OldData.EXP_RECEIVING != this.Data.EXP_RECEIVING || this.OldData.EXP_PACKING != this.Data.EXP_PACKING
      || this.OldData.EXP_PRE_INV != this.Data.EXP_PRE_INV || this.OldData.EXP_BOOKING != this.Data.EXP_BOOKING
      || this.OldData.EXP_INVOICE != this.Data.EXP_INVOICE || this.OldData.EXP_LOADING != this.Data.EXP_LOADING) {
      this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmUpdate)
    }
    else {
      this.modal.warning('There is no data change.', this.viewref)

    }
  }

  ConfirmUpdate = () => {
    this.http.post('WH', 'SNSE157_UpdateData', this.Data)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Update successful.', this.viewref);
          this.GetData()
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }
}

