import { Component, OnInit, ViewChild, ViewContainerRef} from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import * as cloneDeep from 'lodash/cloneDeep';
import { ModalService } from '../../../core/modal.service';

@Component({
    selector: 'snse195',
    templateUrl: './snse195.component.html',
    styleUrls: ['./snse195.component.css']
})

export class SNSE195Component implements OnInit {
    constructor(
        private http: HttpService,
        private router: Router,
        private modal: ModalService,
        private viewref: ViewContainerRef
    ) { }

    @ViewChild("dialogEditCustomerBKK", { static: false }) dialogEditCustomerBKK: any
    @ViewChild("dialogAddCustomerBKK", { static: false }) dialogAddCustomerBKK: any
    public dataList: any;
    public data: any = {};
    public CounterItem: number = 0;
    public index: any;
    public LabelName: any;
    public RouteCode: any;

    public lookupConfigCustomer: any = {
        ColName: "CUST_TEXT",
        ColValue: "",
        PlaceholderText: "Select Customer Code",
        SourceController: "WH",
        SourceMethodName: "SNSE195_Customer_Find",
        NoOfShowRecords: 50,
        MinLengthSearch: 2,
        UpperCase: true
    }

    public formData: any = {
        CUSTOMER_CODE: null,
        CUST_NAME_EN: null,
    };

    ngOnInit() {

    }

    keyDownFunction(event) {
        console.log(event)
        if (event.keyCode == 13) {
            this.GetCustomerLabel();
        }
    }

    SetCustoMerLookup(event) {
        this.formData.CUSTOMER_CODE = event.CUSTOMER_CODE;
        this.formData.CUST_NAME = event.CUST_NAME
        console.log(event)
        this.GetCustomerLabel();
    }

    GetCustomerLabel() {
        this.dataList = [];
        this.http.post("WH", "SNSE195_GetCustomerLabel", JSON.stringify(this.formData))
            .subscribe((result: any) => {
                this.dataList = result.Table;
                this.CounterItem = this.dataList.length;
                console.log(this.dataList);
            })
    }

    EditRow(row: any) {

        this.index = this.dataList.indexOf(row)
        this.LabelName = cloneDeep(this.dataList[this.index].LABEL_NAME)
        this.RouteCode = cloneDeep(this.dataList[this.index].ROUTE_CODE)
        this.dialogEditCustomerBKK.OpenDialog();
    }

    SaveDataEdit() {
        this.dataList[this.index].LABEL_NAME = this.LabelName
        this.dataList[this.index].ROUTE_CODE = this.RouteCode

        console.log('this.dataList[index]', this.dataList[this.index])
        this.http.post('WH', 'SNSE195_CustomerBKK_Save', this.dataList[this.index])
            .subscribe(res => {
                if (res === "Done") {
                  this.modal.info('Save successfully', this.viewref)              
                  this.GetCustomerLabel();
                  this.dialogEditCustomerBKK.Close();
                }
            }, (err) => {

                console.log(err, 'err')
            })
    }

    AddCustomerBKK() {
        this.data = {};
        this.dialogAddCustomerBKK.OpenDialog();
    }

    SaveDataAdd() {
        this.data.CUSTOMER_CODE = this.data.CUSTOMER_CODE.toUpperCase();
        this.http.post('WH', 'SNSE195_CustomerBKK_Add', JSON.stringify(this.data))
            .subscribe(res => {
                if (res === "Done") {
                  this.modal.info('Save successfully', this.viewref)                  
                  this.GetCustomerLabel();
                  this.dialogAddCustomerBKK.Close();
                }
            }, (err) => {

                console.log(err, 'err')
            })
    }

    ExportExcel() {

        this.http.Download("WH", "SNSE195_GetCustomerLabel_Export", JSON.stringify(this.formData))
            .subscribe(result => {
                if (result) {

                    this.download(result)
                }
            }, (err) => {
                console.log(err, 'err')
                console.log(this.formData, 'data');
            })

    }

    download(content) {

        const a = document.createElement('a');
        const file = new Blob([content], { type: content.type })
        a.href = URL.createObjectURL(file);
        a.download = "SNSE195_CustomerLabel.xlsx"
        a.click()
  }

  CancelAdd() {
    this.dialogAddCustomerBKK.Close();
  }

  CancelEdit() {
    this.dialogEditCustomerBKK.Close();
  }

}
