import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from '../../../core/global';
import { forkJoin } from 'rxjs';

@Component({
  selector: 'snsq088_001',
  templateUrl: './SNSQ088_001.component.html',
  styleUrls: ['./SNSQ088_001.component.css']
})


export class SNSQ088_001Component implements OnInit {
  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals
  ) {
  }
  public dataToSaveRowChecked: any = {
    ORDER_PART_NO: null,
    ORDER_PART_NAME: null,
    ORDER_QTY: null,
    STICKER_PACKER: null,
    LABEL_QTY: null,
    LABEL_VALUE: null,
    PO_DATE: null,
    PO_NO: null,
    PO_CLASS: null,
    PO_ITEM_NO: null,
    VENDOR_CODE: null,
    VENDOR_NAME: null,
    VENDOR_TYPE: null,
    ORIGIN_CODE: null,
    ORIGIN_NAME: null
  }
  //from BF
  public showFromPoDate;
  public showToPoDate;

  public searchCriteria: any = {
    FromPoDate: null,
    ToPoDate: null,
    PoClass: null,
    VendorType: null,
    PrintStatus: null,
    FromPONo: null,
    ToPONo: null,
    OrderPartNo: null,
    FromVendorCode: null,
    ToVendorCode: null,
    FromVendorShow: null,
    ToVendorShow: null
  };
  public totalItem = 0;
  public totalSelect = 0;

  public ListPoClass: any = [];//for combobox Po class
  public ListPrintStatus: any;
  public ListVenderType: any = [];//for combobox vendor type
  public OrderPartName = ""; // for show Name of Order Part No

  public LookupConfigPO: any = {
    ColName: "PO_NO",
    ColValue: "PO_NO",
    PlaceholderText: "Select PO No.",
    SourceController: "wPMS",
    SourceMethodName: "GetPONo",
    NoOfShowRecords: 30,
    MinLengthSearch: 2,
    uppercase: true

  }

  public VendorLookupVendorShowName: any = {
    ColName: "LOOKUP_VENDOR_NAME",
    PlaceholderText: "Select Vendor",
    SourceController: "wPMS",
    SourceMethodName: "GetVendorCode",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: true
  }

  @ViewChild('dialog') public dialog: any;

  public lookupConfigPartIndent: any = {
    ColName: "LOOKUP_PART_VALUE",
    PlaceholderText: "Select Order Part No.",
    SourceController: "wPMS",
    SourceMethodName: "GetIndentDetailPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 3
  }

  //for ManualPrint
  public manualPartNo = "";
  public manualPartName = "";
  public manualOriginName = "";
  public manualMasterStrickerPackage = 1;//inti is 1 card
  public manualPartNameEN = "";

  public manualLabelQty = 0;//init is ""
  public manualLabelValue = 0;

  public dataList: any = [];
  private oldDataList: any = [];
  public vendorList: any = [];
  public vendor: string = "";
  public vendorTo: string = "";

  public manualPrint: any = {
    PartNo: "",
    PartName: "",
    OriginName: "",
    MasterStrickerPackage: 1,
    LabelQty: 0,
    LabelValue: 0
  }

  public lookupConfigPartMaster: any = {
    ColName: "LOOKUP_PART_NAME",
    PlaceholderText: "Select Part No.",
    SourceController: "IC",
    SourceMethodName: "SNSQ088_GetManualPart",
    NoOfShowRecords: 25,
    MinLengthSearch: 3
  }

  ngOnInit() {

    this.ListPrintStatus = [{ ID: 'A', TEXT: "All" }, { ID: 'N', TEXT: "Not Print" }, { ID: 'P', TEXT: "Printed" }, { ID: '', TEXT: "" }]
    this.ListVenderType = [{ ID: 'J', TEXT: "J : Japan" }, { ID: 'K', TEXT: "K : Import(Not Japan)" }, { ID: 'L', TEXT: "L : Local" }, { ID: 'O', TEXT: "O : Oil" }, { ID: '', TEXT: "" }]

    this.http.get("System", "QueryData", "SP_NP_MT_PO_CLASS_LIST")
      .subscribe(result => {
        //console.log('this.result', result);
        this.ListPoClass = result.Table;
      })
  }

  SetSelectedPart(value: any) {
    this.searchCriteria.OrderPartNo = value.ACCEPT_PART_NO;
    this.OrderPartName = value.PART_NAME_EN;
  }

  SetSearchVendorFrom(value: any) {
    this.searchCriteria.FromVendorShow = value.LOOKUP_VENDOR_NAME;
    this.searchCriteria.FromVendorCode = value.VENDOR_CODE;
  }
  SetSearchVendorTo(value: any) {
    this.searchCriteria.ToVendorShow = value.LOOKUP_VENDOR_NAME;
    this.searchCriteria.ToVendorCode = value.VENDOR_CODE;
  }

  SetSelectedManualPart(value: any) {
    this.manualLabelQty = 0;
    this.manualPartNo = value.PART_NO;
    this.manualPartName = value.PART_NAME;
    this.manualPartNameEN = value.PART_NAME;
    this.manualOriginName = value.ORIGIN_NAME2;
    this.manualMasterStrickerPackage = value.PO_PACKAGE;
    this.manualLabelValue = (value.PO_PACKAGE === 0) ? 1 : value.PO_PACKAGE;
  }

  manualPrintLabel() {
    if (this.manualPartName.toString().trim().length > 0 && this.manualLabelQty > 0) {
      this.manualPrint.PartNo = this.manualPartNo;
      this.manualPrint.PartName = this.manualPartNameEN;
      this.manualPrint.OriginName = this.manualOriginName;
      this.manualPrint.MasterStrickerPackage = this.manualMasterStrickerPackage;
      this.manualPrint.LabelQty = this.manualLabelQty;
      this.manualPrint.LabelValue = this.manualLabelValue;

      this.http.post("IC", "SNSQ088_SavePrintManual", JSON.stringify(this.manualPrint))
        .subscribe((result: any) => {
          this.GoToReportPrintCheckList();
        })
    }
  }
  //end for ManualPrint
  //end BF

  CheckSearchFromToCondition() {
    //Check null,undefined,""
    if (this.searchCriteria.PoClass === null || this.searchCriteria.PoClass === undefined) {
      this.searchCriteria.PoClass = "";
    }
    if (this.searchCriteria.FromVendorCode == null || this.searchCriteria.FromVendorCode.toString().trim().length === 0) {
      this.searchCriteria.FromVendorCode = this.searchCriteria.ToVendorCode;
      this.searchCriteria.FromVendorShow = this.searchCriteria.ToVendorShow;
    }
    if (this.searchCriteria.ToVendorCode == null || this.searchCriteria.ToVendorCode.toString().trim().length === 0) {
      this.searchCriteria.ToVendorCode = this.searchCriteria.FromVendorCode;
      this.searchCriteria.ToVendorShow = this.searchCriteria.FromVendorShow;
    }
    if (this.searchCriteria.FromPONo == null || this.searchCriteria.FromPONo.toString().trim().length === 0) {
      this.searchCriteria.FromPONo = this.searchCriteria.ToPONo;
    }
    if (this.searchCriteria.ToPONo == null || this.searchCriteria.ToPONo.toString().trim().length === 0) {
      this.searchCriteria.ToPONo = this.searchCriteria.FromPONo;
    }

    if (this.showFromPoDate == null || this.showFromPoDate.toString().trim().length === 0) {
      this.showFromPoDate = this.showToPoDate;
    }
    if (this.showToPoDate == null || this.showToPoDate.toString().trim().length === 0) {
      this.showToPoDate = this.showFromPoDate;
    }

  }//end CheckSearchCondition

  GetOrderPartData() {
    this.dataList = [];
    this.oldDataList = [];
    this.CheckSearchFromToCondition();

    // some_variable is either null, undefined, 0, NaN, false, or an empty string
    if (!this.showFromPoDate) {
      this.searchCriteria.FromPoDate = null;
    } else {//typeof object and moment.Moment that can call .format('ll')
      this.searchCriteria.FromPoDate = this.showFromPoDate.format('ll');
    }
    if (!this.showToPoDate) {
      this.searchCriteria.ToPoDate = null;
    } else {//typeof object and moment.Moment that can call .format('ll')
      this.searchCriteria.ToPoDate = this.showToPoDate.format('ll');
    }

    this.http.post("IC", "SNSQ088_SearchOrderPartNoList", JSON.stringify(this.searchCriteria))
      .subscribe((result: any) => {
        let i = 1;
        result.Table.forEach(d => {
          d.SEQ_NO = i;
          this.totalItem = i;
          i++;
        });

        this.dataList = result.Table;
        this.totalSelect = this.dataList.filter(x => x.SEND_DATA_FLAG == 'Y').length
        this.oldDataList = JSON.parse(JSON.stringify(this.dataList));
      })
  }

  PrintLabelFromSearch() {
    if (this.totalSelect > 0) {
      let checkedList = this.dataList.filter(d => d.SEND_DATA_FLAG === 'Y');
      this.SaveCheckList(checkedList).then(() => {
        this.SavePrintLabel().then(() => {
          this.GoToReportPrintCheckList();
        });
      })
    }
  }

  GoToReportPrintCheckList() {
    this.global.GoToReport("PMS_RPT_IC_SNSQ088", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_USER_ID: this.global.GetTokenDetail("ssUserName")
    })
  }

  SaveCheckList(checkedList){
    return this.http.post("IC", "SNSQ088_SaveCheckList", checkedList).toPromise();
  }

  SavePrintLabel() {
    return this.http.post("IC", "SNSQ088_SavePrintLabel", {}).toPromise();
  }

  CheckboxChange(evt, ctrl) {
    ctrl.SEND_DATA_FLAG = evt.checked ? 'Y' : 'N';

    if (evt.checked) {
      this.totalSelect++;
    } else {
      this.totalSelect--;
    }
  }

  OpenManualDialog() {
    this.dialog.OpenDialog();

    this.manualLabelQty = 0;
    this.manualPartNo = null;
    this.manualPartName = null;
    this.manualPartNameEN = null
    this.manualOriginName = null
    this.manualMasterStrickerPackage = null
    this.manualLabelValue = 0
  }

  ClearSearch() {
    this.searchCriteria = {
      FromPoDate: null,
      ToPoDate: null,
      PoClass: null,
      VendorType: null,
      PrintStatus: null,
      FromPONo: null,
      ToPONo: null,
      OrderPartNo: null,
      FromVendorCode: null,
      ToVendorCode: null,
      FromVendorShow: null,
      ToVendorShow: null
    };

    this.dataList = [];
  }

}
