import { Component, OnInit, ViewChild, ViewContainerRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'SNWR001',
  templateUrl: './SNWR001.component.html',
  styleUrls: ['../warehouse.component.css']
})

export class SNWR001Component implements OnInit {
  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private global: Globals,
    private viewRef: ViewContainerRef
  ) { }

  @ViewChild("dialogCustomPrint", { static: false }) dialogCustomPrint: any;

  public tableData: any = [];
  public IsAdd = false;
  public IsSaved = false;
  public dataSearch: any = [];
  public tableSLoc: any;
  public tableSPart: any;
  public tableSPrit: any;
  public grdLoc: any;
  public grdPart: any;
  public grdPrint: any;
  public ReccordCount: any = 0;
  public params = {
    locationFrom: null,
    locationTo: null,
    PrintFrom: null,
    PartFrom: null,
    PartTo: null,
    PRINT_NO: null,
    PrintTo: null
  }
  public ConfigLocation: any = {
    ColName: "LOOKUP_LOCATION_NO",
    PlaceholderText: "Select Location",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetLocation",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: true
  }
  public ConfigPart: any = {
    ColName: "PART_NO",
    ColValue: "PART_NO",
    PlaceholderText: "Select Part",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetPart",
    NoOfShowRecords: 30,
    //locationFrom: this.params.locationFrom !== null ? this.params.locationFrom:"null",
    //locationTo: this.params.locationTo !== null ? this.params.locationTo : "null",

    SourceParams: {
      locationFrom: null,
      locationTo: null
    },
    MinLengthSearch: 1,
    UpperCase: true
  }
  public ConfigPrint: any = {
    ColName: "PRINT_NO",
    ColValue: "PRINT_NO",
    PlaceholderText: "Select Print",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetPrint",
    locationFrom: this.params.locationFrom !== null ? this.params.locationFrom : "null",
    locationTo: this.params.locationTo !== null ? this.params.locationTo : "null",
    PartFrom: this.params.PartFrom !== null ? this.params.PartFrom : "null",
    PartTo: this.params.PartTo !== null ? this.params.PartTo : "null",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: true
  }

  ngOnInit() {


  }

  GetLocation(code, p) {
    if (p === "F") {
      this.params.locationFrom = code;
      this.ConfigPart.SourceParams.locationFrom = this.params.locationFrom !== null ? this.params.locationFrom : "null";
    }
    if (p === "T") {
      this.params.locationTo = code;
      this.ConfigPart.SourceParams.locationTo = this.params.locationTo !== null ? this.params.locationTo : "null";
    }
  }
  GetPrint(code, p) {
    if (p === "F") {
      this.params.PrintFrom = code;
    }
    if (p === "T") {
      this.params.PrintTo = code;
    }
  }
  GetPart(code, p) {
    if (p === "F") {
      this.params.PartFrom = code;
    }
    if (p === "T") {
      this.params.PartTo = code;
    }
  }

  FindGrdData() {

    if (this.params.locationFrom <= 3) {

      this.modal.warning("Please input location more than 3 characters.", this.viewRef);
      return;
    }

    if (this.params.locationTo <= 3) {

      this.modal.warning("Please input location more than 3 characters.", this.viewRef);
      return;
    }

    this.params.locationFrom = this.params.locationFrom.toUpperCase();

    this.http.get("WH", "SNWR001_Search", this.params.locationFrom !== null ? this.params.locationFrom : "null"
      , this.params.locationTo !== null ? this.params.locationTo : "null"
      , this.params.PartFrom !== null ? this.params.PartFrom : "null"
      , this.params.PartTo !== null ? this.params.PartTo : "null")
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataSearch = result.Table;
          this.ReccordCount = result.Table.length;
        } else {
          this.ReccordCount = 0;
        }
      });
  }

  PrintReloCard() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR001",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_LOCATION_FROM: this.params.locationFrom,
        P_LOCATION_TO: this.params.locationTo,
        P_PART_NO_FROM: this.params.PartFrom,
        P_PART_NO_TO: this.params.PartTo
      });

  }

  public OpenCustomPrint() {
    this.tableData = [];
    this.IsAdd = true;
    this.IsSaved = false;
    this.CreateDetailRow(0);


    this.dialogCustomPrint.OpenDialog();
  }

  public CloseCustomPrint() {
    this.dialogCustomPrint.Close();
  }

  CreateDetailRow(tblIndex) {
    let currentMaxRow: number = this.tableData.length || 0;
    let nextMaxRow: number = (Math.floor(currentMaxRow / 10) + 1) * 30;

    if (currentMaxRow - tblIndex <= 2) {
      for (let i = currentMaxRow; i < nextMaxRow; i++) {
        this.tableData.push({
          LOCATION_NO: null,
        });
      }

      this.tableData = [...this.tableData];
    }

  }

  DeleteRow(index) {
    if (this.IsAdd) {

      this.modal.confirm("Are you sure to remove this row?", this.viewRef,
        () => {
          this.tableData.splice(index, 1);
          this.tableData = [...this.tableData];
        }, () => { })

    }
  }
  public SetLocationNo(values, data) {
    data.LOCATION_NO = values.LOCATION_NO;
    data.FLOOR_NO = values.FLOOR_NO;
    data.RACK_CODE = values.RACK_CODE;
    data.RACK_GROUP_CODE = values.RACK_GROUP_CODE;
    data.MAX_WEIGHT = values.MAX_WEIGHT;
    data.PART_NO = values.PART_NO;
    data.PART_NAME_TH = values.PART_NAME_TH;
    data.PART_NAME_EN = values.PART_NAME_EN;
  }

  public SaveManual = () => {
    const filterTable = this.tableData.filter(x => x.LOCATION_NO);

    this.http.post('WH', 'SNWR001_InsertTemp', filterTable)
      .subscribe(res => {
        this.global.GoToReport("PMS_RPT_WMS_SNWR001_Manual",
          {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_SYSTEM_USER: this.global.GetTokenDetail("ssUserName"),
          });
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }
}
