import { Component, OnInit, ViewChild } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from "../../../core/modal.service";
import { ViewContainerRef } from "@angular/core";

@Component({
  selector: 'SNWR002',
  templateUrl: './SNWR002.component.html',
  styleUrls: ['../warehouse.component.css']
})

export class SNWR002Component implements OnInit {
  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals
  ) { }


  public dataPartNonLocation: any = [];
  public dataPONonLocation: any = [];
  public dataPartPOComming: any = [];
  public dataPartTempLocation: any = [];
  public dataLocationList1: any = [];
  public dataLocationList2: any = [];
  public dataLocationList3: any = [];
  public dataLocationList4: any = [];


  public PART_NO: any = {};

  public partInfo: any = {};
  public partPO: any = {};

  public dataConfig: any = {};

  public selectedLocation: any = {};
  public dataByCat: any = {};
  public dataByTemp: any = {};
  public dataByEmpty: any = {};

  private iSelect: number = 0;
  public iByCat: number = 0;
  public iByTemp: number = 0;
  public iByEmpty: number = 0;

  public iMaxCat: number = 0;
  public iMaxTemp: number = 0;
  public iMaxEmpty: number = 0;

  public FIND_LOCATION_NO:any;
  //public tableSLoc: any;
  //public tableSPart: any;
  //public tableSPrit: any;
  //public grdLoc: any;
  //public grdPart: any;
  //public grdPrint: any;
  public ReccordCount: any = 0;
  public params = {
    locationFrom: null,
    locationTo: null,
    PrintFrom: null,
    PartFrom: null,
    PartTo: null,
    PRINT_NO: null,
    PrintTo: null
  }
  @ViewChild("dialogMain", { static: false }) dialogMain: any;
  @ViewChild("dialogSecond", { static: false }) dialogSecond: any;


  public ConfigLocation: any = {
    ColName: "LOCATION_NO",
    ColValue: "LOCATION_NO",
    PlaceholderText: "Select Location",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetLocation",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  public ConfigPart: any = {
    ColName: "PART_NO",
    ColValue: "PART_NO",
    PlaceholderText: "Select Part",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetPart",
    NoOfShowRecords: 30,
    //locationFrom: this.params.locationFrom !== null ? this.params.locationFrom:"null",
    //locationTo: this.params.locationTo !== null ? this.params.locationTo : "null",

    SourceParams: {
      locationFrom: null,
      locationTo: null
    },
    MinLengthSearch: 1,
    UpperCase: false
  }
  public ConfigPrint: any = {
    ColName: "PRINT_NO",
    ColValue: "PRINT_NO",
    PlaceholderText: "Select Print",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetPrint",
    locationFrom: this.params.locationFrom !== null ? this.params.locationFrom : "null",
    locationTo: this.params.locationTo !== null ? this.params.locationTo : "null",
    PartFrom: this.params.PartFrom !== null ? this.params.PartFrom : "null",
    PartTo: this.params.PartTo !== null ? this.params.PartTo : "null",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  ngOnInit() {
    this.dataConfig.COMING_IN_DAY = 0;
    this.dataConfig.ETD_DAY = 0;
    this.dataConfig.M3_MAGIN_RATE = 10;
    this.dataConfig.WEIGHT_MAGIN_RATE = 10;

    this.PART_NO = '';

    //this.GetPartNonLocation();
  }


  GetPrint(code, p) {
    if (p === "F") {
      this.params.PrintFrom = code;
    }
    if (p === "T") {
      this.params.PrintTo = code;
    }
  }
  GetPart(code, p) {
    if (p === "F") {
      this.params.PartFrom = code;
    }
    if (p === "T") {
      this.params.PartTo = code;
    }
  }




  public GetPartNonLocation() {

   
    if (this.PART_NO.length < 4) {
      this.modal.warning("Please input the Part no. as less 4 characters", this.viewRef);
      return;
    }

    this.http.get("WH", "SNWR002_GetPartNonLocation", this.PART_NO)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataPartNonLocation = result.Table;         

        } else {
          this.ReccordCount = 0;
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetPONonLocation() {

    this.http.get("WH", "SNWR002_GetPONonLocation")
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataPONonLocation = result.Table;  
          this.ReccordCount = result.Table.length;
        } else {
          this.ReccordCount = 0;
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  //----------------- Tab 2 ------------------

  public RetreivePart() {
    this.dataPartPOComming = {};
    this.http.post("WH", "SNWR002_GetIncomingPart", this.dataConfig)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataPartPOComming = result.Table;
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }


  public EditData(data) {
    this.selectedLocation = {};
    this.iByCat = 0;
    this.iByTemp = 0;
    this.iByEmpty = 0;
    this.partPO = data;

    this.http.post('WH', 'SNWR002_GetLocationSuggest', data)
    //this.http.get("WH", "SNWR002_GetLocationSuggest"
    //  , data.PART_NO !== null ? data.PART_NO : "null"
    //  , data.PART_CATEGORY !== null ? data.PART_CATEGORY : "null"
    //  , data.LOCATION_NO !== null ? data.LOCATION_NO : "null"
    //  , this.params.PartTo !== null ? this.params.PartTo : "null")
      .subscribe(result => {

        this.partInfo = result.Table[0];
        this.dataLocationList1 = result.Table1;
        this.dataLocationList2 = result.Table2;
        this.dataLocationList3 = result.Table3;

/*        console.log(this.dataLocationList3);*/

        this.iMaxCat = this.dataLocationList1.length;
        this.iMaxTemp = this.dataLocationList2.length;
        this.iMaxEmpty = this.dataLocationList3.length;

        this.SetByCat(0);
        this.SetByTemp(0);
        this.SetByEmpty(0);
        this.dialogMain.OpenDialog();
      }, err => {
        console.log(err);
        this.modal.error("Found error, please contact support team.", this.viewRef);
      });
  }

  public FindLocation() {    
    var temp = this.FIND_LOCATION_NO;
  
    if (this.dataLocationList3.length > 0) {
      let data = this.dataLocationList3.find(x => x.LOCATION_NO == temp);
      if (data) {
        this.dataByEmpty = data;
        this.FIND_LOCATION_NO = temp;
      } else {
        this.modal.warning("Location No. not found!", this.viewRef);
    }
    }
  }

  public EditDataWithDemand(data) {
    this.selectedLocation = {};
    this.iByCat = 0;
    this.iByTemp = 0;
    this.iByEmpty = 0;
    this.partPO = data;
    this.http.get("WH", "SNWR002_GetLocationSuggest"
      , data.PART_NO !== null ? data.PART_NO : "null"
      , data.PART_CATEGORY !== null ? data.PART_CATEGORY : "null"
      , data.LOCATION_NO !== null ? data.LOCATION_NO : "null"
      , this.params.PartTo !== null ? this.params.PartTo : "null")
      .subscribe(result => {

        this.partInfo = result.Table[0];
        this.dataLocationList1 = result.Table1;
        this.dataLocationList2 = result.Table2;
        this.dataLocationList3 = result.Table3;
     
        if (data.LOCATION_NO) {
          this.dataLocationList4 = result.Table4;
          this.selectedLocation = this.dataLocationList4[0];
        }  

        this.iMaxCat = this.dataLocationList1.length;
        this.iMaxTemp = this.dataLocationList2.length;
        this.iMaxEmpty = this.dataLocationList3.length;

        this.SetByCat(0);
        this.SetByTemp(0);
        this.SetByEmpty(0);
        this.dialogSecond.OpenDialog();
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public SelectLocation(data) {

    if (data == 1) {
      this.selectedLocation = this.dataByCat;// this.dataLocationList1[this.iByCat];
    } else if (data == 2) {
      this.selectedLocation = this.dataByTemp; // this.dataLocationList2[this.iByTemp];
    } else if (data == 3) {
      this.selectedLocation = this.dataByEmpty; // this.dataLocationList3[this.iByEmpty];
    }
  }

  public SetByCat(idx) {
    this.iByCat = this.iByCat + idx;
    if (this.iByCat < 0) {
      this.iByCat = 0;
    }
    if (this.iByCat >= this.dataLocationList1.length) {
      this.iByCat = this.dataLocationList1.length - 1;
    }
  
    if (this.dataLocationList1.length > 0) {
      this.dataByCat = this.dataLocationList1[this.iByCat];
    }
  }

  public SetByTemp(idx) {
    this.iByTemp = this.iByTemp + idx;
    if (this.iByTemp < 0) {
      this.iByTemp = 0;
    }
    if (this.iByTemp >= this.dataLocationList2.length) {
      this.iByTemp = this.dataLocationList2.length - 1;
    }

    if (this.dataLocationList2.length > 0) {
      this.dataByTemp = this.dataLocationList2[this.iByTemp];
    }

  }

  public SetByEmpty(idx) {
    this.iByEmpty = this.iByEmpty + idx;
    if (this.iByEmpty < 0) {
      this.iByEmpty = 0;
    }
    if (this.iByEmpty >= this.dataLocationList3.length) {
      this.iByEmpty = this.dataLocationList3.length - 1;
    }

    if (this.dataLocationList3.length > 0) {
      this.dataByEmpty = this.dataLocationList3[this.iByEmpty];
    }

  }

  public ConfirmLocation() {

    if (!this.selectedLocation.LOCATION_NO) {
      this.modal.warning("Please select location first", this.viewRef);
    }

    this.modal.confirm('Do you want to confirm? <br> Location no. : ' +  this.selectedLocation.LOCATION_NO
      + ' <br> Part no. : ' + this.partInfo.PART_NO , this.viewRef, this.ConfirmSaveLocation);

  }


  private ConfirmSaveLocation = () => {
    this.selectedLocation.PART_NO = this.partInfo.PART_NO;
    this.http.post('WH', 'SNWR002_UpdateLocation', this.selectedLocation)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Successfully to confirm location', this.viewRef);
          this.dialogMain.Close();
          //this.GetPartNonLocation();
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }

  public ConfirmUse() {

    if (!this.selectedLocation.LOCATION_NO) {
      this.modal.warning("Please select location first", this.viewRef);
    }

    this.modal.confirm('Do you want to confirm? <br> Location no. : ' + this.selectedLocation.LOCATION_NO
      + ' <br> Part no. : ' + this.partInfo.PART_NO, this.viewRef, this.ConfirmUseLocation);

  }

  private ConfirmUseLocation = () => {
    this.selectedLocation.PART_NO = this.partInfo.PART_NO;
    this.http.post('WH', 'SNWR002_UpdateLocation', this.selectedLocation)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Successfully to confirm location', this.viewRef);
          this.dialogSecond.Close();
          this.GetPartNonLocation();
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }

  public ProcessSuggest() {

    this.http.post('WH', 'SNWR002_ProcessSuggest', this.dataConfig)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.GetPartNonLocation();
          this.modal.info('Successfully to suggest location, please check', this.viewRef);
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });

  }

  PrintReloCard() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR001",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_LOCATION_FROM: this.params.locationFrom,
        P_LOCATION_TO: this.params.locationTo,
        P_PART_NO_FROM: this.params.PartFrom,
        P_PART_NO_TO: this.params.PartTo
      });

  }


}
