import { Component, ElementRef, OnInit, ViewChild } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from "../../../core/modal.service";
import { ViewContainerRef } from "@angular/core";
import { SelectionModel } from '@angular/cdk/collections';
import { FormControl } from "@angular/forms";
import { isBoolean } from "util";

@Component({
  selector: 'SNWR004',
  templateUrl: './SNWR004.component.html',
  styleUrls: ['../warehouse.component.css']
})

export class SNWR004Component implements OnInit {
  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals
  ) { }

  public dataPartTempLocation: any = [];
  public dataCategoryChange: any = [];
  public dataHighCapacity: any = [];
  public dataLowCapacity: any = [];
  public dataManualSelect: any = [];

  public dataLocationStatus: any = [];
  public dataLocationList1: any = [];
  public dataLocationList2: any = [];
  public dataLocationList3: any = [];
  public dataLocationList4: any = [];
  public dataLocationList4Temp: any = [];
  public dataLocationList5: any = [];

  public paramSearch: any = {};

  public partInfo: any = {};
  public partPO: any = {};

  public dataConfig: any = {};

  public selectedLocation: any = {};
  public currentLocation: any = {};
  public dataByCat: any = {};
  public dataByEmpty: any = {};

  private iTab: number = 0;
  public iByCat: number = 0;
  public iByEmpty: number = 0;

  public iMax: number = 0;
  public iMaxEmpty: number = 0;

  public selection = new SelectionModel<any>(true, []);
  public dataIsSelected: any = [];

  public ReccordCount: any = 0;
  public params = {
    locationFrom: null,
    locationTo: null,
    PrintFrom: null,
    PartFrom: null,
    PartTo: null,
    PRINT_NO: null,
    PrintTo: null
  }
  @ViewChild("dialogMain", { static: false }) dialogMain: any;
  @ViewChild("dialogSecond", { static: false }) dialogSecond: any;
  @ViewChild("fileInput") fileInput: ElementRef;
  @ViewChild("dialogUpload", { static: false }) dialogUpload: any;
  public tableDataUpload : any = [];
  public correctData : any = [];
  private file : any;
  public fileNameInput: string = "";
  public isSave : boolean = false;

  myControl = new FormControl();

  public ConfigLocation: any = {
    ColName: "LOCATION_NO",
    ColValue: "LOCATION_NO",
    PlaceholderText: "Select Location",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetLocation",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }
  public ConfigPart: any = {
    ColName: "PART_NO",
    ColValue: "PART_NO",
    PlaceholderText: "Select Part",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetPart",
    NoOfShowRecords: 30,
    //locationFrom: this.params.locationFrom !== null ? this.params.locationFrom:"null",
    //locationTo: this.params.locationTo !== null ? this.params.locationTo : "null",

    SourceParams: {
      locationFrom: null,
      locationTo: null
    },
    MinLengthSearch: 1,
    UpperCase: false
  }
  public ConfigPrint: any = {
    ColName: "PRINT_NO",
    ColValue: "PRINT_NO",
    PlaceholderText: "Select Print",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetPrint",
    locationFrom: this.params.locationFrom !== null ? this.params.locationFrom : "null",
    locationTo: this.params.locationTo !== null ? this.params.locationTo : "null",
    PartFrom: this.params.PartFrom !== null ? this.params.PartFrom : "null",
    PartTo: this.params.PartTo !== null ? this.params.PartTo : "null",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  ngOnInit() {
    this.dataConfig.COMING_IN_DAY = 0;
    this.dataConfig.ETD_DAY = 0;
    this.dataConfig.M3_MAGIN_RATE = 10;
    this.dataConfig.WEIGHT_MAGIN_RATE = 10;

    this.GetPartReLocationStatus();

    this.paramSearch.LOCATION_NO = '';
    //this.GetPartReLocation1();
    //this.GetPartReLocation2();
    //this.GetPartReLocation3();
    //this.GetPartReLocation4();
  }

  public TabChange($event) {

    if ($event.index == 0) {
      this.GetPartReLocationStatus();
    } else if ($event.index == 1) {
      this.GetPartReLocation1();
    } else if ($event.index == 2) {
      this.GetPartReLocation2();
    } else if ($event.index == 3) {
      this.GetPartReLocation3();
    } else if ($event.index == 4) {
      this.GetPartReLocation4();
    }

  }

  public Search() {
    //this.myControl.markAsTouched();
    if (this.paramSearch.LOCATION_NO.length < 4) {
      this.modal.warning("Please input location at less 4 characters.", this.viewRef);
      return;
    } else {
    
      this.http.post('WH', 'SNWR004_GetReLocationL5', this.paramSearch)
        .subscribe(res => {
          this.dataManualSelect = res.Table;
        }, (err) => {
          console.log(err, 'err');
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
    }

  }
  GetPrint(code, p) {
    if (p === "F") {
      this.params.PrintFrom = code;
    }
    if (p === "T") {
      this.params.PrintTo = code;
    }
  }
  GetPart(code, p) {
    if (p === "F") {
      this.params.PartFrom = code;
    }
    if (p === "T") {
      this.params.PartTo = code;
    }
  }



  public GetPartReLocationStatus() {
    this.http.get("WH", "SNWR004_GetReLocationStatus")
      .subscribe(result => {
        this.dataLocationStatus = result.Table;

      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }


  public GetPartReLocation1() {
    this.http.get("WH", "SNWR004_GetReLocationL1",this.paramSearch.TEMP_LOCATION)
      .subscribe(result => {
        this.dataPartTempLocation = result.Table;

      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetPartReLocation2() {
    this.http.get("WH", "SNWR004_GetReLocationL2")
      .subscribe(result => {
        this.dataCategoryChange = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetPartReLocation3() {
    this.http.get("WH", "SNWR004_GetReLocationL3")
      .subscribe(result => {
        this.dataHighCapacity = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetPartReLocation4() {
    this.http.get("WH", "SNWR004_GetReLocationL4")
      .subscribe(result => {
        this.dataLowCapacity = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  //public GetPartReLocation5() {
  //  this.http.post("WH", "SNWR004_GetReLocationL5", this.paramSearch)
  //    .subscribe(result => {
  //      this.dataManualSelect = result.Table;
  //    }, err => {
  //      console.log(err);
  //      this.modal.error("Found eror, please contact support team.", this.viewRef);
  //    });
  //}

  //----------------- Tab 2 ------------------

  //public RetreivePart() {
  //  this.dataPartPOComming = {};
  //  this.http.post("WH", "SNWR002_GetIncomingPart", this.dataConfig)
  //    .subscribe(result => {
  //      if (result.Table.length > 0) {
  //        this.dataPartPOComming = result.Table;
  //      }
  //    }, err => {
  //      console.log(err);
  //      this.modal.error("Found eror, please contact support team.", this.viewRef);
  //    });
  //}


  public EditData(data, pTab) {

    this.iTab = pTab;
    this.selectedLocation = {};
    this.currentLocation = {};
    this.iByCat = 0;
    this.partPO = data;

    this.http.post('WH', 'SNWR004_GetLocationSuggest', data)
      //this.http.get("WH", "SNWR004_GetLocationSuggest"
      //  , data.PART_NO !== null ? data.PART_NO : "null"
      //  , data.PART_CATEGORY !== null ? data.PART_CATEGORY : "null"
      //  , data.LOCATION_NO !== null ? data.LOCATION_NO : "null"
      //  , this.params.PartTo !== null ? this.params.PartTo : "null")

      .subscribe(result => {

        this.partInfo = result.Table[0];
        this.dataLocationList1 = result.Table1;
        this.dataLocationList2 = result.Table2;
        this.dataLocationList3 = result.Table3;

        this.dataLocationList4 = result.Table4;

        this.dataLocationList4Temp = result.Table4;
        this.dataLocationList5 = result.Table5;

        this.currentLocation = this.dataLocationList3[0];

        if (this.currentLocation.LOCATION_STATUS == 'R' || this.currentLocation.LOCATION_STATUS == 'DR' || this.currentLocation.LOCATION_STATUS == 'FR') {
          this.selectedLocation = this.dataLocationList2[0];
        } else {

        }

        this.iMax = this.dataLocationList1.length;
        this.iMaxEmpty = this.dataLocationList4.length;

        this.SetByCat(0);
        this.SetByEmpty(0);
        // this.SetByTemp(0);
        this.dialogMain.OpenDialog();
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }


  public SelectLocation(data) {

    if (data == 1) {
      this.selectedLocation = this.dataByCat; //this.dataLocationList1[this.iByCat];
    } else if (data == 3) {
      this.selectedLocation = this.dataByEmpty; //this.dataLocationList4[this.iByEmpty];
    }
  }

  public SetByCat(idx) {
    this.iByCat = this.iByCat + idx;
    if (this.iByCat < 0) {
      this.iByCat = 0;
    }
    if (this.iByCat >= this.dataLocationList1.length) {
      this.iByCat = this.dataLocationList1.length - 1;
    }

    if (this.dataLocationList1.length > 0) {
      this.dataByCat = this.dataLocationList1[this.iByCat];
    }
  }

  //public FindLocation() {
  //  var temp = this.dataByEmpty.FIND_LOCATION_NO;

  //  if (this.dataLocationList4.length > 0) {
  //    this.dataByEmpty = this.dataLocationList4.find(x => x.LOCATION_NO == temp);
  //    this.dataByEmpty.FIND_LOCATION_NO = temp;
  //  }

  //}

  public FindLocation() {
    var temp = this.dataByEmpty.FIND_LOCATION_NO.toUpperCase();
    var dataLocation: any = [];

    if (this.dataLocationList4Temp.length > 0) {

      dataLocation = this.dataLocationList4Temp.filter(x => x.LOCATION_NO.indexOf(temp) == 0);
      this.dataLocationList4 = this.dataLocationList4Temp.filter(x => x.LOCATION_NO.indexOf(temp) == 0);

      if (dataLocation.length > 0){
        this.dataByEmpty = dataLocation[0];
      }

      this.dataByEmpty.FIND_LOCATION_NO = temp;
      this.iMaxEmpty = this.dataLocationList4.length;
      this.iByEmpty = 0;
      this.SetByEmpty(0);
    }

   

  }
  public SetByEmpty(idx) {
    this.iByEmpty = this.iByEmpty + idx;
    if (this.iByEmpty < 0) {
      this.iByEmpty = 0;
    }
    if (this.iByEmpty >= this.dataLocationList4.length) {
      this.iByEmpty = this.dataLocationList4.length - 1;
    }

    if (this.dataLocationList4.length > 0) {
      this.dataByEmpty = this.dataLocationList4[this.iByEmpty];
    }

  }


  private RefreshData() {
    if (this.iTab == 0) {

    } else if (this.iTab == 1) {
      this.GetPartReLocation1();
    } else if (this.iTab == 2) {
      this.GetPartReLocation2();
    } else if (this.iTab == 3) {
      this.GetPartReLocation3();
    } else if (this.iTab == 4) {
      this.GetPartReLocation4();
    } else if (this.iTab == 5) {
      //this.GetPartReLocation5();
    } else {

    }
    this.GetPartReLocationStatus();
  }

  public ConfirmLocation() {

    if (!this.selectedLocation.LOCATION_NO) {
      this.modal.warning("Please select location first", this.viewRef);
    }

    this.modal.confirm('Do you want to confirm? <br> Location no. : ' + this.selectedLocation.LOCATION_NO
      + ' <br> Part no. : ' + this.partInfo.PART_NO, this.viewRef, this.ConfirmSaveLocation);

  }

  private ConfirmSaveLocation = () => {
    this.selectedLocation.PART_NO = this.partInfo.PART_NO;
    this.selectedLocation.LOCATION_NO_OLD = this.currentLocation.LOCATION_NO;

    this.http.post('WH', 'SNWR004_ReLocation', this.selectedLocation)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Successfully to confirm save new location', this.viewRef);
          this.dialogMain.Close();
          this.RefreshData();

        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }


  public ConfirmReLocation() {

    if (!this.selectedLocation.LOCATION_NO) {
      this.modal.warning("Please select location first", this.viewRef);
    }

    this.modal.confirm('Do you want to confirm to finish re-location for this part?', this.viewRef, this.ConfirmSaveReLocation);

  }

  private ConfirmSaveReLocation = () => {
    this.selectedLocation.PART_NO = this.partInfo.PART_NO;
    this.selectedLocation.LOCATION_NO_OLD = this.currentLocation.LOCATION_NO;

    this.http.post('WH', 'SNWR004_ConfirmReLocation', this.selectedLocation)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Successfully to confirm location', this.viewRef);
          this.dialogMain.Close();
          this.RefreshData();

        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }

  public isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.dataLocationStatus.length;
    return numSelected === numRows;
  }

  public Toggle() {
    if (this.isAllSelected()) {
      this.selection.clear()
      this.dataLocationStatus.map(x => {
        this.dataIsSelected = [];
      })
    } else {
      this.dataLocationStatus.forEach(row => this.selection.select(row));
      this.dataIsSelected = [];
      this.dataLocationStatus.map(x => {
        this.dataIsSelected.push(x);
      })
    }

  }

  public CheckboxChange(event, data) {
    if (event.checked) {

      this.dataIsSelected.push(data);
    }
    else {
      this.dataIsSelected.splice(this.dataIsSelected.indexOf(data), 1);
    }
    // this.params.CNT_SEL = this.dataIsSelected.length;
  }

  public OpenReport() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR004_RE_LOCATION_ST",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_USER_ID: '1'
      });
  }

  public OpenRelocationHistoryReport() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR004_RELOCATION_HISTORY", {});
  }

  public PrintLocation() {

    this.global.GoToReport("PMS_RPT_WMS_SNWR004_RE_LOCATION_ST",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_USER_ID: '1'
      });
  }

  public OpendialogUpload(){
    this.dialogUpload.OpenDialog();
    this.fileNameInput = "";
    //this.fileInput.nativeElement.value = '';
    this.tableDataUpload = []
    this.correctData = []
    this.isSave = false
  }
  public OpenFileBrowser() {
    this.fileNameInput = "";
    this.fileInput.nativeElement.value = '';
    this.fileInput.nativeElement.click();
  }
  public SelectFile(evt) {
    let Files: Array<File> = evt.target.files;
    if (Files.length > 0) {
      //let File: File = Files[0];
      this.file = Files[0];
      this.fileNameInput = this.file.name;
    }
  }
  public PreView() {
    if (!this.fileInput) {
      this.modal.warning("Please Open File First...", this.viewRef)
      return;
    }
        let formData = new FormData();
        formData.append('file', this.file);
        this.tableDataUpload = []
        this.http.postFile("WH", "SNWR004_UploadFile", formData)
            .subscribe(result => {
              this.modal.info("Upload complete",this.viewRef);      
              this.tableDataUpload = result.filter(x => x.NEW_LOCATION)
              this.correctData = this.tableDataUpload.filter(x => x.ERR_FLAG == 'N')
              this.isSave = false;
            }, err => {
              this.modal.error("Upload not complete", this.viewRef);
            })
  }

  public SaveByUpload (){

    this.modal.confirm("Do you want to save location master?",this.viewRef,() => ConfirmSave())


    let ConfirmSave = () =>{

      let data = {
        DETAIL : this.correctData
      }
  
      this.http.post("WH","SNWR004_SaveByUpload",data)
      .subscribe(res => {
          if (res.STATUS == 'DONE'){
            this.isSave = true
            this.modal.info("Save Relocation " + this.correctData.length + " records complete",this.viewRef)
          }else{
            this.modal.error('Found an error, please contact support team', this.viewRef);
          }
      },err => {
        this.modal.error('Found an error, please contact support team', this.viewRef);
      })

    }
   
  }

  public DownloadTemplate(){
    let link = "assets/templates/SNWR004_RELOCATION_TEMPLATE.xlsx"
    window.open(link,'_blank')
  }
}
