import { Component, ElementRef, OnInit, QueryList, ViewChildren, ViewContainerRef, ViewChild } from "@angular/core";
import * as moment from "moment";
import { Subject } from "rxjs";
import { debounceTime, delay, map, take } from "rxjs/operators";
import { Globals } from "src/app/core/global";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";
import { DialogTemplateComponent } from "src/app/components/shared/dialog-template/dialog-template.component";

@Component({
  selector: "SNWR016",
  templateUrl: "SNWR016.component.html",
})
export class SNWR016Component implements OnInit {
  constructor(
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private http: HttpService,
    private el: ElementRef,
    private global: Globals
  ) { }

  public params: any = {};
  public invoiceData: any = {};
  private currentDate: moment.Moment = moment();
  public tableDataPick: any = [];
  public tableDataPickByCust: any = [];


  public tablePickByCustInComplete: any = [];
  public tablePickingByCust: any = [];
  public tablePickingByPicker: any = [];

  public tableDataCheck: any = [];
  public tableDataInvoice: any = [];
  public tableDataDetail: any = [];
  public iSelectTab: number = 0;
  public iShowBy: number = 0;
  public tabIndex: number = 0;

  public dataDetail1: any = [];
  public dataDetail2: any = [];
  public dataDetail3: any = [];
  public dataDetail4: any = [];
  public invoiceDetail: any = [];
  public sumPick: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY_BAL',
      show: true,
    },
  ];
  public sumPack: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
  ];
  public sumInv: any[] = [
    {
      fieldName: 'PART_NAME',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'ITEM_QTY',
      show: true,
    },
    {
      fieldName: 'NET_AMT_B',
      show: true,
    },
  ];

  @ViewChild("dialogPickDetail", { static: false }) dialogPickDetail: any;
  @ViewChild("dialogPackDetail", { static: false }) dialogPackDetail: any;
  @ViewChild("InvoiceDialog") InvoiceDialog: DialogTemplateComponent;

  ngOnInit() {
    this.params.SEARCH_TYPE = '1';

    this.params.START_DATE = this.currentDate;
    this.params.END_DATE = this.currentDate;

    this.iSelectTab = 0;
    this.iShowBy = 1;

    this.Search();
  }

  public lookupPickingListNoConfig: any = {
    ColName: "PICKING_LIST_NO",
    PlaceholderText: "Select Picking List No.",
    SourceController: "WH",
    SourceMethodName: "SNWR016_getPickListNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedPickingListNo(value: any) {
    this.params.PICKING_LIST_NO = value.PICKING_LIST_NO;
  }


  public Search() {

    if (this.iSelectTab == 0) {

      this.http.post('WH', 'SNWR016_GetPickByCustInComplete', this.params)
        .subscribe(res => {
          this.tablePickByCustInComplete = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })

    } else if (this.iSelectTab == 1) {

      this.http.post('WH', 'SNWR016_GetPickByCustPicking', this.params)
        .subscribe(res => {
          this.tablePickingByCust = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })

      this.http.post('WH', 'SNWR016_GetPickOnPicking', this.params)
        .subscribe(res => {
          this.tablePickingByPicker = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })


    } else if (this.iSelectTab == 2) {

      this.http.post('WH', 'SNWR016_GetPickByCustComplete', this.params)
        .subscribe(res => {
          this.tableDataPickByCust = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })

      this.http.post('WH', 'SNWR016_GetPickComplete', this.params)
        .subscribe(res => {
          this.tableDataPick = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })

    } else if (this.iSelectTab == 3) {

      this.GetPack();




    } else if (this.iSelectTab == 4) {
      this.http.post('WH', 'SNWR016_GetDataInvoice', this.params)
        .subscribe(res => {
          this.tableDataInvoice = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })
    } else if (this.iSelectTab == 4) {



    } else if (this.iSelectTab == 5) {

    }



  }


  public ViewBy1(i) {
    this.iShowBy = i;
    // this.Search();
  }

  public tabClick(tab: any) {

    this.iSelectTab = tab;
    this.Search();

  }



  public TabChange($event): void {
    //this.params = {};


  }


  public GetPack(): void {
    //this.InitialProcess();
    this.http.post("WH", "SNWR016_GetDataPack", this.params).subscribe(
      (res) => {
        this.dataDetail1 = res.Table;
      },
      (err) => {
        console.log(err);
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
      }
    );
  }




  public ViewDetail(data: any) {
    this.params.DSP_PICKING_LIST_NO = data.PICKING_LIST_NO;
    this.tableDataDetail = [];
    this.http.post('WH', 'SNWR016_GetDataDetail', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.dialogPickDetail.OpenDialog();

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ViewDetailByCust(data: any) {

    this.tableDataDetail = [];
    this.http.post('WH', 'SNWR016_GetDataDetailByCust', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.dialogPickDetail.OpenDialog();

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ViewDetailByPicker(data: any) {

    this.tableDataDetail = [];
    this.http.post('WH', 'SNWR016_GetDataDetailByPicker', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.dialogPickDetail.OpenDialog();

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ViewDetailPacked(data: any) {

    this.tableDataDetail = [];
    this.http.post('WH', 'SNWR016_GetPackedDetail', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.dialogPackDetail.OpenDialog();

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ViewInvoice(data: any) {

    this.InvoiceDialog.OpenDialog();
    this.invoiceData = data;

    this.http.post("WH", "SNWR023_GetInvoiceDetail", this.invoiceData).subscribe(
      (res) => {
        this.invoiceDetail = res.Table;
      },
      (err) => {
        console.log(err);
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
      }
    );
  }


  Close() {
    this.dialogPickDetail.Close();
  }


  ClosePack() {
    this.dialogPackDetail.Close();
  }
}
