import { Component, ElementRef, OnInit, ViewContainerRef} from "@angular/core";
import { Globals } from "src/app/core/global";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";

@Component({
  selector: "SNWR018",
  templateUrl: "SNWR018.component.html",
})
export class SNWR018Component implements OnInit {
  constructor(
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private http: HttpService,
    private el: ElementRef,
    private global: Globals
  ) { }

  public params: any = {};

  ngOnInit() {
  }

  public lookupInvoiceNoConfig: any = {
    ColName: "LOOKUP_INVOICE_NO",
    PlaceholderText: "Select Invoice No.",
    SourceController: "WH",
    SourceMethodName: "SNWR018_getInvoicetNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedInvoiceNo(value: any) {
    this.params.INVOICE_NO = value.INVOICE_NO;
  }

  public ConfirmSave() {
    if (this.params.INVOICE_NO) {
      this.modal.confirm('Are you sure to confirm invoice ship out time?', this.viewRef
        , () => {
          this.http.post("WH", "SNWR018_UpdateInvoiceTime", this.params)
            .subscribe(result => {
              console.log(result)
              if (result.STATUS == 'DONE') {
                this.modal.info("Update Invoice Time Completed!", this.viewRef)
                this.params.INVOICE_NO = null;
              }
            }, err => {
              console.log(err)
              this.modal.error((err.error).substring(11), this.viewRef);
            })
        }, () => { })
    } else {
      this.modal.error("Please fill Invoice No.!!!", this.viewRef);
    }
  }
}
