import { Component, OnInit, ViewContainerRef } from "@angular/core";
import { Globals } from "src/app/core/global";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";

@Component({
  selector: "SNWR019_A",
  templateUrl: "SNWR019_A.component.html",
})
export class SNWR019_AComponent implements OnInit {
  constructor(
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private http: HttpService,
    private global: Globals
  ) {}

  public paramSearch: any = {};
  public dataConfirmStock: any = {};
  public tableHeader: any = [];
  public isSavePage: boolean = false;
  public checkType: any = [
    { ID: 1, TYPE: "CHECK_STOCK", DESC: "Check stock" },
    // {ID: 2, TYPE: "CYCLE_COUNT", DESC: "Cycle count"},
  ];
  public hideColumns: string[] = [
    "DELETE",
    "MESSAGE",
    "UNPACK_QTY",
    "SHELVE_QTY",
    "PL_QTY",
    "N3_QTY",
    "N2_QTY",
    "N1_QTY",
    "N_QTY",
  ];

  public dataPreview: any = [];

  public ngOnInit() {
    this.Search();
  }

  public Search() {
    this.http
      .post("WH", "SNWR019_A_GetData", this.paramSearch)
      .subscribe((res) => {
        this.tableHeader = res.Table;
      });
  }

  public IsConfirmPage(data: any) {
    this.dataPreview = [];
    this.GetDataByID(data);
    this.dataConfirmStock = data;
    this.isSavePage = !this.isSavePage;
  }

  public GetDataByID(data) {
    this.http
      .get("WH", "SNWR019_GetData_ByID", data.HEADER_ID)
      .subscribe((res) => {
        this.dataPreview = res.Table;
      });
  }

  public Back() {
    this.isSavePage = !this.isSavePage;
  }

  //Check Part QTY
  public SubmitAdd() {
    if (this.dataPreview.length > 0 && this.dataConfirmStock.HEADER_ID) {
      this.modal.confirm(
        "Do you want to save change you have made?",
        this.viewRef,
        this.ConfirmSubmit
      );
    } else {
      this.modal.warning(
        "Don't have data for submit, please try again.",
        this.viewRef
      );
    }
  }

  public ConfirmSubmit = () => {
    var headerId = this.dataConfirmStock.HEADER_ID;
    this.http
      .post("WH", ["SNWR019_CONFIRM", headerId], this.dataPreview)
      .subscribe(
        (res) => {
          if (res == "Done") {
            this.modal.info(
              "Transaction complete: applied and saved.",
              this.viewRef
            );
            this.Search();
            this.Back();
          } else {
            this.modal.error(
              "No change to save. Something went wrong.",
              this.viewRef
            );
          }
        },
        (err) => {
          this.modal.warning(
            "Found an error, please contract support team",
            this.viewRef
          );
        }
      );
  };

  public PrintCountReport() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR019_COUNT", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_ID: this.dataConfirmStock.HEADER_ID,
      P_SHOW_ALL: "N",
    });
  }
}
