using System;
using System.Net;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Hosting;
using Newtonsoft.Json;
using System.Net;
using System.Text;

namespace PMS.Controllers
{
  [Route("service/Report")]
  public class ReportController : Controller
  {
    private IConfiguration _conf;
    private IHostEnvironment _env;
    public ReportController(IConfiguration configuration, IHostEnvironment env)
    {
      _conf = configuration;
      _env = env;
    }

    [HttpPost("[action]/{reportName}")]
    public IActionResult ExportReport(string reportName, [FromBody] dynamic pReport)
    {

      dynamic report = JsonConvert.DeserializeObject<dynamic>(pReport.ToString());

      string url = report.url;
      string fileName = String.Concat(report.fileName ?? reportName, ".", report.fileExtension);

      NetworkCredential credential = new NetworkCredential(_conf["SSRSUser"].ToString(), _conf["SSRSPassword"].ToString(), _conf["SSRSIP"].ToString());
      CredentialCache credentialCache = new CredentialCache();
      string[] ssrsUrls = _conf["SSRSUrl"].ToString().Split(',');
      foreach(string ssrsUrl in ssrsUrls){
        credentialCache.Add(new Uri(url), "NTLM", credential);
      }

      using (WebClient client = new WebClient())
      {
        client.Credentials = credentialCache;
        client.Headers.Add("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; .NET CLR 1.0.3705;)");

        byte[] data = client.DownloadData(url);
        System.IO.MemoryStream content = new System.IO.MemoryStream(data);

        return File(content, report.fileType.ToString(), fileName);

      }
      
    }
  }
}
